/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF = 1e18;

int n;
int a[MAXN];
llong dp[2][MAXN][2];
void solve()
{
    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = n ; j >= 0 ; --j)
        {
            for (int t = 0 ; t < 2 ; ++t)
            {
                dp[i & 1][j][t] = dp[(i + 1) & 1][j][t];
                if (j > 0 || t > 0)
                {
                    dp[i & 1][j][t] = std::max(dp[i & 1][j][t], dp[(i + 1) & 1][j - (t == 0)][t ^ 1] + (t == 0 ? -a[i] : a[i]));
                }
            }
        }

        for (int j = 2 ; j < n ; ++j)
        {
            assert(dp[i & 1][j][0] - dp[i & 1][j - 1][0] >= dp[i & 1][j + 1][0] - dp[i & 1][j][0]);
            assert(dp[i & 1][j][1] - dp[i & 1][j - 1][1] >= dp[i & 1][j + 1][1] - dp[i & 1][j][1]);
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << dp[1][i][0] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}