#include<bits/stdc++.h>
using namespace std;

const long long mod=1e9+7;

struct frac{
    long long p,q;

    inline friend frac operator + (frac fr,frac sc){
        return {(fr.p*sc.q+fr.q*sc.p)%mod,(fr.q*sc.q)%mod};
    }

    inline friend frac operator * (frac fr,frac sc){
        return {(fr.p*sc.p)%mod , (fr.q*sc.q)%mod};
    }
};

frac neg(frac x){
    return {(mod-x.p)%mod,x.q};
}

frac inv(frac x){
    return {x.q,x.p};
}

int n;
int pa,pb;

string s;

pair<frac,frac> e;

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a%mod;
    if(b==2)return (a*a)%mod;

    if(b%2==0)return power(power(a,b/2),2);
    return (power(power(a,b/2),2)*a)%mod;   
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>pa>>pb;
    cin>>s;

    frac zero={pa,pb};
    frac one={pb-pa,pb};

    if(s[0]=='0')e={{1,1},neg(inv(zero))};
    else e={{1,1},neg(inv(one))};
    
    for(int i=1;i<s.size();i++){
        frac curr;

        if(s[i]=='0')curr=zero;
        else curr=one;

        e.first=(e.first+curr+neg({1,1})) * inv(curr);
        e.second=e.second + neg(inv(curr));
    }

    e.second=neg(e.second);

    e.second = e.second*inv(e.first);
    
    cout<<( e.second.p * power(e.second.q,mod-2) )%mod<<"\n";



    return 0;
}