#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 5e5 + 10;
const ll INF = 1e18;

int n;
ll p[MAXN];

void input()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> p[i];
    }
}

ll res[MAXN];


int par[MAXN];
int left_child[MAXN], right_child[MAXN];

int root;
void build_cartesian()
{
    for (int i = 1; i <= n; i ++)
    {
        left_child[i] = right_child[i] = par[i] = -1;
    }
    stack < int > st;
    for (int i = 1; i <= n; i ++)
    {
        while(!st.empty() && p[st.top()] < p[i])
        {
            left_child[i] = st.top();
            st.pop();
        }
        if (left_child[i] != -1)
            par[left_child[i]] = i;
        st.push(i);
    }

    while(!st.empty())
        st.pop();
    for (int i = n; i > 0; i --)
    {
        while(!st.empty() && p[st.top()] <= p[i])
        {
            right_child[i] = st.top();
            st.pop();
        }
        if (right_child[i] != -1)
            par[right_child[i]] = i;
        st.push(i);
    }

    for (int i = 1; i <= n; i ++)
    {
        if (par[i] == -1)
            root = i;
    }

}

ll fp[MAXN][2];
/*
fp[v][t][k]
v - vertex
t - will have right sell

*/

int to[MAXN][2];

void dfs(int v)
{

    fp[v][1] = -INF;
    fp[v][0] = 0;

    to[v][1] = 0;
    to[v][0] = 0;

    if (left_child[v] != -1)
        dfs(left_child[v]);

    if (right_child[v] != -1)
        dfs(right_child[v]);


    /// no sell root and no right buy
    ll val = 0;
    if (right_child[v] != -1)
        val = fp[right_child[v]][0];

    if (val > fp[v][0])
    {
        to[v][0] = 1;
        fp[v][0] = val;
    }

    /// no sell root and right buy
    val = -p[v]; /// buy root
    if (left_child[v] != - 1)
        val = max(val, fp[left_child[v]][1]);
    if (right_child[v] != -1)
        val = max(val, fp[right_child[v]][1]);


    if (val > fp[v][1])
    {
        fp[v][1] = val;
        to[v][1] = 1;
    }

    /// sell and no right buy
    val = p[v];
    if (left_child[v] != -1)
        val = val + fp[left_child[v]][1];
    else
        val = - INF;
    if (right_child[v] != -1)
        val = val + fp[right_child[v]][0];

    if (val > fp[v][0])
    {
        fp[v][0] = val;
        to[v][0] = 2;
    }


    /// sell and right buy

    val = p[v];
    if (left_child[v] != -1)
        val = val + fp[left_child[v]][1];
    else
        val = - INF;

    if (right_child[v] != -1)
        val = val + fp[right_child[v]][1];
    else
        val = - INF;

    if (val > fp[v][1])
    {
        fp[v][1] = val;
        to[v][1] = 2;
    }

}

int buy_mark[MAXN], sell_mark[MAXN];
void traverse(int v, int s)
{
    if (s == 0)
    {
        if  (to[v][s] == 0)
            return;
        if (to[v][s] == 1)
        {
            if (right_child[v] != -1)
                traverse(right_child[v], s);
            return;
        }
        sell_mark[v] = 1;
        traverse(left_child[v], 1);
        if (right_child[v] != -1)
            traverse(right_child[v], 0);
        return;
    }
    else
    {
        if (to[v][s] == 0)
            return;

        if (to[v][s] == 1)
        {
            ll val = -p[v], t = 0; /// buy root
            if (left_child[v] != - 1)
            {
                if (fp[left_child[v]][1] > val)
                {
                    val = fp[left_child[v]][1];
                    t = 1;
                }
            }

            if (right_child[v] != -1)
            {
                if (fp[right_child[v]][1] > val)
                {
                    val = fp[right_child[v]][1];
                    t = 2;
                }
            }

            if (t == 0)
            {
                buy_mark[v] = 1;
                return;
            }

            if (t == 1)
            {
                traverse(left_child[v], 1);
                return;
            }

            if (t == 2)
            {
                traverse(right_child[v], 1);
                return;
            }
            return;
        }

        if (to[v][s] == 2)
        {
            sell_mark[v] = 1;
            traverse(left_child[v], 1);
            traverse(right_child[v], 1);
        }
        return;
    }
}
void solve_dp()
{
    /**for (int i = 0; i < 2; i ++)
        for (int j = 0; j <= n; j ++)
        dp[i][j] = -INF, from[i][j] = -1;

    for (int i = 0; i <= n; i ++)
        dp[i][0] = 0, from[i][0] = i - 1;

    /for (int i = 1; i <= n; i ++)
    {


        for (int j = 1; j <= n; j ++)
        {
            dp[i][j] = dp[i - 1][j];
            from[i][j] = i - 1;
            for (int k = 1; k < i; k ++)
            {
                ll s = dp[k][j - 1] + p[i] - p[k];
                if (s > dp[i][j])
                {
                    dp[i][j] = s;
                    from[i][j] = k;

                }
            }

        }
    }*/


    ///cout << fp[root][0] << endl;
    /**for (int i = 1; i <= n; i ++)
    {
        cout << buy_mark[i] << " ";
    }
    cout << endl;
    for (int i= 1; i <= n; i ++)
    {
        cout << sell_mark[i] << " ";
    }
    cout << endl;*/
    ll ans = -INF, best_k = 0;
    ans = fp[root][0];
    //cout << ans << endl;
    /**for (int k = 1; k <= n; k ++)
    {
        if (dp[n][k] > ans)
        {
            ans =dp[n][k];
            best_k = k;
        }

    }*/
    for (int i = 1; i <= n; i ++)
    {
        if (buy_mark[i] == 1)
            best_k ++;
    }
    //cout << best_k << endl;
    ///assert(fp[root][0] == ans);
    vector < pair < int, int > > ranges;
    pair < int, int > cur = {-1, -1};
    set < int > funny;

    set < pair < ll, int > > rem;
    for (int i = 1; i <= n; i ++)
    {
        if (buy_mark[i])
        {
            cur.first = i;
            if (!funny.empty())
            {
                pair < ll, int > cur;
                cur.second = *(funny.rbegin());
                cur.first = p[cur.second] - p[i];
                if (cur.first < 0)
                    cur.first = - cur.first;
                rem.insert(cur);
            }
            funny.insert(i);
        }
        if (sell_mark[i])
        {
            cur.second = i;
            ranges.push_back(cur);
            if (!funny.empty())
            {
                pair < ll, int > cur;
                cur.second = *(funny.rbegin());
                cur.first = p[cur.second] - p[i];
                if (cur.first < 0)
                    cur.first = - cur.first;
                rem.insert(cur);
            }
            funny.insert(i);
        }
    }
    /**int i = n, j = best_k;
    while(i > 0)
    {
        int b = from[i][j];
        if (dp[b][j] == dp[i][j])
        {
            i = b;
            continue;
        }

        ranges.push_back({b, i});
        i = b;
        j --;
    }


    reverse(ranges.begin(), ranges.end());*/
    int k = best_k;
    for (int j = k; j <= n; j ++)
        res[j] = ans;



    while(k > 1)
    {
        /**cout << "step " << endl;
        for (int x : funny)
            cout << x << " ";
        cout << endl;*/
        k --;
        pair < ll, int > cur = *(rem.begin());
        ///cout << cur.first << " " << cur.second << endl;
        ans -= cur.first;
        rem.erase(rem.find(cur));
        set < int > ::iterator it = funny.find(cur.second), hp = next(it);
        if (it != funny.begin())
        {
            pair < ll, int > temp;
            temp.second = *prev(it);
            temp.first = p[temp.second] - p[*it];
            if (temp.first < 0)
                temp.first = -temp.first;
            rem.erase(temp);
        }

        if (next(hp) != funny.end())
        {
            pair < ll, int > temp;
            temp.second = *hp;
            temp.first = p[temp.second] - p[*next(hp)];
            if (temp.first < 0)
                temp.first = - temp.first;
            rem.erase(temp);
        }

        if (it != funny.begin() && next(hp) != funny.end())
        {
            pair < ll, int > temp;
            temp.second = *prev(it);
            temp.first = p[*next(hp)] - p[*prev(it)];
            if (temp.first < 0)
                temp.first = - temp.first;
            rem.insert(temp);
        }

        int p1 = *it;
        int p2 = *hp;
        funny.erase(funny.find(p1));
        funny.erase(funny.find(p2));

        res[k] = ans;
    }
    /**while(k > 1)
    {
        k --;

        int best_rem = -1;
        ll loss_rem = INF;
        for (int i = 0; i < (int)(ranges.size()); i ++)
        {
            ll loss = p[ranges[i].second] - p[ranges[i].first];
            if (loss < loss_rem)
            {
                loss_rem = loss;
                best_rem = i;
            }
        }

        int best_merge = -1;
        ll loss_merge = INF;
        for (int i = 1; i < (int)(ranges.size()); i ++)
        {
            ll loss = p[ranges[i - 1].second] - p[ranges[i].first];
            if (loss < loss_merge)
            {
                loss_merge = loss;
                best_merge = i - 1;
            }
        }

        if (loss_rem < loss_merge)
        {
            ans -= loss_rem;
            ranges.erase(ranges.begin() + best_rem);
        }
        else
        {
            ans -= loss_merge;
            pair < int, int > rg = {ranges[best_merge].first, ranges[best_merge + 1].second};
            ranges.erase(ranges.begin() + best_merge);
            ranges.erase(ranges.begin() + best_merge);
            ranges.insert(ranges.begin() + best_merge, rg);
        }

        res[k] = ans;

    }*/

    for (int i = 1; i <= n; i ++)
        cout << res[i] << " ";
}
void solve()
{
    input();
    build_cartesian();
    dfs(root);
    traverse(root, 0);
    solve_dp();
}

int main()
{
    //speed();
    solve();
    return 0;
}
