#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2010;
const ll INF = 1e18;

int n;
ll p[MAXN];
ll dp[MAXN][MAXN];
int from[MAXN][MAXN];
void input()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> p[i];
    }
}

ll res[MAXN];

void solve_dp()
{
    for (int i = 0; i < 2; i ++)
        for (int j = 0; j <= n; j ++)
        dp[i][j] = -INF, from[i][j] = -1;

    for (int i = 0; i <= n; i ++)
        dp[i][0] = 0, from[i][0] = i - 1;

    for (int i = 1; i <= n; i ++)
    {


        for (int j = 1; j <= n; j ++)
        {
            dp[i][j] = dp[i - 1][j];
            from[i][j] = i - 1;
            for (int k = 1; k < i; k ++)
            {
                ll s = dp[k][j - 1] + p[i] - p[k];
                if (s > dp[i][j])
                {
                    dp[i][j] = s;
                    from[i][j] = k;

                }
            }

        }
    }

    ll ans = -INF, best_k = -1;
    for (int k = 1; k <= n; k ++)
    {
        if (dp[n][k] > ans)
        {
            ans =dp[n][k];
            best_k = k;
        }
    }

    vector < pair < int, int > > ranges;
    int i = n, j = best_k;
    while(i > 0)
    {
        int b = from[i][j];
        if (dp[b][j] == dp[i][j])
        {
            i = b;
            continue;
        }

        ranges.push_back({b, i});
        i = b;
        j --;
    }


    reverse(ranges.begin(), ranges.end());
    int k = best_k;
    for (int j = k; j <= n; j ++)
        res[j] = ans;


    while(k > 1)
    {
        k --;

        int best_rem = -1;
        ll loss_rem = INF;
        for (int i = 0; i < (int)(ranges.size()); i ++)
        {
            ll loss = p[ranges[i].second] - p[ranges[i].first];
            if (loss < loss_rem)
            {
                loss_rem = loss;
                best_rem = i;
            }
        }

        int best_merge = -1;
        ll loss_merge = INF;
        for (int i = 1; i < (int)(ranges.size()); i ++)
        {
            ll loss = p[ranges[i - 1].second] - p[ranges[i].first];
            if (loss < loss_merge)
            {
                loss_merge = loss;
                best_merge = i - 1;
            }
        }

        if (loss_rem < loss_merge)
        {
            ans -= loss_rem;
            ranges.erase(ranges.begin() + best_rem);
        }
        else
        {
            ans -= loss_merge;
            pair < int, int > rg = {ranges[best_merge].first, ranges[best_merge + 1].second};
            ranges.erase(ranges.begin() + best_merge);
            ranges.erase(ranges.begin() + best_merge);
            ranges.insert(ranges.begin() + best_merge, rg);
        }

        res[k] = ans;

        /**cout << "------------------" << endl;
        for (pair < int, int > cur : ranges)
            cout << cur.first <<  " " << cur.second << endl;*/
    }

    for (int i = 1; i <= n; i ++)
        cout << res[i] << " ";
}
void solve()
{
    input();
    solve_dp();
}

int main()
{
    speed();
    solve();
    return 0;
}
