#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;

vector<bool> cod;
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){

    int br=log2(n)+1;
    //cout<<br<<endl;
    cod.resize(2*edges.size()*br);
    int k=0;
    for(int i=0;i<edges.size();i++){

        int a=edges[i].first;
        for(int j=k;j<k+br;j++){
            cod[j]=a%2;
            a/=2;
        }
        k+=br;
        a=edges[i].second;
        for(int j=k;j<k+br;j++){
            cod[j]=a%2;
            a/=2;
        }
        k+=br;

    }

    return cod;
}

vector<pair<int,int> > ans;
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    int br=log2(n)+1;
    int k=0;
    while(k<data.size()){
        int a=0,b=0;
        int step=1;
        for(int i=k;i<k+br;i++){
            a+=data[i]*step;
            step*=2;
        }
        k+=br;
        step=1;
        for(int i=k;i<k+br;i++){
            b+=data[i]*step;
            step*=2;
        }
        k+=br;
        if(a==0 && b==0){
            break;
        }
        ans.push_back({a,b});
    }

    return ans;
}
