#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn = 20000;


void code(int val, vector < bool > & ans)
{
    int st = 1;
    for (int i = 0; i <= 15; ++ i)
    {
        if(st & val)ans.push_back(1);
        else ans.push_back(0);
        st *= 2;
    }

}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector < bool > ans;
    vector < int > g[n+1];
    for (int i = 0; i < n; ++ i)
        g[i].clear();
    for (auto &[x, y]: edges)
    {
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++ i)
    {
        //cout << i << " ";
        code(g[i].size(), ans);
        for (auto nb: g[i])
        {
            code(nb, ans);
            //cout << nb << " ";
        }
    }
    int sz = ans.size();
    assert(sz == edges.size() * 16 + n * 16);
    //cout << endl;
    return ans;
}

vector < bool > get_data(int i, vector < bool > &info)
{
    //assert(i + 15 < info.size());

    vector < bool > curr;

    for (int j = i; j <= i + 15; ++ j)
    {
        curr.push_back(info[j]);

    }
    //cout << curr.size() << endl;
    return curr;
}
int findval(vector < bool >&curr)
{
    int val = 0;
    long long st = 1;
   // assert(curr.size() == 16);
    for (auto bit: curr)
    {
        if(bit)val += st;
        st *= 2;
    }
    return val;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector < pair < int, int > > res;

    vector < bool > info = data;
   /* for (auto x: info)
        cout << x << " ";
    cout << endl;*/
    int id = 0;
    for (int i = 0; i < n; ++ i)
    {
        vector < bool > curr;
        curr = get_data(id, info);
        id += 16;
        int sz = findval(curr);
       // cout << i << " " << sz << endl;
        for (int cnt = 1; cnt <= sz; ++ cnt)
        {
            vector < bool > nb = get_data(id, info);
            id += 16;
            int nn = findval(nb);
            res.push_back(make_pair(i, nn));
            //cout << i << " " << nn << endl;
        }
    }
   // assert(res.size() > n-1);
    return res;
}
