#include<bits/stdc++.h>
#include "cactus.h"
#define MAXN 16010
using namespace std;
int p[MAXN];
int cyc[MAXN];
int used[MAXN];
vector<int> edge[MAXN];
void dfs(int curr, int parent)
{
    used[curr]=used[parent]+1;
    p[curr]=parent;
    for(int i=0;i<edge[curr].size();i++)
    {
        int now=edge[curr][i];
        if(now==parent)continue;
        if(used[now]!=0)
        {
            if(used[now]<used[curr])cyc[curr]=used[curr]-used[now];
            continue;
        }
        dfs(now,curr);
    }
}
vector<bool> bin(int n, int buck)
{
    vector<bool> ret;
    while(n>0)
    {
        ret.push_back(n&1);
        n>>=1;
    }
    while(ret.size()<buck)ret.push_back(0);
    reverse(ret.begin(),ret.end());
    return ret;
}
int convert(vector<bool> a)
{
    int num=0;
    for(int i=0;i<a.size();i++)
    {
        if(a[i])num+=(1<<(a.size()-i-1));
    }
    return num;
}
vector<bool> encode(int n, vector<pair<int,int>> edges)
{
    int buck=24;//limit to 15
    /*for(int i=0;i<edges.size();i++)
    {
        if(edges[i].first>edges[i].second)swap(edges[i].first,edges[i].second);
    }
    sort(edges.begin(),edges.end());*/
    for(int i=0;i<n;i++){edge[i].clear();used[i]=0;cyc[i]=0;}
    for(int i=0;i<edges.size();i++)
    {
        int u=edges[i].first,v=edges[i].second;
        edge[u].push_back(v);
        edge[v].push_back(u);
    }
    dfs(0,MAXN);
    vector<bool> res;
    for(int i=0;i<n;i++)
    {
        //cout<<i<<": "<<p[i]<<" "<<cyc[i]<<"\n";

        vector<bool> v1=bin(p[i],14);
        vector<bool> v2=bin(cyc[i],10);
        for(int j=0;j<v1.size();j++)res.push_back(v1[j]);
        for(int j=0;j<v2.size();j++)res.push_back(v2[j]);
    }
    return res;
}
vector<pair<int,int>> decode(int n, vector<bool> data)
{
    vector<pair<int,int>> ans;
    int buck=24,half=14,ind=0;
    for(int i=0;i<data.size();i+=buck)
    {
        vector<bool> vec1;
        for(int j=i;j<i+half;j++)vec1.push_back(data[j]);
        p[ind]=convert(vec1);
        if(p[ind]<MAXN)ans.push_back({p[ind],ind});
        //cout<<ind<<" "<<p[ind]<<"B\n";
        //if(cyc[ind]<MAXN)ans.push_back({ind,cyc[ind]});

        ind++;
    }
    ind=0;
    for(int i=0;i<data.size();i+=buck)
    {
        vector<bool> vec2;
        for(int j=i+half;j<i+buck;j++)vec2.push_back(data[j]);
        cyc[ind]=convert(vec2);
        //cout<<ind<<" "<<cyc[ind]<<"C\n";
        if(cyc[ind]>0)
        {
            int ver=ind;
            for(int cntr=0;cntr<cyc[ind];cntr++)ver=p[ver];
            ans.push_back({ind,ver});
        }
        ind++;
    }
    return ans;
}