#include<bits/stdc++.h>
#define MAXN 2010
using namespace std;
long long a[MAXN];
long long dp[MAXN][MAXN];
int tab[MAXN][32];
void build(int n)
{
    for(int i=1;i<=n;i++)tab[i][0]=i;
    for(int j=1;(1<<j)<=n;j++)
    {
        for(int i=1;i<=n;i++)
        {
            if(a[tab[i][j-1]]>a[tab[i+(1<<(j-1))][j-1]])tab[i][j]=tab[i][j-1];
            else tab[i][j]=tab[i+(1<<(j-1))][j-1];
        }
    }
}
int query(int l, int r)
{
    int logx=log2(r-l+1);
    if(a[tab[l][logx]]>a[tab[r-(1<<logx)+1][logx]])return tab[l][logx];
    return tab[r-(1<<logx)+1][logx];
}
long long cost(int l, int r)
{
    if(l==r)return 0;
    r=query(l+1,r);
    return a[r]-a[l];
}
void calc(int l, int r, int optl, int optr, int k)
{
    if(l>r)return;
    int mid=(l+r)>>1;
    pair<long long, pair<int,int>> best={0,{optl,min(mid,optr)}};
    for(int i=optl;i<=min(mid,optr);i++)
    {
        long long val=cost(i,min(mid,optr));
        if(best.first<dp[i-1][k-1]+val)
        {
            best={dp[i-1][k-1]+val,{i,query(i,min(mid,optr))}};
        }
    }
    //cout<<l<<" "<<r<<" "<<optl<<" "<<optr<<" "<<best.first<<"A\n";
    dp[mid][k]=best.first;
    int opt=best.second.first;//?
    int opt2=best.second.second;//?
    if(l==r)return;
    calc(l,mid,optl,opt2,k);
    calc(mid+1,r,opt,optr,k);//mid+1?
}
int main()
{
    int n;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    build(n);
    long long prev=0,ans=0;
    for(int k=1;k<=n;k++)
    {
        calc(1,n,1,n,k);
        ans=dp[n][k];
        cout<<ans<<" ";
        if(ans==prev)
        {
            for(int i=k+1;i<=n;i++)cout<<ans<<" ";
            break;
        }
        prev=ans;
    }
    cout<<"\n";
}