#include <iostream>
#include <algorithm>
#include "cactus.h"
#include <vector>
using namespace std;
bool el(pair<int,int> a,pair<int,int> b){
    if(a.first==b.first){
        return a.second<b.second;
    }
    return a.first<b.first;
}
int power;
vector<bool> transformtobinary(int a){
    vector<bool> c;
    int b=(1<<power-1);
    while(b>0){
        if(a>=b){
            c.push_back(1);
            a-=b;
        }else c.push_back(0);
        b=b>>1;
    }
    return c;
}
void stepen(int a){
    int b=13;
    while(a<(1<<b)){
        b--;
    }
    power=b+1;
    //cout<<"power = "<<power;
}
vector<bool> encode(int n, vector<pair<int, int>> edges){
    stepen(n);
    vector<bool> s;
    for(int i=0;i<edges.size();i++){
        if(edges[i].first>edges[i].second){
            swap(edges[i].first,edges[i].second);
        }
    }
    sort(edges.begin(),edges.end(),el);
    /*long long ind = 0;
    for(int i=0;i<n;i++){
        for(int j=i+1;j<n;j++){
            if(edges[ind].first==i and edges[ind].second==j){
                s.push_back(1);
                ind++;
            }
            else s.push_back(0);
        }
    }*/
    vector<bool> curr;
    int last1=0,last2=0;
    for(auto p:edges){
        if(p.first!=last1){
            curr = transformtobinary(p.first);
            s.push_back(1);
            for(int i=0;i<power;i++){
                s.push_back(curr[i]);
                //cout<<curr[i];
            }
            last1=p.first;
        }
        curr = transformtobinary(p.second);
        //cout<<" ";
        s.push_back(0);
        for(int i=0;i<power;i++){
            s.push_back(curr[i]);
            //cout<<curr[i];
        }
        //cout<<"\n";
    }
    return s;
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    stepen(n);
    vector<pair<int, int>> edges;
    int b = (1<<(power-1));
    int a,c;
    int ind = 0;
    int currv = 0;
    int lastv = 0;
    bool nach;
    while(ind<data.size()){
        b = (1<<(power-1)); a=0;
        nach = false;
        if(data[ind]==1) nach=true;
        ind++;
        for(int i=0;i<power;i++){
            if(data[ind+i]==1){
                a+=b;
            }
            b=(b>>1);
        }
        ind+=power;
        if(nach){
            lastv=a;
            currv=a;
        }else{
            //cout<<"add-vam "<<currv<<" "<<a<<"\n";
            edges.push_back({currv,a});
            lastv=a;
        }

        /*b=(1<<power-1);
        for(int i=0;i<power;i++){
            if(data[ind+i]==1){
                c+=b;
            }
            b=(b>>1);
        }
        ind+=power;*/
        //edges.push_back({a,c});
    }
    return edges;
}
