#include <iostream>
#include <algorithm>
#include "cactus.h"
#include <vector>
using namespace std;
bool el(pair<int,int> a,pair<int,int> b){
    if(a.first==b.first){
        return a.second<b.second;
    }
    return a.first<b.first;
}
vector<bool> transformtobinary1(int a){
    vector<bool> c;
    int b=(1<<3);
    while(b>0){
        if(a>=b){
            c.push_back(1);
            a-=b;
        }else c.push_back(0);
        b=b>>1;
    }
    return c;
}
int brcifri(int a){
    //cout<<a<<" ima ";
    int s=0;
    while(a>0){
        s++;
        a=(a>>1);
    }
    //cout<<s<<" cifri\n";
    return s;
}
vector<bool> transformtobinary(int a){
    vector<bool> c;
    vector<bool> d;
    int b=(1<<13);
    bool fl=false;
    while(b>0){
        if(a>=b){
            if(!fl){
                d=transformtobinary1(brcifri(b));
                for(auto p:d) c.push_back(p);
                fl=true;
            }
            c.push_back(1);
            a-=b;
        }else if(fl){
            c.push_back(0);
        }
        b=b>>1;
    }
    return c;
}
vector<bool> encode(int n, vector<pair<int, int>> edges){
    vector<bool> s;
    for(int i=0;i<edges.size();i++){
        if(edges[i].first>edges[i].second){
            swap(edges[i].first,edges[i].second);
        }
    }
    sort(edges.begin(),edges.end(),el);
    vector<bool> curr;
    int last1=0,last2=0;
    for(auto p:edges){
        if(p.first!=last1){
            curr = transformtobinary(p.first);
            s.push_back(1);
            for(int i=0;i<curr.size();i++){
                s.push_back(curr[i]);
                //cout<<curr[i];
            }
            last1=p.first;
        }
        curr = transformtobinary(p.second);
        //cout<<" ";
        s.push_back(0);
        for(int i=0;i<curr.size();i++){
            s.push_back(curr[i]);
            //cout<<curr[i];
        }
        //cout<<"\n";
    }
    return s;
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    vector<pair<int, int>> edges;
    int b = (1<<13);
    int a,c;
    int ind = 0;
    int currv = 0;
    int lastv = 0;
    bool nach;
    while(ind<data.size()){
        b = (1<<3); a=0; c=0;
        nach = false;
        if(data[ind]==1) nach=true;
        ind++;
        for(int i=0;i<4;i++){
            if(data[ind+i]==1){
                c+=b;
            }
            b=(b>>1);
        }
        ind+=4;
        b= (1<<(c-1));
        for(int i=0;i<c;i++){
            if(data[ind+i]==1){
                a+=b;
            }
            b=(b>>1);
        }
        ind+=c;
        if(nach){
            lastv=a;
            currv=a;
        }else{
            //cout<<"add-vam "<<currv<<" "<<a<<"\n";
            edges.push_back({currv,a});
            lastv=a;
        }

        /*b=(1<<13);
        for(int i=0;i<14;i++){
            if(data[ind+i]==1){
                c+=b;
            }
            b=(b>>1);
        }
        ind+=14;*/
        //edges.push_back({a,c});
    }
    return edges;
}
