#include "cactus.h"
#include<bits//stdc++.h>
using namespace std;

vector<bool> encode(int n, vector<pair<int, int>> edges){
        vector<bool> script;
        long long step=0,now=1;
        while(now<=n){
            step++;
            now*=2;
        }
        step--;

        for(int i=0;i<edges.size();i++){
            int vOt=edges[i].first,vDo=edges[i].second;

            vector<bool> dvoi,clr;
            while(vOt>0){
                dvoi.push_back(vOt%2);
                vOt/=2;
            }
            while(dvoi.size()<step)dvoi.push_back(0);
            for(int j=0;j<step;j++)script.push_back(dvoi[j]);

            dvoi=clr;
            while(vDo>0){
                dvoi.push_back(vDo%2);
                vDo/=2;
            }
            while(dvoi.size()<step)dvoi.push_back(0);
            for(int j=0;j<step;j++)script.push_back(dvoi[j]);
        }

        return script;
}


vector<pair<int, int>> decode(int n, vector<bool> data){
    vector<pair<int, int>> edges;
    long long step=0,now=1;
    while(now<=n){
        step++;
        now*=2;
    }
    step--;

    for(int j=0;j<data.size();j+=(2*step)){
        int numOne=0,numTwo=0,dv=1;
        for(int i=j;i<j+step;i++){
            if(data[i]==1)numOne+=dv;
            dv*=2;
        }

        dv=1;
        for(int i=j+step;i<j+2*step;i++){
            if(data[i]==1)numTwo+=dv;
            dv*=2;
        }

        edges.push_back({numOne,numTwo});
    }

    return edges;
}
