#include<iostream>
#include<algorithm>
#include "cactus.h"
using namespace std;
const int bucket=130;
int st[1005];
bool cmp(pair<int,int> a, pair<int,int> b)
{
    if((a.first/bucket)==(b.first/bucket))
        return a.second<b.second;

    return ((a.first/bucket)<(b.first/bucket));
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<bool> rez;

    sort(edges.begin(),edges.end(),cmp);

    int l=0,r=0;
    for(int i=0;i<edges.size();i++)
    {
        rez.push_back(1);
        rez.push_back(0);

        if(r<edges[i].second)
        {
            rez.resize(rez.size()+edges[i].second-r,1);
            r=edges[i].second;
        }
        if(r>edges[i].second)
        {
            rez.resize(rez.size()+r-edges[i].second,0);
            r=edges[i].second;
        }
        rez.push_back(1);
        rez.push_back(0);

        while(l<edges[i].first)
        {
            rez.resize(rez.size()+edges[i].first-l,1);
            l=edges[i].first;
        }
        while(l>edges[i].first)
        {
            rez.resize(rez.size()+l-edges[i].first,0);
            l=edges[i].first;
        }
    }
    return rez;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int, int> > rez;

    int l=0,r=0,j;
    bool isright=0;

    for(int i=0;i<data.size();i++)
    {
        if(i<data.size()-1 && data[i+1]==0 && data[i]==1)
        {
            i+=2;
            isright=!isright;

            for(j=i;j<data.size();j++)
            {
                if(j<data.size()-1 && data[j+1]==0 && data[j]==1) {j--;break;}

                if(isright)
                {
                    if(data[j]==1)
                        r++;
                    else
                        r--;
                }
                else
                {
                    if(data[j]==1)
                        l++;
                    else
                        l--;
                }
            }
            i=j;
            if(!isright){
            rez.push_back({l,r});
           // cout<<l<<" "<<r<<endl;
            }

        }
    }
    return rez;
}

