#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn=16005;
vector<pair<int,int>> g[maxn];
vector<int> tourA;
vector<bool> used;
int br[maxn];
void tour(int vr)
{
    // cout<<vr<<endl;
    stack<pair<int,int>> st;
    st.push({vr,-1});
    bool t=0;
    while(!st.empty())
    {
        vr=st.top().first;
        int parent =st.top().second;
        if(br[vr]==g[vr].size())
        {
            if(!t) tourA.push_back(vr);
            t=1;
            if(tourA[tourA.size()-1]!=16383)tourA.push_back(16383);
            st.pop();
            continue;
        }
        
        if(g[vr][br[vr]].first==parent){br[vr]++;continue;}
        tourA.push_back(vr);
        if(!used[g[vr][br[vr]].second])
        {
            t=0;
            used[g[vr][br[vr]].second]=1;
            st.push({g[vr][br[vr]].first,vr});
            br[vr]++;
        }
    }    
}
vector<bool> toBin(int a)
{
    vector<bool> ret;
    while(a)
    {
        ret.push_back(a%2);
        a/=2;
    }
    reverse(ret.begin(),ret.end());
    return ret;
}
vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    for(int i=0;i<n;i++)
    {
        g[i].clear();
    }
    tourA.clear();  
    for(int i=0;i<edges.size();i++)
    {
        if(i<used.size())used[i]=0;
        else used.push_back(0);
        g[edges[i].first].push_back({edges[i].second,i});
        g[edges[i].second].push_back({edges[i].first,i});
    }  
    tour(0);
    vector<bool> ans;
    for(int i=1;i<tourA.size();i++)
    {
        // cout<<tourA[i]<<" ";
        int base=1<<13;
        for(int j=0;j<14;j++)
        {
            ans.push_back(base&tourA[i]);
            base/=2;
        }
    }
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int,int>> ans;
    int a=0,b=0;
    int base = 1<<13;
    int i=0;
    for(;i<data.size();)
    {
        int base = 1<<13;
        for(int j=0;j<14;j++,i++)
        {
            // cout<<data[i];
            b+=base*data[i];
            base=base>>1;
        }
        // cout<<endl;
        if(a!=16383&&b!=16383)ans.push_back({a,b});
        a=b;
        b=0;
    }
    // for(int i=0;i<ans.size();i++)
    // {
    //     cout<<ans[i].first<<" "<<ans[i].second<<endl;
    // }
    return ans;
}