#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn=16005;
vector<int> g[maxn];
vector<int> tourA;
map<pair<int,int>,int> used;
void tour(int vr, int parent)
{
    // cout<<vr<<endl;
    if(parent!=-1)tourA.push_back(vr);  bool t=0;
    for(int i=0;i<g[vr].size();i++)
    {
      
        if(g[vr][i]==parent)continue;
        if(!used[{vr,g[vr][i]}]&&!used[{g[vr][i],vr}])
        {
            // cout<<t<<endl;
            if(t){tourA.push_back(vr);t=0;}
            used[{vr,g[vr][i]}]=1;
            tour(g[vr][i],vr);
            t=1;
        }
    }
    if(tourA[tourA.size()-1]!=16383)tourA.push_back(16383);
}
vector<bool> toBin(int a)
{
    vector<bool> ret;
    while(a)
    {
        ret.push_back(a%2);
        a/=2;
    }
    reverse(ret.begin(),ret.end());
    return ret;
}
vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    for(int i=0;i<n;i++)
    {
        g[i].clear();
    }
    used.clear();
    tourA.clear();  
    for(int i=0;i<edges.size();i++)
    {
        g[edges[i].first].push_back(edges[i].second);
        g[edges[i].second].push_back(edges[i].first);
    }  
    tour(0,-1);
    vector<bool> ans;
    for(int i=0;i<tourA.size();i++)
    {
        // cout<<tourA[i]<<" ";
        int base=1<<13;
        for(int j=0;j<14;j++)
        {
            ans.push_back(base&tourA[i]);
            base/=2;
        }
    }
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int,int>> ans;
    int a=0,b=0;
    int base = 1<<13;
    int i=0;
    for(;i<data.size();)
    {
        int base = 1<<13;
        for(int j=0;j<14;j++,i++)
        {
            // cout<<data[i];
            b+=base*data[i];
            base=base>>1;
        }
        // cout<<endl;
        if(a!=16383&&b!=16383)ans.push_back({a,b});
        a=b;
        b=0;
    }
    // for(int i=0;i<ans.size();i++)
    // {
    //     cout<<ans[i].first<<" "<<ans[i].second<<endl;
    // }
    return ans;
}