#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 3e3;
const int64_t INF = 1e14;

int n;
int64_t dp[MAXN][MAXN][2];
int64_t p[MAXN];

int64_t solve(int n, int k, int pos, bool isHolding)
{
    if (pos == n)
    {
        return ((k == 0)?0:-INF);
    }

    if (dp[pos][k][isHolding] != -1)
    {
        return dp[pos][k][isHolding];
    }


    int64_t ans = solve(n, k, pos+1, isHolding);
    if (isHolding)
    {
        ans = max(ans, solve(n, k, pos+1, false)+p[pos]);
    }

    else if (isHolding == false && k > 0)
    {
        ans = max(ans, solve(n, k-1, pos+1, true)-p[pos]);
    }

    dp[pos][k][isHolding] = ans;
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dp, -1, sizeof(dp));

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> p[i];
    }


    int64_t ans = -INF;

    for (int k = 1; k <= n; k++)
    {
        ans = max(ans, solve(n, k, 0, 0));
        cout << ans << " ";
    }

    cout << endl;

    return 0;
}
