#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 3e3;
const int64_t INF = 1e14;

int n;
int64_t dp[MAXN][MAXN][2];
int64_t p[MAXN];

int64_t solve(const int n, const int k, int pos, int br, bool isHolding)
{
    if (pos == n)
    {
        return ((br <= k)?0:-INF);
    }

    if (dp[pos][br][isHolding] != -1)
        return dp[pos][br][isHolding];

    int64_t ans = solve(n, k, pos+1, br, isHolding);
    if (isHolding)
    {
        ans = max(ans, solve(n, k, pos+1, br, false)+p[pos]);
    }

    else
    {
        ans = max(ans, solve(n, k, pos+1, br+1, true)-p[pos]);
    }

    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dp, -1, sizeof(dp));

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> p[i];
    }


    int64_t ans = -INF;
    for (int k = 1; k <= n; k++)
    {
        ans = max(ans, solve(n, k, 0, 0, 0));
        cout << ans << " ";
    }

    cout << endl;

    return 0;
}
