#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;

const int maxn = 16002, maxb = 16, pausa = 16300;
struct vertex
{
    int idx;
    int st = 0;
};
vertex a[maxn];
vector <bool> ans;
bool usedver[maxn], ispausa;
int pw[maxb], cntver, N;
vector <int> v[maxn];
unordered_map <long long, bool> used;

bool cmp(vertex v1, vertex v2)
{
    return (v1.st < v2.st);
}

string to_2(int num)
{
    //cout << "*" << num << "*" << '\n' ;
    string s = "00000000000000";
    int pos = 13;
    do
    {
        if (num&1)
            s[pos] = '1';
        -- pos;
        num >>= 1;
    }while (num);
    return s;
}

void add_to_ans(vector<bool>&ans, string s)
{
    int i, len = 14;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '0')
            ans.push_back(false);
        else
            ans.push_back(true);
    }
}

void dfs(int ver, int par)
{
    add_to_ans(ans, to_2(ver));
    ispausa = 0;
    ++ cntver;
    usedver[ver] = true;
    int i, len = (int)(v[ver].size()), nb;
    long long edge;
    for (i=0; i<len; ++i)
    {
        nb = v[ver][i];
        edge = (long long)(ver)*(long long)(maxn)+(long long)(nb);
        if (!usedver[nb])
        {
            if (ispausa)
            {
                add_to_ans(ans, to_2(ver));
                ispausa = 0;
            }
            used[edge] = true;
            edge = (long long)(nb)*(long long)(maxn)+(long long)(ver);
            used[edge] = true;
            dfs(nb, ver);
        }
        else if (nb != par && used[edge] == 0)
        {
            used[edge] = true;
            edge = (long long)(nb)*(long long)(maxn)+(long long)(ver);
            used[edge] = true;
            add_to_ans(ans, to_2(nb));
            ispausa = 0;
            if (cntver < N)
            {
                add_to_ans(ans, to_2(pausa));
                ispausa = true;
            }
            //cout << ver << " " << nb << " " << par << '\n' ;
        }
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    int m = (int)(edges.size()), i, x, y;
    vector <bool> zero;
    ans = zero; used.clear();
    memset(usedver, 0, sizeof(usedver));
    cntver = 0; N = n; ispausa = 0;
    for (i=0; i<m; ++i)
    {
        x = edges[i].first;
        y = edges[i].second;
        v[x].push_back(y);
        v[y].push_back(x);
        a[x].st++; a[y].st++;
        a[x].idx = x; a[y].idx = y;
    }

    sort(a, a+n, cmp);
    dfs(a[0].idx, -1);
    return ans;
}

void init()
{
    int i;
    pw[0] = 1;
    for (i=1; i<maxb; ++i)
        pw[i] = pw[i-1] * 2;
}

int to_10(string s)
{
    int i, len = 14, res = 0;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '1')
            res += (pw[13-i]);
    }
    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector <pair<int, int>> ans;
    init();
    int i, len = (int)(data.size()), j, x = -1, y = -1, num;
    string s;
    for (i=0; i<len; i+=14)
    {
        s = "00000000000000";
        for (j=i; j<i+14; ++j)
        {
            if (data[j])
                s[j%14] = '1';
        }

        num = to_10(s);
        if (num == pausa)
        {
            x = -1, y = -1;
            continue;
        }
        if (x == -1)
            x = num;
        else
        {
            y = num;
            ans.push_back({x, y});
            x = y;
            y = -1;
        }
    }
    return ans;
}

/*

1
11 12
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10

*/