#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;

const int maxn = 16002, maxb = 16, pause = 16300;
struct vertex
{
    int idx;
    int st = 0;
};
vertex a[maxn];
int pos[maxn], sz[maxn], pw[maxb];
vector <int> v[maxn];
unordered_map <long long, bool> used;

bool cmp(vertex v1, vertex v2)
{
    return (v1.st > v2.st);
}

string to_2(int num)
{
    //cout << num << " - " ;
    string s = "00000000000000";
    int pos = 13;
    do
    {
        if (num&1)
            s[pos] = '1';
        -- pos;
        num >>= 1;
    }while (num);
    //cout << s << '\n' ;
    return s;
}

void add_to_ans(vector<bool>&ans, string s)
{
    int i, len = 14;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '0')
            ans.push_back(false);
        else
            ans.push_back(true);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    int m = (int)(edges.size()), i, x, y;
    for (i=0; i<m; ++i)
    {
        x = edges[i].first;
        y = edges[i].second;
        v[x].push_back(y);
        v[y].push_back(x);
        a[x].st++; a[y].st++;
        a[x].idx = x; a[y].idx = y;
        //cout << x << "*" << y << '\n' ;
    }
    //cout << '\n' ;

    for (i=0; i<n; ++i)
        sz[i] = a[i].st;
    sort(a, a+n, cmp);
    for (i=0; i<n; ++i)
        pos[a[i].idx] = i;

    vector <bool> ans;
    int j, len;
    long long edge;
    bool lamp = false;
    for (i=0; i<n; ++i)
    {
        x = a[i].idx;
        len = a[i].st;
        if (len <= 0)
            continue;

        if (!lamp) lamp = true;
        else add_to_ans(ans, to_2(pause));
        add_to_ans(ans, to_2(x));

        for (j=0; j<sz[x]; ++j)
        {
            y = v[x][j];
            edge = (long long)(x)*(long long)(maxn)+(long long)(y);
            if (used[edge] == 0)
            {
                add_to_ans(ans, to_2(y));
                a[pos[y]].st --;
                used[edge] = true;
                edge = (long long)(y)*(long long)(maxn)+(long long)(x);
                used[edge] = true;
            }
        }
    }
}

void init()
{
    int i;
    pw[0] = 1;
    for (i=1; i<maxb; ++i)
        pw[i] = pw[i-1] * 2;
}

int to_10(string s)
{
    int i, len = 14, res = 0;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '1')
            res += (pw[13-i]);
    }
    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector <pair<int, int>> ans;
    init();
    int i, len = (int)(data.size()), j, x = -1, y = -1, num;
    string s;
    for (i=0; i<len; i+=14)
    {
        s = "00000000000000";
        for (j=i; j<i+14; ++j)
        {
            if (data[j])
                s[j%14] = '1';
        }

        num = to_10(s);
        if (num == pause)
            x = -1, y = -1;
        else if (x == -1)
            x = num;
        else
        {
            y = num;
            ans.push_back({x, y});
            //cout << x << " -> " << y << '\n' ;
        }
    }
}