#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

const int maxn=16005;

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<bool>ans(n*n,0);

    for(pair<int,int> i : edges)
    {
        if(i.first>i.second)
            swap(i.first,i.second);
        ans[i.first*n+i.second+1]=true;
    }

    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int,int>>ans;
    int p1,p2;
    for(int i=0;i<data.size();i++)
    {
        if(data[i])
        {
            p2=(i-1)%n;
            p1=(i-1)/n;

            ans.push_back({p1,p2});
        }
    }

    return ans;
}
