#include<bits/stdc++.h>

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn=3005,mod=1e9+7;
long long pa,pb,f[maxn];
string s;

void precomp_f() ///ok
{
    f[0]=1;
    for(int i=1;i<maxn;i++)
        f[i]=(f[i-1]*i)%mod;
}

long long fastpower(long long x,long long p) ///ok
{
    long long ret=1,base=x;
    while(p!=0)
    {
        if(p%2!=0)
            ret=(ret*base)%mod;
        base=(base*base)%mod;
        p/=2;
    }
    return ret;
}

long long find_ans(long long p,long long q)
{
    return (p*fastpower(q,mod-2))%mod;
}

long long comb(int n,int k) ///ok
{
    long long inverse1=fastpower(f[k],mod-2);

    long long inverse2=fastpower(f[n-k],mod-2);

    long long ans=(f[n]*inverse1)%mod;
    ans=(ans*inverse2)%mod;

    return ans;
}

void read()
{
    precomp_f();

    int n;

    cin>>n>>pa>>pb>>s;

    long long a=1; /// ok
    for(char i : s) /// mod????
    {
        if(i=='0')
            a*=pa;
        else a*=(pb-pa);
    }

    long long ans=0,curr,currans;
    long long proiz=fastpower(pb,(long long)n);
    long long del=fastpower(proiz,mod-2);

    for(int i=n;i<=maxn;i++)
    {
        curr=(i*comb(i,n))%mod;
        curr=(curr*a)%mod;
        ans=(ans+curr)%mod;///ok

        if(ans>=proiz)
        {
            cout<<i<<endl;
            return;
        }
    }
}

int main()
{
    speed();
    read();
    return 0;
}
