#define _GLIBCXX_FILESYSTEM
#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;
typedef long long ll;
string chisla[16028];
string pravi(int x){
    if(x==0){
        return "0";
    }
    string st="";
    while(x!=0){
        if(x%2==1){
            st+='1';
        }else{
            st+='0';
        }
        x/=2;
    }
    return st;
}
void build(int br){
    for(int i=0;i<max(br,120);i++){
        chisla[i]=pravi(i);
    }
}
int ch(string cr){
    int res=0;
    for(int i=(int)cr.size()-1;i>=0;i--){
        if(cr[i]=='1'){
            res+=(1<<i);
        }
    }
    return res;
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){
    build(n);
    vector<bool> res;
    string data;
    for(int i=0;i<edges.size();i++){
        int u=edges[i].first;
        int v=edges[i].second;
        string stu=pravi(u),stv=pravi(v);
        while(stu.size()<14){
            stu+='0';
        }
        while(stv.size()<14){
            stv+='0';
        }
        data+=stu;
        data+=stv;
    }
    for(int i=0;i<data.size();i++){
        if(data[i]=='1'){
            res.push_back(1);
        }else{
            res.push_back(0);
        }
    }
    return res;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    build(n);
    vector<pair<int,int>> res;
    string danni;
    for(int i=0;i<data.size();i++){
        if(data[i]){
            danni+='1';
        }else{
            danni+='0';
        }
    }
    int id=0;
    while(id<danni.size()){
        int x=0;
        string curru,currv;
        while(x<14){
            curru+=danni[id];
            x++;
            id++;
        }
        x=0;
        while(x<14){
            currv+=danni[id];
            x++;
            id++;
        }
        res.push_back({ch(curru),ch(currv)});
    }

    return res;
}
