#include<vector>
#include"cactus.h"

std::vector<bool>encode(int n, std::vector<std::pair<int,int>> edges){
    std::vector<bool> ans(n*n+n);
    for(auto &[v, u] : edges){
        ans[v*n+u+1] = true;
        ans[u*n+v+1] = true;
    }
    return ans;
}

std::vector<std::pair<int,int>> decode(int n, std::vector<bool> data){
    std::vector<std::pair<int,int>> edges;
    for(int i=0; i<n;i++)
        for(int j=i+1; j<n;j++)
            if(data[i*n+j + 1])
                edges.push_back({i,j});
    return edges;
}
