#include<vector>
#include"cactus.h"
using namespace std;

vector<bool>encode(int n, vector<pair<int,int>> edges){
    vector<bool> ans(n*n+n);
    for(auto &[v, u] : edges){
        if(v > u)
        ans[v*n+u+1] = true;
    else
        ans[u*n+v+1] = true;
    }
    return ans;
}

vector<pair<int,int>> decode(int n, vector<bool> data){
    vector<pair<int,int>> edges;
    for(int i=0; i<n;i++)
        for(int j=i+1; j<n;j++)
            if(data[i*n+j + 1])
                edges.push_back({i,j});
    return edges;
}
