#include <bits/stdc++.h>
#include "cactus.h"
//#include "Lgrader.cpp"
using namespace std;

vector<bool> XtoBin(int num)
{
    vector<bool> ans;
    if(num == 0) ans.push_back(0);
    while(num > 0)
    {
        int teki = num%2;
        num /= 2;
        ans.push_back(teki);
    }
    while(ans.size() < 15)
    {
        ans.push_back(0);
    }
    //reverse(ans.begin(), ans.end());

    return ans;
}

int BinToX(vector<bool> teki)
{
    int p = 1;
    int ans = 0;
    for(int i = 0; i < 15; i ++)
    {
        ans += p*teki[i];
        p *= 2;
    }
    return ans;
}

void OutPut(vector<pair<int, int>> edg)
{
    for(int i = 0; i < edg.size(); i ++)
    {
        vector<bool> ap, bp;
        ap = XtoBin(edg[i].first);
        bp = XtoBin(edg[i].second);
        cout << edg[i].first << " - ";
        for(int j = 0; j < ap.size(); j ++)
        {
            cout << ap[j];
        }
        cout << " ; " << edg[i].second << " - ";
        for(int j = 0; j < bp.size(); j ++)
        {
            cout << bp[j];
        }cout << endl;
    }
}

vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    vector<bool> p;

    int m = edges.size();

    for (auto& [u, v] : edges)
    {
        if (u > v) swap(u, v);
    }
    sort(edges.begin(), edges.end());

    //OutPut(edges);

    for(int i = 0; i < m; i ++)
    {
        vector<bool> teki1, teki2;
        teki1 = XtoBin(edges[i].first);
        teki2 = XtoBin(edges[i].second);
        for(int i = 0; i < 15; i ++)
        {
            p.push_back(teki1[i]);
        }
        for(int i = 0; i < 15; i ++)
        {
            p.push_back(teki2[i]);
        }

       //cout << ans1 << " " << ans2 << endl;
    }

    return p;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int, int>> k;
    /*k.push_back({0, 1});
    k.push_back({2, 0});
    k.push_back({2, 1});
    k.push_back({1, 3});
    k.push_back({3, 4});
    k.push_back({4, 5});
    k.push_back({5, 1});
    k.push_back({2, 6});
    k.push_back({6, 7});
    k.push_back({8, 6});
    k.push_back({8, 7});
    k.push_back({2, 9});
    k.push_back({9, 10});*/

    int m = data.size()/30;
    int numtek = 0;
    for(int i = 0; i < m; i ++)
    {
        int l, r;
        vector<bool> teki1;
        for(int j = numtek; j < numtek+15; j ++)
        {
            teki1.push_back(data[j]);
            ///cout << data[j];
        }///cout << ", ";
        int ans1 = BinToX(teki1);

        l = i*15 + 15;
        r = i*15 + 30;
        vector<bool> teki2;

        numtek += 15;
        for(int j = numtek; j < numtek+15; j ++)
        {
            teki2.push_back(data[j]);
           /// cout << data[j];
        } ///cout << endl;
        int ans2 = BinToX(teki2);

        k.push_back({ans1, ans2});
        numtek += 15;
        //cout << i << " : " << ans1 << " " << ans2 << endl << endl;
    }

    return k;
}

/*
InPut:
1
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10


InPut:
1
3 4

0 1
1 2
2 3
3 4

*/
