#include<bits/stdc++.h>
using namespace std;

const long long MOD = 1e9+7;
long long sys[2001][2001];
vector<long long> wow(2001);
vector<long long> idk0(2001);
vector<long long> idk1(2001);

long long calc(long long a, long long b) {
    if(b == 0) {
        return 1;
    }
    else if(b == 1) {
        return a;
    }
    long long ans = calc(a,b/2);
    ans*=ans;
    ans%=MOD;
    if(b%2) {
        ans*=a;
        ans%=MOD;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,a,b;
    cin >> n >> a >> b;
    long long p = (a*calc(b,MOD-2))%MOD;
    string s;
    cin >> s;
    reverse(s.begin(),s.end());
    s+='0';
    reverse(s.begin(),s.end());
    vector<int> kmp(n+1);
    kmp[0] = 0;
    kmp[1] = 0;
    for(int i = 2; i <= n; i++) {
        int y = i-1;
        while((y != 0 && s[y+1] != s[i]) || y == i-1) {
            y = kmp[y];
        }
        if(y == 0) {
            if(s[1] == s[i]) {
                kmp[i] = 1;
            }
            else {
                kmp[i] = 0;
            }
        }
        else {
            kmp[i] = kmp[y]+1;
        }
    }
    for(int i = 0; i < n; i++) {
        if(s[i+1] == '0') {
            idk0[i] = i+1;
            int y = i;
            while(s[y+1] != '1' && y != 0) {
                y = kmp[y];
            }
            if(s[y+1] == '1') {
                idk1[i] = y+1;
            }
            else {
                idk1[i] = 0;
            }
        }
        else {
            idk1[i] = i+1;
            int y = i;
            while(s[y+1] != '0' && y != 0) {
                y = kmp[y];
            }
            if(s[y+1] == '0') {
                idk0[i] = y+1;
            }
            else {
                idk0[i] = 0;
            }
        }
    }
    for(int i = 0; i < n; i++) {
        wow[i] = 1;
        for(int j = 0; j < n; j++) {
            sys[i][j] = 0;
        }
        sys[i][i] = 1;
        if(idk0[i] < n) {
            sys[i][idk0[i]] = (sys[i][idk0[i]]-p+2*MOD)%MOD;
        }
        if(idk1[i] < n) {
            sys[i][idk1[i]] = (sys[i][idk1[i]]+p-1+2*MOD)%MOD;
        }
    }
    for(int i = n-1; i > 0; i--) {
        long long a = sys[i][i];
        long long c = (sys[i-1][i]*calc(a,MOD-2))%MOD;
        for(int j = 0; j < n; j++) {
            sys[i-1][j] = (sys[i-1][j]-c*sys[i][j]+MOD*MOD)%MOD;
        }
        wow[i-1] = (wow[i-1]-wow[i]*c+MOD*MOD)%MOD;
    }
    vector<long long> ans(n,-1);
    for(int i = 0; i < n; i++) {
        long long sb = wow[i];
        for(int j = 0; j < i; j++) {
            sb = (sb-sys[i][j]*ans[j]+MOD*MOD)%MOD;
        }
        ans[i] = (sb*calc(sys[i][i],MOD-2))%MOD;
    }
    cout << ans[0];
    return 0;
}
