# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
using namespace std;
# include "cactus.h"
//# include "Lgrader.cpp"

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    map<pair<int,int>,bool> vis;
    for(pair<int,int> pa: edges)
    {
        if(pa.first>pa.second) swap(pa.first,pa.second);
        vis[pa]=1;
    }

    vector<bool> v;
    for(int i=0;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            if(vis[{i,j}]) v.push_back(1);
            else v.push_back(0);
        }
    }

    return v;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> edges;
    int ct=-1;
    for(int i=0;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            ct++;
            if(data[ct]) edges.push_back({i,j});
        }
    }

    return edges;
}
