# include <iostream>
using namespace std;

const long long INF=1e18;
const int MAX=5e5+11;

long long n;
long long a[MAX];
long long dp[MAX][2];
long long mx[MAX][2];

int f(int x) {return x&1;}

void init(int x)
{
    for(int i=0;i<=n;i++)
    {
        dp[i][x]=-INF;
        mx[i][x]=-INF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];

    init(0);
    init(1);

    for(int i=1;i<=n;i++)
    {
        mx[i][0]=-a[i];
        mx[i][0]=max(mx[i][0],mx[i-1][0]);
    }

    long long ans=0;
    for(int j=1;j<=n;j++)
    {
        if(j*2<=n) init(f(j));

        for(int i=j*2;i<=n;i++)
        {
            dp[i][f(j)]=a[i]+mx[i-1][f(j-1)];
            dp[i][f(j)]=max(dp[i][f(j)],dp[i-1][f(j)]);
            ans=max(ans,dp[i][f(j)]);
            //cout<<i<<" "<<j<<":"<<dp[i][j]<<"\n";

            mx[i][f(j)]=max(mx[i-1][f(j)],dp[i][f(j)]-a[i]);

            //cout<<i<<" "<<j<<":"<<mx[i][j]<<"\n";
        }

        cout<<ans<<" ";
    }
    cout<<"\n";

    return 0;
}

/*
5
5 4 3 2 1
*/
