#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;



std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<int> edg[16009];
    vector<pair<int,int>> edgD;
    vector<bool> ans;
    bitset<16009> vis;
    int father[16009];
    const long long DAL=14;

    for(auto i:edges)
    {
        edg[i.first].push_back(i.second);
        edg[i.second].push_back(i.first);
    }
    queue<int> q;
    q.push(0);
    father[0]=-1;
    vis[0]=1;
    while(!q.empty())
    {
        int t=q.front();
        q.pop();
        for(auto i: edg[t])
        {
            if(father[t]==i)continue;
            if(vis[i])
            {
                edgD.push_back({t,i});
                continue;
            }
            father[i]=t;
            q.push(i);
            vis[i]=1;
        }
    }
    for(int k=1;k<n;k++)
    {
        int x=father[k];
        for(int i=DAL-1; i>=0; i--)
        {
            ans.push_back(x/(1LL<<i));
            x%=(1LL<<i);
        }
    }
    for(int i=0;i<edgD.size();i+=2)
    {
        int x=edgD[i].second;
        for(int i=DAL-1; i>=0; i--)
        {
            ans.push_back(x/(1LL<<i));
            x%=(1LL<<i);
        }
        x=edgD[i].first;
        for(int i=DAL-1; i>=0; i--)
        {
            ans.push_back(x/(1LL<<i));
            x%=(1LL<<i);
        }
    }
    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> ans;
    const int DAL=14;
    for(int i=0; i<(n-1)*DAL; i+=DAL)
    {
        int y=0;
        for(int j=i; j<i+DAL; j++)
        {
            y+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        ans.push_back({y,i/DAL+1});
    }
    for(int i=(n-1)*DAL; i<data.size();)
    {
        int x=0;
        for(int j=i; j<i+DAL; j++)
        {
            x+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        i+=DAL;
        int y=0;
        for(int j=i; j<i+DAL; j++)
        {
            y+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        i+=DAL;
        ans.push_back({x,y});
    }
    return ans;
}
