#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;



std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<bool> ans;
    const long long DAL=14;
    for(auto i:edges)if(i.first>i.second)swap(i.first,i.second);
    sort(edges.begin(),edges.end());
    int curr=0;
    for(int i=0;i<n;i++)
    {
        while(curr<edges.size()&&edges[curr].first==i)
        {
            int x=edges[curr].second;
            for(int i=DAL-1;i>=0;i--)
            {
                ans.push_back(x/(1LL<<i));
                x%=(1LL<<i);
            }
            curr++;
        }
        if(i!=n-1)
        {
            for(int i=0;i<DAL;i++)ans.push_back(1);
        }
    }
    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> ans;
    const int DAL=14;
    int curr=0;
    for(int i=0;i<data.size();i+=DAL)
    {
        int x=0;
        for(int j=i;j<i+DAL;j++)
        {
            x+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        if(x>n)curr++;
        else ans.push_back({curr,x});
    }
    return ans;
}
