# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 1e5 + 1;
const ll INF = 1e18;
const int BLOCK = (1e9 + 1e8);
int N;
ll P[MAXN];
ll dp[MAXN][2];
ll dpPrevious[MAXN][2];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;
    for(int i = 1; i <= N; i++) cin >> P[i];

    for(int i = 0; i <= min(N, (BLOCK / N)); i++)
    {
        dpPrevious[i][0] = -INF;
        dpPrevious[i][1] = -INF;
    }

    dpPrevious[0][0] = 0;

    for(int i = 1; i <= N; i++)
    {
        dpPrevious[i][0] = 0;

        for(int K = 1; K <= min(N, (BLOCK / N)); K++)
        {
            dp[K][0] = dpPrevious[K][0];
            dp[K][1] = dpPrevious[K][1];
            dp[K][0] = max(dpPrevious[K][1] + P[i], dp[K][0]);
            dp[K][1] = max(dpPrevious[K - 1][0] - P[i], dp[K][1]);
        }

        for(int K = 0; K <= min(N, (BLOCK / N)); K++)
        {
            dpPrevious[K][0] = dp[K][0];
            dpPrevious[K][1] = dp[K][1];
        }
    }
}

void Solve()
{
    ll Answer = 0;
    for(int K = 1; K <= min(N, (BLOCK / N)); K++)
    {
        if(K <= min(N, (BLOCK / N)))Answer = max(Answer, dp[K][0]);
        cout << Answer << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

