# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 10001;
const ll INF = 1e18;
int N;
ll P[MAXN];
ll dp[MAXN][MAXN][2];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;
    for(int i = 1; i <= N; i++) cin >> P[i];
    for(int i = 0; i <= N; i++)
    {
        for(int K = 0; K <= N; K++)
        {
            dp[i][K][0] = -INF;
            dp[i][K][1] = -INF;
        }
    }

    dp[0][0][0] = 0;

    for(int i = 1; i <= N; i++)
    {
        dp[i][0][0] = 0;

        for(int K = 1; K <= N; K++)
        {
            dp[i][K][0] = dp[i - 1][K][0];
            dp[i][K][1] = dp[i - 1][K][1];
            dp[i][K][0] = max(dp[i - 1][K][1] + P[i], dp[i][K][0]);
            dp[i][K][1] = max(dp[i - 1][K - 1][0] - P[i], dp[i][K][1]);
        }
    }
}

void Solve()
{
    ll Answer = 0;
    for(int K = 1; K <= N; K++)
    {
        Answer = max(Answer, dp[N][K][0]);
        cout << Answer << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

