#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int MAXN = 3005;

long long n,pA,pB;


string s;
long long p0,p1;

long long step(long long a, long long b)
{
    long long res = 1;
    while(b > 0)
    {
        if(b%2) res = (res*a)%mod;

        b /= 2;
        a = (a*a)%mod;
    }
    return res;
}

long long fract(long long chis, long long znam)
{
    return (chis*step(znam,mod-2))%mod;
}



void read()
{
    cin >> n;
    cin >> pA >> pB;
    cin >> s;

    p0 = fract(pA,pB);
    p1 = fract(pB-pA,pB);

    //cout << p0 << " " << p1 << endl;
}

long long used[2*MAXN];

void solve()
{
    if(s[0]=='0')
    {
        used[n] = 1;
        used[n+1] = p1;
    }
    else
    {
        used[n] = 1;
        used[n+1] = p0;
    }

    for(long long i = n+2; i <= 2*n; i++)
    {
        long long sm = used[i-1];
        ///used[i] = sm*(p1 + p0)
        used[i] = sm;
    }

    long long obshto = 0;
    for(int i = n; i <= 2*n; i++) obshto += used[i];

    /*cout << "eto gi" << endl;
    cout << obshto << endl;
    for(int i = n; i <= 2*n; i++) cout << used[i] << " ";
    cout << endl;*/

    long long ans = 0;
    for(int i = n; i <= 2*n; i++)
    {
        ans = (ans + (used[i]*i)%mod)%mod;
    }
    cout << ans << endl;


    /*long long st = 1;
    long long newb = 0;
    newb = st*4;
    newb += st*5;
    newb += st*6;
    newb += (st - (step(p1,2)*p0)%mod + mod)%mod*7;
    newb += (st - ((step(p1,2)*p0)%mod + (step(p1,3)*p0)%mod)%mod + mod)%mod * 8;
    newb %= mod;
    cout << newb << endl;*/
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
