#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int MAXN = 1e7+5;

long long n,pA,pB;


string s;
long long p0,p1;

long long step(long long a, long long b)
{
    long long res = 1;
    while(b > 0)
    {
        if(b%2) res = (res*a)%mod;

        b /= 2;
        a = (a*a)%mod;
    }
    return res;
}

long long fract(long long chis, long long znam)
{
    return (chis*step(znam,mod-2))%mod;
}



void read()
{
    cin >> n;
    cin >> pA >> pB;
    cin >> s;

    p0 = fract(pA,pB);
    p1 = fract(pB-pA,pB);
}

long long used[2*MAXN];

void solve()
{
    if(s[0]=='0')
    {
        used[n] = (step(p0,n)*n)%mod;
        used[n+1] = ((step(p0,n)*p1)%mod * (n+1))%mod;
    }
    else
    {
        used[n] = (step(p1,n)*n)%mod;
        used[n+1] = ((step(p1,n)*p0)%mod * (n+1))%mod;
    }

    for(long long i = n+2; i <= 2*n; i++)
    {
        long long sm = fract((used[i-1]*i)%mod, (i-1));
        used[i] = ((sm*p0)%mod + (sm*p1)%mod)%mod;
    }
    //for(int i = n; i <= 2*n; i++) cout << used[i] << endl;


    //cout << "predi ans" << endl;
    long long ans = 0;
    for(int i = n; i <= 2*n; i++) ans = (ans + used[i])%mod;
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
