#include <iostream>

using namespace std;

const long long mod = 1e9 + 7;

int n;
long long p, q;
string s;

long long fastPower(long long a, long long b)
{
    long long curr = a, result = 1;

    for (int i = 0; i < 63; ++i)
    {
        if ((b & (1LL << i)) != 0)
        {
            result *= curr;
            result %= mod;
        }

        curr *= curr;
        curr %= mod;
    }

    return result;
}

long long E[3005];
long long pInv, qInv;
long long prob[2];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> p >> q;
    cin >> s;

    pInv = fastPower(p, mod - 2);
    qInv = fastPower(q, mod - 2);
    prob[0] = (p * qInv) % mod;
    prob[1] = ((q - p) * qInv) % mod;

    long long sum = 0;
    long long oth = 0;
    /*long long pq = (p * qInv) % mod;
    long long pq1 = ((q - p) * qInv) % mod;

    //cout << pq1 << " " << 1 + mod - pq << endl;

    sum = 1 + mod - pq;
    sum %= mod;
    oth = (1 + mod - pq);
    oth %= mod;

    //cout << "BEFORE " << sum << " " << oth << endl;

    for (int i = 1; i <= n - 1; ++i)
    {
        sum += (((fastPower(pq, i) * (1 + mod - pq)) % mod) * (1LL * (i + 1))) % mod;
        sum %= mod;
        oth = oth + (fastPower(pq, i) * (1 + mod - pq)) % mod;
        oth %= mod;
    }

    //cout << sum  << " and " << oth << " :: " << (3 * fastPower(4, mod - 2)) % mod << endl;

    oth = (1 + mod - oth);
    oth %= mod;

    sum += ((1LL * n) * (fastPower(pq, n))) % mod;
    sum %= mod;

    //cout << sum << " :: " << (3 * fastPower(2, mod - 2)) % mod << endl;
    //cout << oth << endl;

    cout << (sum * fastPower(oth, mod - 2)) % mod << endl;*/

    long long pq = (p * qInv) % mod;
    long long pq1 = ((q - p) * qInv) % mod;

    sum = prob[1 - (s[0] - '0')];
    sum %= mod;
    oth = sum;

    for (int i = 1; i <= n - 1; ++i)
    {
        int d = (s[i - 1] - '0');
        sum += (((fastPower(prob[d], i) * (prob[1 - d]) ) % mod) * (1LL * (i + 1))) % mod;
        sum %= mod;
        oth += (fastPower(prob[d], i) * prob[1 - d]) % mod;
        oth %= mod;
    }

    oth = (1 + mod - oth);
    oth %= mod;

    sum += ((1LL * n) * (fastPower(prob[(s[n - 1] - '0')], n))) % mod;
    sum %= mod;
    cout << (sum * fastPower(oth, mod - 2)) % mod << endl;

    return 0;
}
