#include <iostream>

using namespace std;

const long long mod = 1e9 + 7;

int n;
long long p, q;
string s;

long long fastPower(long long a, long long b)
{
    long long curr = a, result = 1;

    for (int i = 0; i < 63; ++i)
    {
        if ((b & (1LL << i)) != 0)
        {
            result *= curr;
            result %= mod;
        }

        curr *= curr;
        curr %= mod;
    }

    return result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> p >> q;
    cin >> s;

    if (s[0] == '1')
    {
        p = q - p;
    }

    cout << (fastPower(q, n) * fastPower(fastPower(p, mod - 2), n)) % mod << endl;

    return 0;
}
