#include <iostream>

int n;
int prices[1000000];
int maxes[100];

int main() {
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        std::cin >> prices[i];
        maxes[i] = -1;
    }

    for (int mask = 0; mask < (1 << (n+1)); mask++) {
        int bit_cnt = 0;
        int sign = -1;
        int res = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                bit_cnt++;
                res += prices[i] * sign;
                sign *= -1;
            }
        }
        maxes[bit_cnt/2] = std::max(maxes[bit_cnt/2], res);
    }

    for (int i = 1; i <= n; i++) {
        maxes[i] = std::max(maxes[i], maxes[i - 1]);
    }

    for (int i = 1; i <= n; i++) {
        std::cout << maxes[i] << " ";
    }
}
