#include "cactus.h"
#include <bits/stdc++.h>
using namespace std;



int sumTo (int n) {
    if (n <= 0) return 0;
    return n * (n + 1) / 2;
}

int getCord (int i, int j, int n) {
    return j - (i + 1) + sumTo (n - 1) - sumTo (n - i - 1);
}
vector<bool> encode(const int n, vector<pair<int, int>> edges) {
    vector<bool> ans;

    for (int i = 0; i < edges.size(); i ++) {
        int a = edges[i].first;
        int b = edges[i].second;
        if (a > b) swap(a, b);
        ans[getCord(a, b, n)] = true;
    }

    return ans;
}

vector<pair<int, int>> decode(int n, vector<bool> data) {
    vector<pair<int, int>> ans;


    int cnt = 0;
    for (int i = 0; i < n; i ++) {
        for (int j = i + 1; j < n; j ++) {
            if (cnt < data.size() && data[cnt]) ans.push_back({i, j});
            cnt ++;
        }
    }

    return ans;
}
