#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#define endl "\n"

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

const int MOD_1 = 1e9 + 5;
const int MOD_2 = 1e9 + 7;
const int INF = 1e9 + 50;

long long power (int a, int b) {
    if (b == 0) return 1;
    if (b == 1) return a;

    if (b % 2 != 0) {
        return (power(a, b - 1) * a) % MOD_2;
    }

    long long x = power(a, b / 2);
    return (x * x) % MOD_2;
}

long long sum = 0;
int cnt = 0;

string testing;
int p0, p;

void solve (int ind, string& s) {
    if (ind > 1500000) {
        sum += 1500000;
        return;
    }

    if (ind > testing.size() - 1) {
        int x = 0;
        bool flag = true;
        for (int i = ind - testing.size(); i < ind; i ++) {
            if (testing[x] != s[i]) {
                flag = false;
                break;
            }
            x ++;
        }
        if (flag) {
            sum += s.size();
            return;
        }
    }
    if (rand() % p < p0) {
        s += '0';
        solve(ind + 1, s);
        s.pop_back();
    } else {
        s += '1';
        solve(ind + 1, s);
        s.pop_back();
    }
}
int main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    double startTime = clock();

    int n; cin >> n;
    cin >> p0 >> p;
    cin >> testing;
    while ((1.0 * clock() - startTime) / CLOCKS_PER_SEC <= 0.6)  {
        string s;
        cnt ++;
        solve(0, s);
    }

    cout << (sum * power(cnt, MOD_1)) % MOD_2 << endl;
    return 0;
}

