#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#define endl "\n"

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

const int MOD_1 = 1e9 + 5;
const int MOD_2 = 1e9 + 7;
const int INF = 1e9 + 50;

long long power (int a, int b) {
    if (b == 0) return 1;
    if (b == 1) return a;

    if (b % 2 != 0) {
        return (power(a, b - 1) * a) % MOD_2;
    }

    long long x = power(a, b / 2);
    return (x * x) % MOD_2;
}

int main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    int n; cin >> n;
    int p0, p1; cin >> p0 >> p1;
    string s; cin >> s;

    p1 = p1 - p0;

    int cnt0 = 0, cnt1 = 0;

    for (int i = 0; i < s.size(); i ++) {
        if (s[i] == '0') cnt0 ++;
        if (s[i] == '1') cnt1 ++;
    }

    int q = (power(p0, cnt0) * power(p1, cnt1)) % MOD_2;
    int p = (power((p0 + p1), s.size()) + ((s.size() - 0) * q) % MOD_1) % MOD_1;

    cout << (p * power(q, MOD_1)) % MOD_2 << endl;
    return 0;
}
