#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

vector < bool > c;

vector < pair < int, int > > edg;

void encode1(int x)
{
    for(int i = 0; i <= 14; i++)
    {
        c.push_back((x >> i) & 1);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    c.clear();

    for(pair < int, int > e : edges)
    {
        int u = e.first;
        int v = e.second;

        encode1(u);
        encode1(v);
    }

    return c;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    edg.clear();

    int sz = data.size();

    for(int i = 0; i < sz; i += 30)
    {
        int u = 0;
        for(int j = 0; j <= 14; j++)
        {
            u += data[i + j] * (1 << j);
        }

        int v = 0;
        for(int j = 0; j <= 14; j++)
        {
            v += data[i + j + 15] * (1 << j);
        }

        edg.push_back({u, v});
    }

    return edg;
}
