#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
#include "cactus.h"
using namespace std;
string bit(int x, int ko){
    string m = "";
    while(x > 0){
        if(x%2 == 1){
            m += '1';
        }else{
            m += '0';
        }
        x = x/2;
    }
    while(m.size() < ko){
        m += '0';
    }
    return m;
}
int _bit(string x){
    int stepen = 1;
    int chislo = 0;
    for(int i = 0; i < x.size(); i ++){
        if(x[i] == '1'){
            chislo += stepen;
        }
        stepen = stepen * 2;
    }
    return chislo;
}
int bits(int n){
    int otg = 0;
    while(n > 0){
        otg ++;
        n = n / 2;
    }
    return otg;
}
vector <bool> encode(int n, vector<pair<int, int>> edges){
    int kolkoN = bits(n);
    vector <bool> otg;
    sort(edges.begin(), edges.end());
    int x = 0;
    int ss = 0;
    for(int i = 0; i < edges.size(); i ++){
        if(edges[i].first != x){
            string a = bit(x, kolkoN);
            string b = bit(ss, kolkoN);
            /*for(int j = 0; j < a.size(); j ++){
                if(a[j] == '0'){ otg.push_back(false);
                }else{otg.push_back(true);}
            }*/
            for(int j = 0; j < b.size(); j ++){
                if(b[j] == '0'){ otg.push_back(false);
                }else{otg.push_back(true);}
            }
            for(int j = i - ss; j <= i - 1; j ++){
                string c = bit(edges[j].second, kolkoN);
                for(int j = 0; j < c.size(); j ++){
                    if(c[j] == '0'){ otg.push_back(false);
                    }else{otg.push_back(true);}

                }
            }
            x ++;
            ss = 0;
            i --;
        }else{
            ss ++;
        }
    }
    string a = bit(x, kolkoN);
    string b = bit(ss, kolkoN);
    /*for(int j = 0; j < a.size(); j ++){
        if(a[j] == '0'){ otg.push_back(false);
        }else{otg.push_back(true);}
    }*/
    for(int j = 0; j < b.size(); j ++){
        if(b[j] == '0'){ otg.push_back(false);
        }else{otg.push_back(true);}
    }
    for(int j = edges.size() - ss; j <= edges.size() - 1; j ++){
        string c = bit(edges[j].second, kolkoN);
        for(int j = 0; j < c.size(); j ++){
            if(c[j] == '0'){ otg.push_back(false);
            }else{otg.push_back(true);}

        }
    }
    return otg;
}
vector<pair<int, int>> decode(int n, vector<bool> data){
    int kolkoN = bits(n);
    vector <pair <int, int>> graf;
    int m = data.size()/kolkoN;
    int index = 0;
    for(int i = 0; i < m;){
        string a = "", b = "";
        for(int j = kolkoN * i; j < kolkoN * (i + 1); j ++){
            if(data[j] == false){
                a += '0';
            }else{
                a += '1';
            }
        }
        int x = _bit(a);
        int y = _bit(b);
        for(int j = i + 1; j < i + 1 + x; j ++){
            string osm = "";
            for(int f = 0; f < kolkoN; f ++){
                if(data[j * kolkoN + f]){
                    osm += '1';
                }else{
                    osm += '0';
                }
            }
            int z = _bit(osm);
            if(x != 0){
                graf.push_back({index, z});
            }
        }
        index += 1;
        i = i + 1 + x;
    }
    return graf;
}


