#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
#include "cactus.h"
using namespace std;
const int MAXN = 1e5 + 3;
vector <bool> encode(int n, vector<pair<int, int>> edges){
    sort(edges.begin(), edges.end());
    vector <bool> otg;
    int i = 0, j = 0;
    int index = 0;
    while(i < n){
        while(j < n){
            if(index < edges.size() && i == edges[index].first && j == edges[index].second){
                otg.push_back(1);
                index ++;
            }else{
                otg.push_back(0);
            }
            j ++;
        }
        i ++;
        j = 0;
    }
    return otg;
}
vector<pair<int, int>> decode(int n, vector<bool> data){
    vector <pair <int, int>> graf;
    int i = 0, j = 0;
    for(int x = 0; x < data.size(); x ++){
        i = x / n;
        j = x % n;
        if(data[x]){
            graf.push_back({i, j});
        }
    }
    return graf;
}


