#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
using namespace std;
const int MAXN = 10001;
int arr[MAXN];
int N;
vector <pair <int, int>> intervali;
vector <pair <int, int>> freeintervali;
vector <pair<int, pair<int, int>>> of1;
vector <pair<int, pair<int, int>>> of2;
pair <int, pair <int, int> > calc(int l, int r){
    int raz = 0, l1 = 0, r1 = 0;
    for(int i = l; i <= r; i ++){
        for(int j = i; j <= r; j ++){
            if(arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]) > raz){
                l1 = i; r1 = j;
                raz = arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]);
            }
        }
    }
    return {raz, {l1, r1}};

}
pair <int, pair <int, int>> maxFree(int l, int r){
    int max1 = 0, l1 = 0, r1 = 0;
    for(int i = l; i <= r; i ++){
        for(int j = i + 1; j <= r; j ++){
            if(arr[j] - arr[i] > max1){
                l1 = i; r1 = j;
                max1 = arr[j] - arr[i];
            }
        }
    }
    return {max1, {l1, r1}};

}
int main (){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> N;
    for(int i = 0; i < N; i ++){
        cin >> arr[i];
    }
    int l = 0, r = 0;
    for(int i = 0; i < N; i ++){
        for(int j = i; j < N; j ++){
            if(arr[j] - arr[i] > arr[r] - arr[l]){
                l = i; r = j;
            }
        }
    }
    intervali.push_back({l, r});
    freeintervali.push_back({0, l});
    freeintervali.push_back({r, N - 1});
    int sum = arr[r] - arr[l];
    cout << arr[r] - arr[l] << " ";
    for(int i = 2; i <= N; i ++){
        int x = intervali.size();
        int y = freeintervali.size();
        int flag = 0;
        ///cout << i << ": " << endl << endl;
        int maxL = 0, maxR = 0, maxJ = 0, maxRaz = 0;
        for(int j = 0; j < x; j ++){
            int l1, r1, raz;
            ///cout << intervali[j].first << " " << intervali[j].second << endl;
            pair <int, pair <int, int> > tek = calc(intervali[j].first, intervali[j].second);
            raz = tek.first;
            l1 = tek.second.first;
            r1 = tek.second.second;
            ///cout << raz << " " << l1 << " " << r1 << " " << maxRaz << endl;
            if(raz > maxRaz){
                maxRaz = raz;
                maxL = l1; maxR = r1; maxJ = j;
                flag = 1;
            }
        }
        for(int j = 0; j < y; j ++){
            pair <int, pair <int, int> > tek = maxFree(freeintervali[j].first, freeintervali[j].second);
            int l1, r1, raz;
            raz = tek.first;
            l1 = tek.second.first;
            r1 = tek.second.second;
            if(raz > maxRaz){
                maxL = l1;
                maxR = r1;
                maxRaz = raz;
                flag = 2;
                maxJ = j;
            }
        }
        if(maxRaz > 0){
            if(flag == 1){
                intervali.push_back({maxR, intervali[maxJ].second});
                intervali[maxJ].second = maxL;
                sum = sum + maxRaz;
                freeintervali.push_back({maxL, maxR});
            }
            if(flag == 2){
                sum = sum + maxRaz;
                freeintervali.push_back({maxR, freeintervali[maxJ].second});
                freeintervali[maxJ].second = maxL;
                intervali.push_back({maxL, maxR});
            }
        }
        cout << sum << " ";

    }
    return 0;
}
/**
10
90 10 30 20 40 35 30 50 40 70
*/


