#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
using namespace std;
const ll MAXN = 2e3 + 2;
ll arr[MAXN];
ll N;
vector <pair <ll, ll>> intervali;
pair <ll, pair <ll, ll> > calc(ll l, ll r){
    ll raz = 0, l1 = l, r1 = l;
    for(ll i = l + 1; i < r; i ++){
        for(ll j = i + 1; j < r; j ++){
            if(arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]) > raz){
                l1 = i; r1 = j;
                raz = arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]);
            }
        }
    }
    if(l1 != r1){
        return {raz, {l1, r1}};
    }else{
        return {0, {0, 0}};
    }
}
int main (){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> N;
    for(ll i = 0; i < N; i ++){
        cin >> arr[i];
    }
    ll l = 0, r = 0;
    for(ll i = 0; i < N; i ++){
        for(ll j = i + 1; j < N; j ++){
            if(arr[j] - arr[i] > arr[r] - arr[l]){
                l = i; r = j;
            }
        }
    }
    intervali.push_back({l, r});
    ll sum = arr[r] - arr[l];
    cout << arr[r] - arr[l] << " ";
    for(ll i = 2; i <= N; i ++){
        ll x = intervali.size();
        ///cout << i << ": " << endl << endl;
        ll maxL = -1, maxR = -1, maxJ =-1, maxRaz = -1;
        for(ll j = 0; j < x; j ++){
            ll l1, r1, raz;
            ///cout << intervali[j].first << " " << intervali[j].second << endl;
            pair <ll, pair <ll, ll> > tek = calc(intervali[j].first, intervali[j].second);
            raz = tek.first;
            l1 = tek.second.first;
            r1 = tek.second.second;
            ///cout << raz << " " << l1 << " " << r1 << " " << maxRaz << endl;
            if(raz >= maxRaz){
                maxRaz = raz;
                maxL = l1; maxR = r1; maxJ = j;
            }
        }
        if(maxRaz > 0){
            intervali.push_back({maxR, intervali[maxJ].second});
            intervali[maxJ].second = maxL;
            sum = sum + maxRaz;
        }
        cout << sum << " ";

    }
    return 0;
}
/**
10
90 10 30 20 40 35 30 50 40 70
*/

