#include<iostream>
#include <vector>
#include <unordered_set>
#include<stack>

using namespace std;

vector<bool> two_nums_to_bool(int a, int b){
    unsigned long long num = (((1 << 15) + a) << 14) + b;
    vector<bool> cur;
    for(int i = 28; i > 0; --i){
        cur.push_back(num % 2);
        num >>= 1;
    }
    return cur;
}

vector<bool> num_to_bool(int a){
    if(a >= (1 << 14)){
        cout << "STUPID";
    }else{
        vector<bool> cur;
        for(int i = 14; i > 0; --i){
            cur.push_back(a % 2);
            a >>= 1;
        }
        //cout << a << "->"; for(bool c : cur){cout << c;} cout << endl;
        if(cur.size() != 14) cout << "STUPID";
        return cur;
    }
}
pair<int, int> bool_to_two_nums(vector<bool> b){
    if(b.size() == 14 * 2){
        pair<int, int> ans = {0, 0};
        //for(bool a : b){ cout << a; } cout << "->";
        for(int i = 0; i < 14; ++i){
            ans.second = (ans.second << 1) + b[b.size() - 1];
            b.pop_back();
        }
        for(int i = 0; i < 14; ++i){
            ans.first = (ans.first << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }else{
        cout << "STUPID";
    }
}

int bool_to_num(vector<bool> b){
    if(b.size() == 14){
        //for(bool a : b){ cout << a; } cout << "->";
        int ans = 0;
        for(int i = 0; i < 14; ++i){
            ans = (ans << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }
}




vector<bool> encode(int n, vector<pair<int, int>> edges){
    unordered_set<int> spanned;
    vector<pair<int, int>> spanning_tree, other_edges;
    for(auto edge : edges){
        int u = edge.first, v = edge.second;
        if(spanned.find(u) != spanned.end() && spanned.find(v) != spanned.end()){
            other_edges.push_back(edge);
        }else{
            spanning_tree.push_back(edge);
            spanned.insert(u);
            spanned.insert(v);
        }
    }
    for(auto edge : spanning_tree){
        cout << edge.first << " " << edge.second << ", ";
    }
    if(spanning_tree.size() >= n){ cout << "FUCK" ;}

    vector<int> adj_list[n];
    for(auto edge : spanning_tree){
        int u = edge.first, v = edge.second;
        adj_list[u].push_back(v);
        adj_list[v].push_back(u);
    }
    int start = 0;
    for(int i = 0; i < n; ++i){
        if(adj_list[i].size() == 1){
            start = i;
            break;
        }
    }

    vector<int> part_1;
    //dfs
    stack<int> to_visit;
    vector<bool> visited(n, false);
    to_visit.push(start);
    while(!to_visit.empty()){
        int cur = to_visit.top();
        to_visit.pop();
        if(!visited[cur]){
            part_1.push_back(cur);
            visited[cur] = true;
            for(int v : adj_list[cur]){
                to_visit.push(v);
            }
        }
    }

    vector<bool> ans, cur;
    cur = num_to_bool(part_1.size());
    for(bool X : cur){
        ans.push_back(X);
    }
    cout << part_1.size() << ": ";
    for(int v : part_1){
        cur = num_to_bool(v);
        cout << v << ", ";
        for(bool X : cur){
            ans.push_back(X);
        }
        cur.clear();
    }
    cout << endl;
    for(auto edge : edges){
        cur = two_nums_to_bool(edge.first, edge.second);
        for(bool X : cur){
            ans.push_back(X);
        }
    }

    return ans;
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    cout << "Decode\n";
    vector<pair<int, int>> ans;
    vector<bool> cur;
    for(int i = 0; i < 14; ++i){
        cur.push_back(data[i]);
    }
    int A = bool_to_num(cur), u, v, at_bit = 28;
    cout << "A"  << A << endl;
    cur.clear();
    for(int i = 14; i < 28; ++i){
        cur.push_back(data[i]);
    }
    u = bool_to_num(cur);
    cur.clear();
    unordered_set<int> seen;
    seen.insert(u);
    for(int i = 0; i < A; ++i){
        cout << at_bit << " ";
        for(int j = at_bit; j < at_bit + 14; ++j){
            cur.push_back(data[j]);
    cout << data[j];
        }
        v = bool_to_num(cur);
        cout << v << " ";
        cur.clear();
        if(){
            ans.push_back({u, v});
        }else{
            u = v
            seen.insert(v);
        }
        at_bit += 14;
    }
    return ans;
}
