#include<vector>
//#include<bits/stdc++.h>
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){
    std::vector<bool> code;
    code.resize(n * (n - 1) / 2);
    int m = edges.size();
    for(int k = 0; k < m; k++){
        long long indeks = 0;
        int i = edges[k].first;
        int j = edges[k].second;
        if(i > j){
            std::swap(i, j);
        }
        indeks = i * n - i * (i + 3) / 2 + j - 1;
        code[indeks - 1] = 1;
    }
    return code;
}
/*std::vector<std::pair<int, int>> dvoika(int n, int i){
    int kop = i;
    int ind = 1;
    std::vector<std::pair<int, int>> dv;
    while(kop - (n - ind) > 0){
        kop -= n - ind;
        ind++;
    }
    if(kop == n - ind){
        dv.push_back({ind - 1, n - 1});
    }else{
        dv.push_back({ind - 1, ind - 1 + kop});
    }
    return dv;
}*/
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    std::vector<std::pair<int, int>> code;
    for(int i = 0; i < n * (n - 1) / 2; i++){
        if(data[i] != 0){

            int kop = i;
            int ind = 1;
            while(kop - (n - ind) > 0){
                kop -= n - ind;
                ind++;
            }
            if(kop == n - ind){
                code.push_back({ind - 1, n - 1});
            }else{
                code.push_back({ind - 1, ind - 1 + kop});
            }

            //code.push_back(dvoika(n, i));
        }
    }
    return code;
}
