/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF = 1e18;

int n;
int a[MAXN];
llong dp[MAXN][2];
int maxPos[2];
void solve()
{
    maxPos[0] = maxPos[1] = 0;
    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = maxPos[1] + 1 ; j >= 1 ; --j)
        {
            if (dp[j][0] >= dp[j - 1][1] + -a[i])
            {
                break;
            }

            dp[j][0] = dp[j - 1][1] + -a[i];
        }

        for (int j = maxPos[1] + 2 ; j <= n ; ++j)
        {
            if (dp[j][0] >= dp[j - 1][1] + -a[i])
            {
                break;
            }

            dp[j][0] = dp[j - 1][1] + -a[i];
        }

        for (int j = maxPos[0] ; j >= 0 ; --j)
        {
            if (dp[j][1] >= dp[j][0] + a[i])
            {
                break;
            }

            dp[j][1] = dp[j][0] + a[i];
        }

        for (int j = maxPos[0] + 1 ; j <= n ; ++j)
        {
            if (dp[j][1] >= dp[j][0] + a[i])
            {
                break;
            }

            dp[j][1] = dp[j][0] + a[i];
        }

        int oldMaxPos0 = maxPos[0];
        int oldMaxPos1 = maxPos[1] + 1;
        if (dp[oldMaxPos1][0] > dp[maxPos[0]][0])
        {
            maxPos[0] = oldMaxPos1;
        }

        if (dp[oldMaxPos0][1] > dp[maxPos[1]][1])
        {
            maxPos[1] = oldMaxPos0;
        }

        while (maxPos[0] > 0 && dp[maxPos[0] - 1][0] == dp[maxPos[0]][0]) maxPos[0]--;
        while (maxPos[1] > 0 && dp[maxPos[1] - 1][1] == dp[maxPos[1]][1]) maxPos[1]--;
        // std::cout << "dps: " << i << ' ' << maxPos[0] << ' ' << maxPos[1] << "\n";
        // for (int j = 0 ; j <= n ; ++j) std::cout << dp[j][0] << ' '; std::cout << '\n';
        // for (int j = 0 ; j <= n ; ++j) std::cout << dp[j][1] << ' '; std::cout << '\n';
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << dp[i][0] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}