/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF = 1e18;

int n;
int a[MAXN];
llong dp[MAXN][2];
void solve()
{
    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = n ; j >= 1 ; --j)
        {
            dp[j][0] = std::max(dp[j][0], dp[j - 1][1] + -a[i]);
        }

        for (int j = n ; j >= 0 ; --j)
        {
            dp[j][1] = std::max(dp[j][1], dp[j][0] + a[i]);
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << dp[i][0] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}