#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n;
vector<int> v[MAXN];

vector<bool> code;
int vis[MAXN];

stack<int> st;
vector< pair<int,int> > ans;

void reset(){
    code.clear();
    for(int i=0;i<n;i++){
        vis[i]=0; v[i].clear();
    }

    ans.clear();
}

vector<bool> encode(int x){
    vector<bool> res;

    for(int i=14;i>=0;i--){
        res.push_back((((1<<i)&x) > 0));
    }

    return res;
}

void add(int x){
    auto res=encode(x);
    for(bool x:res)code.push_back(x);
}

void dfs(int x,int par){
    vis[x]=1;

    for(int i:v[x]){

        if(vis[i]==0){
            code.push_back(0);
            code.push_back(0);
            add(i);

            dfs(i,x);
        }else if(i!=par and vis[i]==1){
            code.push_back(1);
            code.push_back(0);
            add(i);
        }
    }

    vis[x]=2;

    code.push_back(0);
    code.push_back(1);
}

vector<bool> encode(int N, vector< pair<int, int> > edges){
    n=N;
    reset();

    for(int i=0;i<edges.size();i++){
        v[edges[i].first].push_back(edges[i].second);
        v[edges[i].second].push_back(edges[i].first);
    }

    dfs(0,0);

    return code;
}

void addedge(int x,int y){
    ans.push_back({x,y});
}

vector< pair<int, int> > decode(int N, vector<bool> data){
    n=N;

    int curr=0;
    int pos=0;
    st.push(-1);

    while(pos< int(data.size()) ){

        if(data[pos]==0 and data[pos+1]==0){

            int news=0;
            for(int f=pos+2;f<=pos+16;f++){
                news*=2;
                if(data[f])news++;
            }

            addedge(curr,news);
            st.push(curr); curr=news;
            pos=pos+17;
        }else if(data[pos]==0 and data[pos+1]==1){

            curr=st.top();
            st.pop();
            pos=pos+2;
        }else if(data[pos]==1 and data[pos+1]==0){

            int news=0;
            for(int f=pos+2;f<=pos+16;f++){
                news*=2;
                if(data[f])news++;
            }

            addedge(curr,news);
            pos=pos+17;
        }else{
            return {};
        }
    }

    return ans;
}
