#include<bits/stdc++.h>
#include "cactus.h"


using namespace std;
typedef long long ll;

/// CLEAN THE GLOBAL MEMORY

const int MAXN = 16010;

int n;
vector < int > adj[MAXN];

vector < int > st;
map < pair < int, int >, int > marked;
int used[MAXN], mark;

void traverse(int v, int p)
{
    //cout << v << " " << p << endl;
    used[v] = 1;
    st.push_back(v);

    for (int u : adj[v])
    {
        //cout << "try to " << v << " " << u << " " << used[u] << endl;

        if (u == p || used[u] == 2)
            continue;
        if (used[u] == 0)
            traverse(u, v);
        else
        {
            ++ mark;
            ///cout << "here mark " << v << " : " << p << endl;
            int sz = st.size();
            for (int i = sz - 1; i >= 0; i --)
            {
                if (st[i] == u)
                {
                    marked[{u, v}] = marked[{v, u}] = mark;
                    break;
                }
                //cout << "mark " << st[i] << " " << st[i - 1] << endl;
                marked[{st[i], st[i - 1]}] = marked[{st[i - 1], st[i]}] = mark;
            }
        }
    }

    st.pop_back();
    used[v] = 2;
}


void find_cycles()
{
    st.clear();
    mark = 0;
    for (int i = 0; i < n; i ++)
        used[i] = 0;

    marked.clear();
    traverse(0, -1);
}

vector < bool > code;

const int bit_block = 14;

vector < bool > turn_to_binary(int x)
{
    vector < bool > res;
    ///cout << "num " << x<< endl;
    do
    {
        int c = x % 2;
        res.push_back(c);
        x /= 2;
    }while(x != 0);
    while(res.size() < bit_block)
        res.push_back(0);

    reverse(res.begin(), res.end());

       /**cout << "turn to binary "<< endl;
       cout << res.size() << endl;
        for (int x : res)
            cout << x;
        cout << endl;*/
    return res;
}

bool started;
int last_op;
void dfs(int v, int p, int cur_mark)
{

    //cout << "dfs " << v << " " << cur_mark << endl;
    used[v] = 1;
    if (cur_mark != 0)
    {
        for (int u : adj[v])
        {
            if (u == p)
                continue;
            if (used[u] == 1)
            {//cout << "check " << v << " " << u << endl;
                if (last_op == 1)
                    while(true);
                code.push_back(0);
                code.push_back(1);
                last_op = -1;
                started = false;
                // do stuff;
                /// finish cycle?
                continue;
            }
            if (marked[{v, u}] == cur_mark)
            {
                if (last_op != 1)
                {
                    code.push_back(0);
                    code.push_back(0);
                }
                last_op = -1;
                vector < bool > add = turn_to_binary(u);

                for (int x : add)
                    code.push_back(x);
                dfs(u, v, cur_mark);
                break;
            }
        }
    }

    for (int u : adj[v])
    {
        if (used[u])
            continue;
        int cm = marked[{v, u}];
        //cout << "HERE " << v << " " << u << " " << cm << endl;
        if (cm == 0 || started)
        {
            if (last_op != 1)
            {
                code.push_back(0);
                code.push_back(0);
            }

            last_op = -1;
        }
        else
        {
            if (last_op == 1)
                while(true);
            last_op = 1;
            started = true;
            code.push_back(0);
            code.push_back(1);
        }

        vector < bool > add = turn_to_binary(u);
        for (int x : add)
            code.push_back(x);
        dfs(u, v, marked[{v, u}]);
    }

    last_op = -1;
    code.push_back(1);
    used[v] = 2;
}
vector < bool > encode(int N, vector < pair < int, int > > edges)
{
    n = N;
    for (int i = 0; i < n; i ++)
        adj[i].clear();

    for (int i = 0; i < (int)(edges.size()); i ++)
    {
        adj[edges[i].first].push_back(edges[i].second);
        adj[edges[i].second].push_back(edges[i].first);
    }


    find_cycles();

    code.clear();
    for (int i = 0; i < n; i ++)
        used[i] = 0;

    started = false;
    last_op = -1;
    dfs(0, -1, 0);
    /**for (pair < pair <int, int >, int > cur : marked)
    {

        cout << "edge " << cur.first.first << " " << cur.first.second << " " << cur.second << endl;
    }*/
    /**for (int i = 0; i < 100; i ++)
        cout << code[i];
    cout << endl;*/

    return code;

}

vector < pair < int, int > > decode(int n, vector < bool > data)
{

    vector < pair < int, int > > res;

    int pivot = 0;
    vector < int > ord;
    ord.push_back(0);
    int last_start = -1, ls = -1;

    while(pivot < (int)(data.size()))
    {
        /**cout << "step " << "last start " << last_start << " " << ls << endl;
        for (int x : ord)
            cout << x << " ";
        cout << endl;*/
        if (data[pivot] == 1)
        {
            ls = -1;
            ord.pop_back();
            pivot ++;
            continue;
        }

        int operation = 0;
        if (ls != 1)
        {
            operation = data[pivot] * 2 + data[pivot + 1];
            pivot += 2;
        }
        if (operation == 1 && last_start != -1)
        {
            ls = -1;
            res.push_back({ord.back(), last_start});
            last_start = -1;
            continue;
        }

        int ver = 0;
        for (int i = pivot; i < pivot + bit_block; i ++)
        {
            ver = ver * 2 + data[i];
        }
        pivot += bit_block;
        if (operation == 0)
        {
            ls = -1;
            res.push_back({ord.back(), ver});
            ord.push_back(ver);
            continue;
        }

        if (operation == 1 )
        {
            ls = 1;
            last_start = ord.back();
            res.push_back({ord.back(), ver});
            ord.push_back(ver);
            continue;
        }

        assert(false);
    }

    return res;
}
