#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}


const int MAXN = 3010;
const ll MOD = 1e9 + 7;

ll power(ll base, ll st)
{
    ll res = 1;
    while(st > 0)
    {
        if ((st & 1) > 0)
            res = (res * base) % MOD;
        base = (base * base) % MOD;
        st >>= 1;
    }
    return res;
}

ll table[MAXN][MAXN];

int n;
ll a, b;
string s;
/// a/b prob to hit 0

int fall_link[MAXN];

int arr[MAXN];

ll prob[2];

ll dp[MAXN];
void solve_same()
{
    ll p = prob[arr[1]], r = prob[arr[1] ^1];
    ll pw = 1;
    ll zn = 1, ch = 0;
    for (ll i = 1; i <= n; i ++)
    {
        zn = (zn - (r * pw) % MOD + MOD) % MOD;
        ch = (ch + (((r * pw) % MOD) * i) % MOD + MOD) % MOD;

        pw *= p;
        pw %= MOD;
    }
    ch = (ch + pw * (ll)(n)) % MOD;

    cout << (ch * power(zn, MOD - 2)) % MOD << endl;
}
void solve()
{
    cin >> n >> a >> b >> s;

    prob[0] = (a * power(b, MOD - 2)) % MOD;
    prob[1] = ((b - a) * power(b, MOD - 2)) % MOD;

    bool all_same = true;
    for (int i = 0; i < n; i ++)
    {
        if (s[i] == '0')
            arr[i + 1] = 0;
        else
            arr[i + 1] = 1;

    }
    for (int i = 1; i <= n; i ++)
    {
        if (arr[i] != arr[1])
        {
            all_same =false;
            break;
        }
    }

    if (all_same)
    {
        solve_same();
        return;
    }

    for (int i = 1; i <= n; i ++)
    {
        for (int j = 1; j <= i; j ++)
        {
            if (arr[j] == arr[i + 1])
                continue;
            int pivot = i;
            bool can = true;
            for (int k = j - 1; k > 0; k --)
            {
                if (arr[k] != arr[pivot])
                {
                    can = false;
                    break;
                }
                pivot --;
            }

            if (can)
            {
                fall_link[i] = max(fall_link[i], j);
            }
        }
    }

    for (int i = 0; i < n; i ++)
    {
        table[i][n + 1] = MOD - 1;

        table[i][fall_link[i]] += prob[(arr[i + 1] ^ 1)];
        table[i][fall_link[i]] %= MOD;

        table[i][i + 1] += prob[arr[i + 1]];
        table[i][i + 1] %= MOD;

        table[i][i] += MOD - 1;
        table[i][i] %= MOD;
    }



    for (int i = 0; i <= n; i ++)
        table[i][n] = 0;
    /**cout << "starting table" << endl;
    for (int i = 0; i <= n; i ++, cout << endl)
        for (int j = 0; j <= n + 1; j ++)
        cout << table[i][j] << " ";*/
    for (int i = 0; i <= n; i ++)
    {
        ll normalize = power(table[i][i], MOD - 2);
        for (int j = 0; j <= n + 1; j ++)
        {
            table[i][j] = (table[i][j] * normalize) % MOD;
        }

        for (int j = 0; j <= n; j ++)
        {
            if (j == i)
                continue;

            ll factor = table[j][i];
            for (int k = 0; k <= n + 1; k ++)
            {
                table[j][k] = (table[j][k] - (table[i][k] * factor) % MOD + MOD) % MOD;
            }
        }

        /**cout << "step" << endl;

        for (int i = 0; i <= n; i ++, cout << endl)
        for (int j = 0; j <= n + 1; j ++)
        cout << table[i][j] << " ";*/
    }

    //cout << "final table" << endl;

    cout << table[0][n + 1] << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}
