#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int mod=1e9+7;

long long fastpow(long long a, long long pw)
{
    if(pw==0) return 1;
    if(pw%2) return (a*fastpow(a, pw-1))%mod;
    long long t=fastpow(a, pw/2);
    return t*t%mod;
}

const int MAXN=1e7+2;
int n;
long long pa, pb;
long long prob[2];
int par[MAXN];
int par_df[MAXN];
int par2[MAXN];
int par_df2[MAXN];
string s;

void calc_par()
{
    for(int i=1; i<n; i++)
    {
        int tp=par[i-1];
        if(s[tp]==s[i])
        {
            par[i]=tp+1;
            if(tp>1) par_df[i]=par_df[tp-1];
            else par_df[i]=bool(s[i]!=s[0]);
        }
        else
        {
            par_df[i]=tp+1;
            while(tp>0)
            {
                if(s[tp]!=s[i]) tp=par[tp-1];
                else break;
            }
            if(tp!=0) par[i]=tp+1;
            else if(s[0]==s[i]) par[i]=1;
            else par[i]=0;
        }
    }
    
    ///for(int i=0; i<=n; i++) par_df[i]=0;
   /**for(int i=1; i<n; i++)
    {
        int tp=par2[i-1];
        while(tp>0)
        {
            if(s[tp]==s[i]) break;
            tp=par2[tp-1];
        }
        if(tp!=0) par2[i]=tp+1;
        else if(s[i]==s[0]) par2[i]=1;
        else par2[i]=0;
    }
    for(int i=1; i<n; i++) if(par[i]!=par2[i]) assert(false);
    for(int i=1; i<n; i++)
    {
        int tp=par[i-1];
        while(tp>0)
        {
            if(s[tp]!=s[i]) break;
            tp=par[tp-1];
        }
        if(tp!=0) par_df[i]=tp+1;
        else if(s[i]!=s[0]) par_df[i]=1;
        else par_df[i]=0;
    }*/
}

long long kf[MAXN], sb[MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    cin>>pa>>pb;
    getline(cin, s);
    getline(cin, s);
    prob[0]=pa*fastpow(pb, mod-2)%mod;
    prob[1]=((1-prob[0])+mod)%mod;
    calc_par();

    kf[0]=1;
    sb[0]=0;
    kf[1]=1;
    sb[1]=-fastpow(prob[s[0]-'0'], mod-2);
    for(int i=2; i<=n; i++)
    {
        ///e(i-1)-e(par_df[i])*(1-prob[s[i]])-1=e(i)*prob[s[i]]

        ///kf[i]=(kf[i-1]-(kf[par_df[i-1]]*(1-prob[s[i-1]-'0']))%mod)*fastpow(prob[s[i-1]-'0'], mod-2)%mod;
        sb[i]=(sb[i-1]-(sb[par_df[i-1]]*(1-prob[s[i-1]-'0']))%mod-1)*fastpow(prob[s[i-1]-'0'], mod-2)%mod;
    }
    cout<<((-sb[n])%mod+mod)%mod<<endl;
    return 0;
}