#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

int n;
vector<bool> v;
vector<pair<int,int> > edge;

std::vector<bool> encode(int _n, std::vector<std::pair<int, int>> edges)
{
    n=_n;
    int lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    v.clear();
    for(auto cur: edges)
    {
        auto [u,w]=cur;
        for(int i=0;i<lg;i++)
        {
            if(u&(1<<i)) v.push_back(1);
            else v.push_back(0);
        }
        for(int i=0;i<lg;i++)
        {
            if(w&(1<<i)) v.push_back(1);
            else v.push_back(0);
        }
    }
    return v;
}

std::vector<std::pair<int, int>> decode(int _n, std::vector<bool> data)
{
    n=_n;
    int lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    int cnt=data.size()/(2*lg);
    edge.clear();
    for(int i=0;i<cnt;i++)
    {
        int u=0;
        for(int j=0;j<lg;j++)
        {
            if(data[2*i*lg+j]==1) u+=(1<<j);
        }
        int w=0;
        for(int j=0;j<lg;j++)
        {
            if(data[(2*i+1)*lg+j]==1) w+=(1<<j);
        }
        edge.push_back({u,w});
    }
    return edge;
}
/*
1
31 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/