#pragma GCC optimize ("Ofast")
#pragma GCC target "sse4"
#include<bits/stdc++.h>
#define endl '\n'
//#define int long long

using namespace std;

const int MAXN=1e4+5;
const int MAXLOG=20;
const long long INFLL=(long long)1e18+5;

int n;
int a[MAXN];
vector<int> v1;
vector<int> v;
long long dp[2][MAXN];
int lg[MAXN];
int spT[MAXN][MAXLOG];

void spTable()
{
    lg[1]=0;
    for(int i=2;i<=n;i++)
    {
        lg[i]=lg[i/2]+1;
    }

    for(int i=1;i<=n;i++) spT[i][0]=v[i];
    for(int j=1;(1<<j)<=n;j++)
    {
        for(int i=1;i+(1<<j)-1<=n;i++)
        {
            spT[i][j]=min(spT[i][j-1], spT[i+(1<<(j-1))][j-1]);
        }
    }
}

int queryT(int l,int r)
{
    int len=r-l+1;
    return min(spT[l][lg[len]], spT[r-(1<<lg[len])+1][lg[len]]);
}

int query(int l,int r)
{
    return max(0, v[r]-queryT(l,r));
}

void solve(int l,int r,int optl,int optr)
{
    if(l>r) return;

    int mid=(l+r)/2;
    int opt=optl;
    for(int i=optl;i<=min(mid, optr);i++)
    {
        if(dp[1][mid]<query(i,mid)+dp[0][i-1])
        {
            opt=i;
            dp[1][mid]=dp[0][i-1]+query(i,mid);
        }
    }

    solve(l,mid-1,optl,opt);
    solve(mid+1,r,opt,optr);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];
    
    if(n==1)
    {
        cout<<0<<endl;
        return 0;
    }

    /*for(int i=1;i<=n;i++)
    {
        if(a[i]==a[i-1]) continue;
        v1.push_back(a[i]);
    }
    if(v1.size()==1)
    {
        for(int i=1;i<=n;i++) cout<<"0 ";
        cout<<endl;
        return 0;
    }
    v.push_back(0);
    for(int i=0;i<v1.size();i++)
    {
        if(v.size()==1)
        {
            if(i<v1.size()-1)
            {
                if(v1[i]>=v1[i+1]) continue;
                v.push_back(v1[i]);
            }
        }
        else if(v1[i]<v.back()) v.push_back(v1[i]);
        else if(i==v1.size()-1) v.push_back(v1[i]);
        else if(v1[i]>v1[i+1]) v.push_back(v1[i]);
    }
    if(v.size()<=2)
    {
        for(int i=0;i<n;i++) cout<<"0 ";
        cout<<endl;
        return 0;
    }*/

    v.push_back(0);
    for(int i=1;i<=n;i++) v.push_back(a[i]);

    n=v.size()-1;
    //spTable();

    // cout<<queryT(1,5)<<endl;
    // cout<<queryT(4,4)<<endl;
    // cout<<queryT(5,9)<<endl;
    // cout<<queryT(1,10)<<endl;

    for(int i=0;i<=n;i++) dp[0][i]=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++) dp[1][j]=0;
        int opt=1;
        for(int j=1;j<=n;j++)
        {
            dp[1][j]=dp[1][j-1];
            for(int k=opt;k<=j;k++)
            {
                if(dp[1][j]<dp[0][k]+v[j]-v[k])
                {
                    opt=k;
                    dp[1][j]=dp[0][k]+v[j]-v[k];
                }
            }
        }
        for(int j=1;j<=n;j++) dp[0][j]=max(dp[0][j], dp[1][j]);
        cout<<dp[0][n]<<" ";
    }
    cout<<endl;

    return 0;
}