#include<bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

const int MAXN=3005;
const int MOD=1e9+7;

int n;
long long p,q;
string s;

int fastPow(int x,int pwr)
{
    long long ret=1;
    while(pwr>0)
    {
        if(pwr%2) ret=ret*x%MOD;
        pwr/=2;
        x=1LL*x*x%MOD;
    }
    return ret;
}

int inv(int x)
{
    return fastPow(x,MOD-2);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    
    cin>>n;
    int pa,pb;
    cin>>pa>>pb;
    p=1LL*pa*inv(pb)%MOD;
    q=1LL*(pb-pa)*inv(pb)%MOD;
    cin>>s;

    if(s[0]=='1') swap(p,q);

//cout<<p<<" "<<q<<endl;

    long long s1=0;
    for(int i=1;i<=n;i++)
    {
        s1=(s1+1LL*i*((fastPow(p,i-1)*q)%MOD))%MOD;
    }
    s1=(s1+1LL*n*fastPow(p,n))%MOD;
    long long s2=0;
    s2=(1LL-p+MOD-q*(1LL-fastPow(p,n)+MOD)%MOD+MOD)%MOD;
    s2=s2*inv(1-p+MOD)%MOD;

    //cout<<s1<<" "<<s2<<endl;

    long long ans=s1*inv(s2)%MOD;
    cout<<ans<<endl;

    return 0;
}