#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn = 20000;

vector < bool > ans;
void code(int val)
{
    int st = 1;
    for (int i = 0; i <= 13; ++ i)
    {
        if(st & val)ans.push_back(1);
        else ans.push_back(0);
        st *= 2;
    }
}

map < int, pair < int, int > > mp;
unordered_set < int > s[maxn];
int used[maxn];
int m;
void dfs(int beg, int start)
{

   // cout << beg << " " << start << endl;
    if(start == beg)ans.push_back(0);
    else ans.push_back(1);
    code(beg);
    vector < int > del;
    for (auto nomer: s[beg])
    {
        //cout << "nomer " <<  nomer << endl;
        if(!used[nomer])
        {
            int sum = mp[nomer].first + mp[nomer].second;
            int other = sum - beg;
            used[nomer] = 1;
            del.push_back(nomer);
            dfs(other, start);
            break;
        }
        else del.push_back(nomer);

    }
    for (auto val: del)
        s[beg].erase(val);
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    ans.clear();
    m = edges.size();
    mp.clear();
    for (int i = 0; i < n; ++ i)
        s[i].clear();
    for (int i = 0; i < m; ++ i)
        used[i] = 0;
    ans.clear();
    int edgei = 0;

    for (auto &[from, to]: edges)
    {
        s[from].insert(edgei);
        s[to].insert(edgei);
        mp[edgei] = make_pair(from, to);
        edgei ++;
    }


    for (int i = 0; i < n; ++ i)
    {
        vector < int > del;
            for (auto val: s[i])
            {
                if(used[val])del.push_back(val);
            }
            for (auto val: del)
                s[i].erase(val);
        while(!s[i].empty())
        {
            dfs(i, i);
            vector < int > del;
            for (auto val: s[i])
            {
                if(used[val])del.push_back(val);
            }
            for (auto val: del)
                s[i].erase(val);
        }
    }
    //for (auto val: ans)
      //  cout << val;
   // cout << endl;
    return ans;
}

vector < bool > get_data(int i, vector < bool > &info)
{

    vector < bool > curr;

    for (int j = i; j <= i + 13; ++ j)
    {
        curr.push_back(info[j]);

    }
    //cout << curr.size() << endl;
    return curr;
}
int findval(vector < bool >&curr)
{
    int val = 0;
    long long st = 1;
    for (auto bit: curr)
    {
        if(bit)val += st;
        st *= 2;
    }
    return val;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector < pair < int, int > > res;

    vector < bool > info = data;
    int i = 0;
    vector < int > chain;
    while(i < info.size())
    {

        bool type = info[i];
        i ++;
        if(type == 0)
        {
            int last = -1;
            for (auto ver: chain)
            {
                if(last != -1)
                {
                    res.push_back(make_pair(last, ver));
                }
                last = ver;
            }
            chain.clear();
        }
       // cout << "type ready" << endl;
        vector < bool > curr = get_data(i, info);
        int v = findval(curr);
        chain.push_back(v);
        i += 14;
    }
   // cout << "on ended " << endl;
    int last = -1;
            for (auto ver: chain)
            {
                if(last != -1)
                {
                    res.push_back(make_pair(last, ver));
                }
                last = ver;
            }
            chain.clear();
   // for (auto &[x, y]: res)
       // cout << x << ", " << y << endl;
    return res;
}
