#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn = 20000;


void code(int val, vector < bool > & ans)
{
    int st = 1;
    for (int i = 0; i <= 13; ++ i)
    {
        if(st & val)ans.push_back(1);
        else ans.push_back(0);
        st *= 2;
    }

}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    assert(edges.size() <= n*2);
    vector < bool > ans;
    vector < int > g[n+1];
    for (int i = 0; i < n; ++ i)
        g[i].clear();
    for (auto &[x, y]: edges)
    {
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++ i)
    {
        //cout << i << " ";
        code(g[i].size(), ans);
        if(g[i].size() * 14 < n)
        {
            for (auto nb: g[i])
            {
                code(nb, ans);
            }
        }
        else
        {
            vector < bool > curr;
            for (int j = 0; j < n; ++ j)
            {
                curr.push_back(0);
            }
            for (auto nb: g[i])
                curr[nb] = 1;
            for (auto val: curr)
                ans.push_back(val);
        }
    }
    int sz = ans.size();
   // assert(sz == edges.size() * 14 + n * 14);
    //cout << endl;
    return ans;
}

vector < bool > get_data(int i, vector < bool > &info)
{
    //assert(i + 15 < info.size());

    vector < bool > curr;

    for (int j = i; j <= i + 13; ++ j)
    {
        curr.push_back(info[j]);

    }
    //cout << curr.size() << endl;
    return curr;
}
int findval(vector < bool >&curr)
{
    int val = 0;
    long long st = 1;
    // assert(curr.size() == 16);
    for (auto bit: curr)
    {
        if(bit)val += st;
        st *= 2;
    }
    return val;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector < pair < int, int > > res;

    vector < bool > info = data;
    /* for (auto x: info)
         cout << x << " ";
     cout << endl;*/
    int id = 0;
    for (int i = 0; i < n; ++ i)
    {
        vector < bool > curr;
        curr = get_data(id, info);
        id += 14;
        int sz = findval(curr);
        // cout << i << " " << sz << endl;
        if(sz * 14 < n)
        {
            for (int cnt = 1; cnt <= sz; ++ cnt)
            {
                vector < bool > nb = get_data(id, info);
                id += 14;
                int nn = findval(nb);
                res.push_back(make_pair(i, nn));
                //cout << i << " " << nn << endl;
            }
        }
        else
        {
            int val = 0;
            int krai = id + n;
            while(id < krai)
            {

                if(info[id])res.push_back(make_pair(i, val));
                val ++;
                id ++;
            }
            id = krai;
        }
    }
    // assert(res.size() > n-1);
    return res;
}
