#include <bits/stdc++.h>
#define endl '\n'
#define pb push_back
using namespace std;
const long long maxn = 2e3 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n, a[maxn];
void read()
{
    cin >> n;
    for (long long i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
}
long long last[maxn];
long long dp[maxn];
long long tmin[maxn * 4], tmax[maxn * 4];

void build(long long i, long long l, long long r)
{
    if(l == r)
    {
        tmin[i] = a[l];
        tmax[i] = a[r];
        return;
    }
    long long mid = (l + r)/2;
    build(2*i, l, mid);
    build(2*i+1, mid+1, r);

    tmin[i] = min(tmin[2*i], tmin[2*i+1]);
    tmax[i] = max(tmax[2*i], tmax[2*i+1]);
}
long long ql, qr;
long long querymin(long long i, long long l, long long r)
{
    if(qr < l || ql > r)return 1e9;
    if(ql <= l && r <= qr)return tmin[i];
    long long mid = (l + r)/2;
    return min(querymin(2*i, l, mid), querymin(2*i+1, mid+1, r));
}
long long querymax(long long i, long long l, long long r)
{
    if(qr < l || ql > r)return 0;
    if(ql <= l && r <= qr)return tmax[i];
    long long mid = (l + r)/2;
    return max(querymax(2*i, l, mid), querymax(2*i+1, mid+1, r));
}
long long cost(long long l, long long r)
{
    if(l > r)return 0;
   long long ans = 0;
    for (long long i = l; i < r; ++ i) // on l the last min
    {

       ql = l;
       qr = i;

       long long currmin = querymin(1, 1, n);
       ql = i+1;
       qr = r;
       long long currmax = querymax(1, 1, n);
       ans = max(currmax - currmin, ans);
    }

   // cout << l << " " << r << " " << ans << endl;
    return ans;
}
long long res;
void divide(long long l, long long r, long long optl, long long optr)
{
    //cout << l  << " " << r << " -> " << optl << " " << optr << endl;
    if(r < l)return;
    if(l == r)
    {

       long long best = 0;
        for (long long i = optl; i <= min(l, optr); ++ i)
        {
            long long curr = last[i] + cost(i, r);
            if(curr > best)best = curr;
        }
        dp[l] = best;
        res = max(best, res);
        return;
    }
    long long mid = (l + r)/2;
    long long bestopt = optl, best = 0;
    for (long long i = optl; i <= min(mid, optr); ++ i)
    {
        long long curr = last[i] + cost(i, mid);
        if(curr > best)
        {
            best = curr;
            bestopt = i;
        }
    }
    dp[mid] = best;
    res = max(best, res);
    divide(l, mid-1, optl, bestopt);
    divide(mid+1, r, bestopt, optr);
}
int main()
{

    speed();
    read();
    build(1, 1, n);
    for (long long i = 1; i <= n; ++ i)
    {
       // res = 0;
        for (long long j = 1; j <= n; ++ j)
        {
            last[j] = dp[j];
            dp[j] = 0;
        }

       /* for (int j = 1; j <= n; ++ j)
        {
            for (int from = 0; from <= j; ++ from)
            {
                dp[j] = max(dp[j], last[from] + cost(from + 1, j));
                res = max(dp[j], res);
            }
        }*/
       divide(1, n, 1, n);
      /* for (long long j = 1; j <= n; ++ j)
            cout << dp[j] << " ";
        cout << endl;*/
        cout << res << " " ;
    }
    cout << endl;
    return 0;
}
