#include<bits/stdc++.h>
#include "cactus.h"
#define ll long long
#define f first
#define s second
using namespace std;
const int maxn =16001;
int n;
bool been[10000010];
vector<pair<int,int>> edge[maxn];
vector<bool> ans;
int cntr[maxn];

void encoding(vector<int> path)
{
    for(auto e:path)
    {
        vector<bool> curr;
        int dumb=e;
        while(dumb)
        {
            curr.push_back(dumb&1);
            dumb=dumb>>1;
        }
        reverse(curr.begin(),curr.end());
        for(int i=curr.size();i<14;i++)
        {
            ans.push_back(0);
        }
        for(auto e:curr) ans.push_back(e);
    }
    for(int i=0;i<14;i++)
    {
        ans.push_back(1);
    }
}
void addone(int node)
{
    vector<bool> curr;
    int dumb=node;
    while(dumb)
    {
        curr.push_back(dumb&1);
        dumb=dumb>>1;
    }
    reverse(curr.begin(),curr.end());
    for(int i=curr.size(); i<14; i++)
    {
        ans.push_back(0);
    }
    for(auto e:curr) ans.push_back(e);
}
vector<int> path;
void dfs(int start)
{
    addone(start);
    for(auto e:edge[start])
    {
        if(cntr[e.f]%2==1) continue;
        if(been[e.s]) continue;
        cntr[start]--;
        cntr[e.f]--;
        been[e.s]=1;
        dfs(e.f);
        return;
    }
    for(auto e:edge[start])
    {
        if(been[e.s]) continue;
        been[e.s]=1;
        cntr[start]--;
        cntr[e.f]--;
        dfs(e.f);
        return;
    }
}
vector<bool> encode(int N, vector<pair<int, int>> edges)
{
    n=N;
    int cnt=0;
    for(int i=0;i<n;i++)
    {
        edge[i].clear();
        cntr[i]=0;
    }
    for(auto e:edges)
    {
        been[cnt]=0;
        edge[e.f].push_back({e.s,cnt});
        edge[e.s].push_back({e.f,cnt});
        cntr[e.f]++;
        cntr[e.s]++;
        cnt++;
    }
    ans.clear();
    for(int i=0;i<n;i++)
    {
        if(cntr[i]==1)
        {
            while(cntr[i]%2==1)
            {
                dfs(i);
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(cntr[i])
        {
            while(cntr[i])
            {
                dfs(i);
                encoding(path);
                path.clear();
            }
        }
    }
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    int sz=14;
    bool fl=0;
    vector<int> anss;
    vector<pair<int,int>> ed;
    anss.clear();
    for(int i=0;i<data.size();i++)
    {
        int stp=(1<<13);
        int curr=0;
        for(int j=i;j<i+14;j++)
        {
            curr+=stp*data[j];
            stp=stp>>1;
        }
        i=i+13;
        anss.push_back(curr);
    }

    for(int i=0;i<anss.size()-1;i++)
    {
        if(anss[i+1]!=16383)
        {
            ed.push_back({anss[i],anss[i+1]});
        }
        else i++;
    }
    return ed;
}


