#include<bits/stdc++.h>
#include "cactus.h"
#define ll long long
#define f first
#define s second
using namespace std;
const int maxn =16001;
int n;
bool been[10000010];
vector<pair<int,int>> edge[maxn];
vector<bool> ans;
int cntr[maxn];
void encoding(vector<int> path)
{
    for(auto e:path)
    {
        vector<bool> curr;
        int dumb=e;
        while(dumb)
        {
            curr.push_back(dumb%2);
            dumb=dumb>>1;
        }
        reverse(curr.begin(),curr.end());
        for(int i=curr.size();i<14;i++)
        {
            ans.push_back(0);
        }
        for(auto e:curr) ans.push_back(e);
    }
    for(int i=0;i<14;i++)
    {
        ans.push_back(1);
    }
}
void addone(int node)
{
    vector<bool> curr;
    int dumb=node;
    while(dumb)
    {
        curr.push_back(dumb%2);
        dumb=dumb>>1;
    }
    reverse(curr.begin(),curr.end());
    for(int i=curr.size(); i<14; i++)
    {
        ans.push_back(0);
    }
    for(auto e:curr) ans.push_back(e);
}

int dfs(int start,int parent)
{
    addone(start);
    int cnt=0;
    int sz=1;
    for(auto e:edge[start])
    {
        cnt++;
        if(e.f==parent || been[e.s]) continue;
        cntr[start]--;
        cntr[e.f]--;
        been[e.s]=1;
        been[e.s]=1;
        sz+=dfs(e.f,start);
        if(cnt!=edge[start].size())
        {
            addone(16383);
            addone(start);
        }
    }
    return sz;
}
bool bfs(int start)
{
    queue<int> q;
    vector<bool> visited(n,0);
    vector<pair<int,int>> parent(n,{0,0});
    vector<int> depth(n,0);
    depth[start]=1;
    q.push(start);
    parent[start]={start,-1};
    visited[start]=1;
    int a1=-1,a2;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        bool fl=0;
        for(auto e:edge[curr])
        {
            if(been[e.s]) continue;
            if(visited[e.f])
            {
                if(e.f==parent[curr].f) continue;
                a1=e.f;
                a2=curr;
                been[e.s]=1;
                fl=1;
                break;
            }
            q.push(e.f);
            parent[e.f]={curr,e.s};
            depth[e.f]=depth[curr]+1;
            visited[e.f]=1;
        }
        if(fl) break;
    }
    if(a1==-1)
    {
       // printf("will return false\n");
        int cntr=dfs(start,start);
        if(cntr==1)
        {
            for(int i=0;i<14;i++) ans.pop_back();
            return false;
        }
        addone(16383);
        return false;
    }
    vector<int> left;
    left.clear();
    int st1=a1,st2=a2;
    if(depth[a1]>depth[a2])
    {
        a1=parent[a1].f;
    }
    if(depth[a1]<depth[a2])
    {
        a2=parent[a2].f;
    }
    while(a2!=a1)
    {
        a2=parent[a2].f;
        a1=parent[a1].f;
    }
    while(st1!=a1)
    {
        left.push_back(st1);
        cntr[st1]-=2;
        been[parent[st1].s]=1;
        st1=parent[st1].f;
    }
    left.push_back(a1);
    reverse(left.begin(),left.end());
    while(st2!=a1)
    {
        left.push_back(st2);
        cntr[st2]-=2;
        been[parent[st2].s]=1;
        st2=parent[st2].f;
    }
    left.push_back(a1);
    cntr[a1]-=2;
    //for(auto e:left) cntr[e]-=2;
    encoding(left);
    //printf("returned true\n");
    return true;
}
vector<bool> encode(int N, vector<pair<int, int>> edges)
{
    n=N;
    int cnt=0;
    for(int i=0;i<n;i++)
    {
        edge[i].clear();
        cntr[i]=0;
    }
    for(auto e:edges)
    {
        been[cnt]=0;
        edge[e.f].push_back({e.s,cnt});
        edge[e.s].push_back({e.f,cnt});
        cntr[e.f]++;
        cntr[e.s]++;
        cnt++;
    }
    ans.clear();
   // printf("done edges trtrtrtrt\n");
    for(int i=0;i<n;i++)
    {
        if(cntr[i]>=2)
        {

           // bfs(i);
            while(cntr[i]>=2)
            {
                if(!bfs(i)) break;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(cntr[i]>0)
        {
            int cn=dfs(i,i);
            if(cn==1)
            {
                for(int i=0;i<14;i++) ans.pop_back();
                continue;
            }
            addone(16383);
        }
    }
   // printf("did encoding\n");
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
   // printf("data size is %d\n",data.size());
    int sz=14;
    bool fl=0;
    vector<int> anss;
    vector<pair<int,int>> ed;
    anss.clear();
    for(int i=0;i<data.size();i++)
    {
        int stp=(1<<13);
        int curr=0;
        for(int j=i;j<i+14;j++)
        {
            curr+=stp*data[j];
            stp=stp>>1;
        }
        i=i+13;
        anss.push_back(curr);
    }
   // for(auto e:anss) printf("%d ",e);
   // printf("\n");
    for(int i=0;i<anss.size()-1;i++)
    {
        if(anss[i+1]!=16383)
        {
           // if(aded[{anss[i+1],anss[i]}] || aded[{anss[i],anss[i+1]}]) continue;
           // aded[{anss[i+1],anss[i]}]=aded[{anss[i],anss[i+1]}]=1;
            ed.push_back({anss[i],anss[i+1]});
        }
        else i++;
    }
    return ed;
}

