#include<bits/stdc++.h>
#include "cactus.h"
#define ll long long
#define f first
#define s second
using namespace std;
const int maxn =16001;
int n;
bool been[maxn][maxn];
bool aded[maxn][maxn];
vector<int> edge[maxn];
vector<bool> ans;
int cntr[maxn];
bool used[maxn];
void encoding(vector<int> path)
{
    for(auto e:path)
    {
        vector<bool> curr;
        int dumb=e;
        while(dumb)
        {
            curr.push_back(dumb%2);
            dumb=dumb>>1;
        }
        reverse(curr.begin(),curr.end());
        for(int i=curr.size();i<14;i++)
        {
            ans.push_back(0);
        }
        for(auto e:curr) ans.push_back(e);
    }
    for(int i=0;i<14;i++)
    {
        ans.push_back(1);
    }
}
void addone(int node)
{
    vector<bool> curr;
    int dumb=node;
    while(dumb)
    {
        curr.push_back(dumb%2);
        dumb=dumb>>1;
    }
    reverse(curr.begin(),curr.end());
    for(int i=curr.size(); i<14; i++)
    {
        ans.push_back(0);
    }
    for(auto e:curr) ans.push_back(e);
}
void dfs(int start,int parent)
{
    addone(start);
    int cntr=0;
    for(auto e:edge[start])
    {
        cntr++;
        if(e==parent || been[start][e]||been[e][start]) continue;
        been[e][start]=1;
        been[start][e]=1;
        dfs(e,start);
        if(cntr!=edge[start].size())
        {
            addone(start);
            //cntr++;
        }
    }
}
bool bfs(int start)
{
   // printf("in bfs with %d\n",start);
    queue<int> q;
    vector<bool> visited(n,0);
    vector<int> parent(n,0);
    vector<int> depth(n,0);
    depth[start]=1;
    q.push(start);
    parent[start]=start;
    visited[start]=1;
    int a1=-1,a2;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        bool fl=0;
        for(auto e:edge[curr])
        {
            if(been[curr][e] || been[e][curr]) continue;
            if(visited[e])
            {
                if(e==parent[curr]) continue;
                a1=e;
                a2=curr;
                fl=1;
                break;
            }
            q.push(e);
            parent[e]=curr;
            depth[e]=depth[curr]+1;
            visited[e]=1;
        }
        if(fl) break;
    }
    if(a1==-1)
    {
       // printf("return false with %d\n",start);
        dfs(start,start);
        addone(16383);
        return false;
    }
  //  printf("went trough first\n");
    vector<int> left;
   // printf("found cycle with %d %d\n",a1,a2);
    int st1=a1,st2=a2;
    if(depth[a1]>depth[a2])
    {
        a1=parent[a1];
    }
    if(depth[a1]<depth[a2])
    {
        a2=parent[a2];
    }
    while(a2!=a1)
    {
        a2=parent[a2];
        a1=parent[a1];
    }
    //left.push_back(a1);
    while(st1!=a1)
    {
        left.push_back(st1);
        st1=parent[st1];
    }
    left.push_back(a1);
    reverse(left.begin(),left.end());
    while(st2!=a1)
    {
        left.push_back(st2);
        st2=parent[st2];
    }
    left.push_back(a1);
    for(int i=0;i<left.size()-1;i++)
    {
        been[left[i]][left[i+1]]=been[left[i+1]][left[i]]=1;
    }
    encoding(left);
   // printf("left: ");
    //for(auto e:left) printf("%d ",e);
   // printf("\n");
   // printf("returned true with %d\n",start);
    return true;
}
vector<bool> encode(int N, vector<pair<int, int>> edges)
{
    n=N;
    for(auto e:edges)
    {
        edge[e.f].push_back(e.s);
        edge[e.s].push_back(e.f);
        cntr[e.f]++;
        cntr[e.s]++;
    }
    for(int i=0;i<n;i++)
    {
        if(cntr[i]>2)
        {
           // bfs(i);
            while(true)
            {
                if(!bfs(i)) break;
            }
        }
    }
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    int sz=14;
    bool fl=0;
    vector<int> anss;
    vector<pair<int,int>> ed;
    anss.clear();
    for(int i=0;i<data.size();i++)
    {
        int stp=(1<<13);
        int curr=0;
        for(int j=i;j<i+14;j++)
        {
            curr+=stp*data[j];
            stp=stp>>1;
        }
        i=i+13;
        anss.push_back(curr);
    }
    //for(auto e:anss) printf("%d ",e);
    //printf("\n");
    for(int i=0;i<anss.size()-1;i++)
    {
        if(anss[i+1]!=16383)
        {
            if(aded[anss[i+1]][anss[i]] || aded[anss[i]][anss[i+1]]) continue;
            aded[anss[i+1]][anss[i]]=aded[anss[i]][anss[i+1]]=1;
            ed.push_back({anss[i],anss[i+1]});
        }
        else i++;
    }
    return ed;
}

