#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
using namespace std;
const lli MAXN=10005, INF=-999999999;
lli N, ans[MAXN], a[MAXN], p[MAXN], par[MAXN], sz[MAXN], price[MAXN];
struct node{
    lli x, ind1, ind2, qq;
};
node tree[4*MAXN];
node t[MAXN];
void build(lli ind, lli l, lli r){
    if(l==r){
        if(t[l].x==0){
            tree[ind]={INF, l, l, l};
            return;
        }
        tree[ind]=t[l];
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    if(tree[2*ind].x>=tree[2*ind+1].x){
        tree[ind]=tree[2*ind];
    }else{
        tree[ind]=tree[2*ind+1];
    }
    return;
}
void update(lli ind, lli l, lli r, lli q, lli d){
    if(l>q or r<q)return;
    if(l==r){
        tree[ind].x=d;
        return;
    }
    lli mid=(l+r)/2;
    update(2*ind, l, mid, q, d);
    update(2*ind+1, mid+1, r, q, d);
    if(tree[2*ind].x>=tree[2*ind+1].x){
        tree[ind]=tree[2*ind];
    }else{
        tree[ind]=tree[2*ind+1];
    }
    return;
}
bool update_left(lli ind, lli l, lli r, lli q, lli d, lli rb){
    if(l>q)return false;
    if(tree[ind].x==INF)return false;
    if(l==r){
        tree[ind].x+=d;
        tree[ind].ind2=rb;
        return true;
    }
    lli mid=(l+r)/2;
    bool fl=0;
    if(update_left(2*ind+1, mid+1, r, q, d, rb))fl=1;
    else if(update_left(2*ind, l, mid, q, d, rb)) fl=1;
    if(tree[2*ind].x>=tree[2*ind+1].x){
        tree[ind]=tree[2*ind];
    }else{
        tree[ind]=tree[2*ind+1];
    }
    return fl;
}
bool update_right(lli ind, lli l, lli r, lli q, lli d, lli lb){
    if(r<q)return false;
    if(tree[ind].x==INF)return false;
    if(l==r){
        tree[ind].x+=d;
        tree[ind].ind1=lb;
        return true;
    }
    lli mid=(l+r)/2;
    bool fl=0;
    if(update_right(2*ind, l, mid, q, d, lb)) fl=1;
    else if(update_right(2*ind+1, mid+1, r, q, d, lb))fl=1;
    if(tree[2*ind].x>=tree[2*ind+1].x){
        tree[ind]=tree[2*ind];
    }else{
        tree[ind]=tree[2*ind+1];
    }
    return fl;
}

lli find_parent(lli x){
    if(par[x]==x)return x;
    return par[x]=find_parent(par[x]);
}
lli find_price(lli x){
    lli rootx=find_parent(x);
    return price[x];
}
void merge_v(lli x, lli y){
    lli rootx=find_parent(x), rooty=find_parent(y);
    if(sz[rootx]>sz[rooty]){
        par[rooty]=rootx;
        sz[rootx]+=sz[rooty];
        price[rootx]+=price[rooty];
    }else{
        par[rootx]=rooty;
        sz[rooty]+=sz[rootx];
        price[rooty]+=price[rootx];
    }
    return;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N;
    for(lli i=0; i<N; i++){
        cin>>p[i];
        if(i!=0)a[i]=p[i]-p[i-1];
        sz[i]=1;
        par[i]=i;
        price[i]=a[i];
    }
    lli boats=0, sum=0, now=0, start=0;
    for(lli i=1; i<N; i++){
        //cout<<a[i]<<endl;
        if(a[i]>0){
            now=0;
            start=0;
            if(a[i-1]>0){
                sum+=a[i];
            }else{
                sum+=a[i];
                boats++;
            }
        }else{
            if(start==0)start=i;
            if(a[i+1]<0){
                now+=a[i];
                continue;
            }
            now+=a[i];
            if(start==1 or i==N-1)continue;
            t[i]={now, start, i, i};
        }
    }
    for(lli i=1; i<N; i++){
        //cout<<t[i].x<<" "<<t[i].ind1<<" "<<t[i].ind2<<" "<<t[i].qq<<endl;
    }
    //cout<<endl;
    build(1, 0, N-1);
    for(lli k=N; k>=boats; k--){
        ans[k]=sum;
    }
    for(lli k=boats-1; k>0; k--){
        node curr=tree[1];
        //cout<<k<<" "<<curr.x<<" "<<curr.ind1<<" "<<curr.ind2<<" "<<curr.qq<<endl;
        lli l=curr.ind1-1, r=curr.ind2+1;
        lli prl=find_price(l), prr=find_price(r);
        if(prl<(-curr.x) and prr<(-curr.x)){
            if(prl<prr){
                update(1, 0, N-1, curr.qq, INF);
                update_left(1, 0, N-1, curr.qq, prl+curr.x, curr.ind2);
                sum-=prl;
            }else{
                update(1, 0, N-1, curr.qq, INF);
                update_right(1, 0, N-1, curr.qq, prr+curr.x, curr.ind1);
                sum-=prr;
            }
        }else if(prl<(-curr.x)){
            update(1, 0, N-1, curr.qq, INF);
            update_left(1, 0, N-1, curr.qq, prl+curr.x, curr.ind2);
            sum-=prl;
        }else if(prr<(-curr.x)){
            update(1, 0, N-1, curr.qq, INF);
            update_right(1, 0, N-1, curr.qq, prr+curr.x, curr.ind1);
            sum-=prr;
        }else{
            sum+=curr.x;
            update(1, 0, N-1, curr.qq, INF);
            update_left(1, 0, N-1, curr.qq, 0, curr.ind2);
        }
        ans[k]=sum;
    }
    for(lli i=1; i<=N; i++){
        cout<<ans[i]<<" ";
    }
    cout<<endl;
    return 0;
}
