#include "cactus.h"
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 16000 + 42;
const int mod = 1e7 + 9;


std::vector< int > path;

const int LEN = 13;

int tt = 1;
int indC = 0;
std::vector< int > currCycle[MAX_N];
int viz[MAX_N];
std::vector< int > v[MAX_N];
//bool inC[MAX_N][MAX_N];
std::set< int > inC[MAX_N];
void dfs( int x, int par ){

    cerr << out( x ) << out( par ) << endl;
    for( auto j : path ) cerr << j << " ";
    cerr << endl << endl;
    viz[x] = tt;
    path.push_back( x );
    for( auto j : v[x] ){
        cerr << out( x ) << out( par ) << out( j ) << endl;
        if( j == par ) continue;
        if( viz[j] == tt ){
            if( inC[x].find( j ) != inC[x].end() ) continue;
            // cikal
            for( int i = path.size() - 1 ; i >= 0  ; i-- ){
                currCycle[indC].push_back( path[i] );
                if( path[i] == j ) break;
            }

            for( int i=0 ; i < currCycle[indC].size() ; i++ ){
                int nxt = ( i + 1 );
                if( i == ( (int)currCycle[indC].size() - 1) ) nxt = 0;
                inC[ currCycle[indC][i] ].insert( currCycle[indC][nxt] );
                inC[ currCycle[indC][nxt] ].insert( currCycle[indC][i] );

                //inC[ currCycle[indC][i] ][ currCycle[indC][nxt] ] = true;
                //inC[ currCycle[indC][nxt] ][ currCycle[indC][i] ] = true;
                cerr << out( currCycle[indC][i] ) << out( currCycle[indC][nxt] ) <<endl;
            }

            //cerr << out( indC ) << endl;
            //for( auto j : currCycle[indC] ) cerr << j << " ";
            //cerr << endl;

            indC ++;
        }else dfs( j, x );
    }

    if( !path.empty() ) path.pop_back();
}

void toBits( int x, std::vector< bool >& nas ){

    for( int i=0 ; i < LEN ; i++ ){
        if( x & ( 1 << i ) ) nas.push_back( true );
        else nas.push_back( false );
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){

    indC = 0;
    for( int i=0 ; i <= n ; i++ ){
        v[i].clear();
        currCycle[i].clear();
        viz[i] = 0;
        inC[i].clear();
        //for( int j=i ; j <= n ; j++ ) inC[i][j] = inC[j][i] = false;
    }

    for( auto& j : edges ){
        v[j.first].push_back( j.second );
        v[j.second].push_back( j.first );
    }

    path.clear();
    dfs( 0, 0 );

    /*
    cerr << out( indC ) << endl;
    for( int i=0 ; i < indC ; i++ ){
        cerr << out( i ) << endl;
        for( auto j : currCycle[i] ) cerr << j << " ";
        cerr << endl << endl;
    }
    cerr << endl;
    */

    std::vector< bool > nas;
    toBits( indC, nas );

    //for( auto j : nas ) cerr << j << " ";
    //cerr << endl;

    cerr << out( indC ) << endl;
    for( int i=0 ; i < indC ; i++ ){
        toBits( (int)currCycle[i].size(), nas );
        for( auto j : currCycle[i] ) toBits( j, nas );
    }

    std::vector< std::pair< int, int > > add;
    cerr << " ananasko " << endl;
    for( auto j : edges ){
        if( inC[j.first].find( j.second ) == inC[j.first].end() ){
            cerr << j.first << " " << j.second << endl;
            add.push_back( j );
        }
    }

    toBits( add.size(), nas );
    for( auto j : add ){
        toBits( j.first, nas );
        toBits( j.second, nas );
    }

    return nas;
}



int indR = 0;
int readBits( const std::vector< bool >& data ){
    ll ret = 0;
    for( int i = indR ; i < indR + LEN ; i ++ ){
        if( data[i] ) ret |= ( 1 << ( i - indR ) );
    }

    indR += LEN;
    return ret;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){

    std::vector< std::pair< int, int > > nas;
    indR = 0;
    int numC = readBits( data );
    for( int i=0 ; i < numC ; i++ ){
        int k = readBits( data );
        int prv = -1;
        std::vector< int > curr( k );
        for( int j=0 ; j < k ; j++ ){
            curr[j] = readBits( data );
        }

        cerr << out( i ) << out( k ) << endl;
        //for( auto j : curr ) cerr << j << " ";
        cerr << endl;

        for( int j=0 ; j < k ; j++ ){
            if( j == 0 ) nas.push_back({ curr[j], curr.back() });
            else nas.push_back({ curr[j], curr[j-1] });
        }
    }

    int numE = readBits( data );
    for( int i=0 ; i < numE ; i++ ){
        int a, b;
        a = readBits( data );
        b = readBits( data );
        cerr << out( a ) << out( b ) << endl;
        nas.push_back({ a, b });
    }

    return nas;
}