#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 1e4 + 42;
const int mod = 1e7 + 9;

std::pair< ll, int > dp[MAX_N];

int main() {
#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);
#endif // LOCAL

    int n;
    std::cin >> n;
    std::vector< int > a( n+1 );
    for( int i=1 ; i <= n ; i++ ) std::cin >> a[i];

    std::vector< int > c( n + 1 );

    for( int i=1 ; i <= n ; i++ ){
        for( int l=1 ; l < i ; l++ ){
            std::pair< ll, int > curr = dp[l-1];
            curr.first += a[i] - a[l];
            curr.second += 1;
            if( chkmax( dp[i], curr )){
                c[i] = l;
            }
        }
        if( chkmax( dp[i], dp[i-1] ) ) c[i] = -1;
        cerr << out( i ) << out( c[i] ) << out( dp[i].first ) << endl;
    }
    cerr << out( dp[n].first ) << endl;

    std::cout << endl;

    int currInd = n;
    std::priority_queue< ll > pq;
    int A = -1;
    while( currInd > 1 ){
        if( c[currInd] == -1 ) currInd -= 1;
        else{
            cerr << out( a[currInd] ) << " - " << out( a[ c[currInd] ] ) << endl;
            if( A != -1 ){
                pq.push( -( a[currInd] - A ) );
                cerr << out( a[currInd] ) << out( A ) << endl;
            }
            A = a[c[currInd]];
            currInd = c[currInd];
        }
    }

    std::vector< ll > nas( n );
    ll currNas = dp[n].first;
    for( int i=0 ; i < dp[n].second ; i++ ){
        cerr << out( pq.top() ) << endl;
        currNas += pq.top();
        pq.pop();
        nas[ dp[n].second  - i ] = currNas;
    }
    for( int i=dp[n].second ; i <= n ; i++ ) nas[i] = dp[n].first;


    for( int i=1 ; i <= n ; i++ ) std::cout << nas[i] << " ";
    std::cout << endl;

    return 0;
}
