#include <iostream>
#include <algorithm>
#include "cactus.h"
#include <vector>
using namespace std;
bool el(pair<int,int> a,pair<int,int> b){
    if(a.first==b.first){
        return a.second<b.second;
    }
    return a.first<b.first;
}
vector<bool> transformtobinary(int a){
    vector<bool> c;
    int b=(1<<13);
    while(b>0){
        if(a>=b){
            c.push_back(1);
            a-=b;
        }else c.push_back(0);
        b=b>>1;
    }
    return c;
}
vector<bool> encode(int n, vector<pair<int, int>> edges){
    bool imaLi[16005];
    vector<bool> s;
    for(int i=0;i<edges.size();i++){
        if(edges[i].first>edges[i].second){
            swap(edges[i].first,edges[i].second);
        }
    }
    sort(edges.begin(),edges.end(),el);
    /////////////
    vector<bool> curr;
    vector<bool> ans;
    imaLi[0]=true;
    int last1=0;
    for(auto p:edges){
        if(p.first!=last1){
            imaLi[p.first]=true;
            s.push_back(1);
            last1=p.first;
        }else s.push_back(0);
        curr = transformtobinary(p.second);
        for(int i=0;i<14;i++){
            s.push_back(curr[i]);
        }
    }
    for(int i=0;i<n;i++){
        ans.push_back(imaLi[i]);
    }
    for(auto p:s){
        ans.push_back(p);
    }
    return ans;
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    vector<int> nachalni;
    int ind = 0;
    for(ind=0;ind<n;ind++){
        if(data[ind]){
            nachalni.push_back(ind);
        }
    }
    vector<pair<int, int>> edges;
    int b = (1<<13);
    int a;
    int currv = 0;
    int indvnach=1;
    while(ind<data.size()){
        b = (1<<13); a=0;
        if(data[ind]==1){
            currv=nachalni[indvnach];
            indvnach++;
        }
        ind++;
        for(int i=0;i<14;i++){
            if(data[ind+i]==1){
                a+=b;
            }
            b=(b>>1);
        }
        ind+=14;
        edges.push_back({currv,a});
    }
    return edges;
}
