#include<iostream>
#include "cactus.h"
using namespace std;
int st[1005];
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<bool> r;
    r.resize(14*edges.size()*2);
    int a,next,pr=-1;

    for(int i=0;i<edges.size();i++)
    {
        a=edges[i].first;

        next=pr+14;
        while(a>0)
        {
            r[next]=a%2;
            next--;
            a/=2;
        }
        pr+=14;


        a=edges[i].second;

        next=pr+14;
        while(a>0)
        {
            r[next]=a%2;
            next--;
            a/=2;
        }
        pr+=14;
    }
   // for(int i=0;i<r.size();i++)
   //     cout<<r[i];
   // cout<<endl;

    return r;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int, int> > rez;

    st[0]=1;
    for(int i=1;i<=18;i++)
        st[i]=2*st[i-1];

    int next=-1,a,b;

    for(;;)
    {
        next+=14;
        if(next>=data.size()) break;
        a=0;

        for(int j=next;j>=next-13;j--)
        {
            a+=st[next-j]*data[j];
        }
        b=0;
        next+=14;

        if(next>=data.size()) break;
        for(int j=next;j>=next-13;j--)
        {
            b+=st[next-j]*data[j];
        }
       // cout<<a<<" "<<b<<endl;
        rez.push_back({a,b});
    }
    return rez;
}
/*
1
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/
