#include "cactus.h"

#include <iostream>
#include <algorithm>

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
std::vector<bool> ans;
for(auto p:edges){
    for(int i=1;i<=14;i++){
    ans.push_back(p.first%2);
    p.first=p.first>>1;
    }
    for(int i=1;i<=14;i++){
    ans.push_back(p.second%2);
    p.second=p.second>>1;
    }
}
return ans;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
std::vector<std::pair<int,int>> ans;
for(int i=data.size()-1;i>=0;i-=28){
    std::pair<int,int> t={0,0};
    for(int p=i;(i-p)<=13;p--){
        t.first=t.first<<1;
        t.first+=data[p];
    }
    for(int p=i-14;(i-p)<=27;p--){
        t.second=t.second<<1;
        t.second+=data[p];
    }
    ans.push_back(t);
}
return ans;
}