#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn=16005;
vector<pair<int,int>> g[maxn];
bitset<50000> used;
int br[maxn];
int factors_two[14];
vector<int> tourA;
void tour(int vr)
{
    stack<pair<int,int>> st;
    st.push({vr,-1});
    bool t=0;
    while(!st.empty())
    {
        vr=st.top().first; 
        int parent =st.top().second;
        if(br[vr]==g[vr].size())
        {
            if(!t) tourA.push_back(vr);
            t=1;
            if(tourA[tourA.size()-1]!=16383)tourA.push_back(16383);
            st.pop();
            continue;
        }
        if(g[vr][br[vr]].first==parent){br[vr]++;continue;}
        tourA.push_back(vr);
        if(!used[g[vr][br[vr]].second])
        {
            t=0;
            used.set(g[vr][br[vr]].second);
            st.push({g[vr][br[vr]].first,vr});
            br[vr]++;
        }
    }    
}

vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    tourA.clear();  
    for(int i=0;i<edges.size();i++)
    {
        used.reset(i);
        g[edges[i].first].push_back({edges[i].second,i});
        g[edges[i].second].push_back({edges[i].first,i});
    }  
    vector<bool> ans;
    factors_two[0]=1;
    tour(0);
    for(int i=1;i<=13;i++)factors_two[i]=factors_two[i-1]*2;
    for(int i=1;i<tourA.size();i++)
    {
        // cout<<tourA[i]<<" ";
        int k=13;
        for(int j=0;j<14;j++)
        {
            ans.push_back(factors_two[k--]&tourA[i]);
        }
    }
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int,int>> ans;
    int a=0,b=0;
    int i=0;
    factors_two[0]=1;
    for(int i=1;i<=13;i++)factors_two[i]=factors_two[i-1]*2;
    for(;i<data.size();)
    {
        int k=13;
        for(int j=0;j<14;j++,i++)
        {
            // cout<<data[i];
            b+=factors_two[k--]*data[i];
        }
        // cout<<endl;
        if(a!=16383&&b!=16383)ans.push_back({a,b});
        a=b;
        b=0;
    }
//    for(int i=0;i<ans.size();i++)
//     {
//         cout<<ans[i].first<<" "<<ans[i].second<<endl;
//     }
    return ans;
}