#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;
const int maxn=16005;
vector<int> g[maxn];
vector<int> tourA;
map<pair<int,int>,int> used;
int br[maxn];
void tour(int vr)
{
    // cout<<vr<<endl;
    stack<pair<int,int>> st;
    st.push({vr,-1});
    bool t=0;
    while(!st.empty())
    {
        vr=st.top().first;
        int parent =st.top().second;
        if(br[vr]==g[vr].size())
        {
            if(!t) tourA.push_back(vr);
            t=1;
            if(tourA[tourA.size()-1]!=16383)tourA.push_back(16383);
            st.pop();
            continue;
        }
        if(g[vr][br[vr]]==parent){br[vr]++;continue;}
        tourA.push_back(vr);
        if(!used[{vr,g[vr][br[vr]]}]&&!used[{g[vr][br[vr]],vr}])
        {
            t=0;
            used[{vr,g[vr][br[vr]]}]=1;
            st.push({g[vr][br[vr]],vr});
            br[vr]++;
        }
    }    
}
vector<bool> toBin(int a)
{
    vector<bool> ret;
    while(a)
    {
        ret.push_back(a%2);
        a/=2;
    }
    reverse(ret.begin(),ret.end());
    return ret;
}
int factors_two[14];
vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    for(int i=0;i<n;i++)
    {
        g[i].clear();
    }
    // used.clear();
    tourA.clear();  
    for(int i=0;i<edges.size();i++)
    {
        used[{edges[i].first,edges[i].second}]=0;
        used[{edges[i].second,edges[i].first}]=0;
        g[edges[i].first].push_back(edges[i].second);
        g[edges[i].second].push_back(edges[i].first);
    }  
    tour(0);
    vector<bool> ans;
    factors_two[0]=1;
    for(int i=1;i<=13;i++)factors_two[i]=factors_two[i-1]*2;
    /*for(int i=1;i<tourA.size();i++)
    {
        //cout<<tourA[i]<<" ";
        int k=13;
        for(int j=0;j<14;j++)
        {
            ans.push_back(factors_two[k--]&tourA[i]);
        }
    }*/
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int,int>> ans;
    int a=0,b=0;
    int base2 = 1<<13;
    int i=0;
    factors_two[0]=1;
    for(int i=1;i<=13;i++)factors_two[i]=factors_two[i-1]*2;
    for(;i<data.size();)
    {
        int k=13;
        for(int j=0;j<14;j++,i++)
        {
            // cout<<data[i];
            b+=factors_two[k--]*data[i];
        }
        // cout<<endl;
        if(a!=16383&&b!=16383)ans.push_back({a,b});
        a=b;
        b=0;
    }
    // for(int i=0;i<ans.size();i++)
    // {
    //     cout<<ans[i].first<<" "<<ans[i].second<<endl;
    // }
    return ans;
}