#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;

const int maxn = 16002, maxb = 16;
int pw[maxb];

string to_2(int num)
{
    //cout << num << " - " ;
    string s = "00000000000000";
    int pos = 13;
    do
    {
        if (num&1)
            s[pos] = '1';
        -- pos;
        num >>= 1;
    }while (num);
    //cout << s << '\n' ;
    return s;
}

void add_to_ans(vector<bool>&ans, string s)
{
    int i, len = 14;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '0')
            ans.push_back(false);
        else
            ans.push_back(true);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    int m = (int)(edges.size()), i, x, y;
    vector <bool> ans;
    for (i=0; i<m; ++i)
    {
        x = edges[i].first;
        y = edges[i].second;
        add_to_ans(ans, to_2(x));
        add_to_ans(ans, to_2(y));
    }
    return ans;
}

void init()
{
    int i;
    pw[0] = 1;
    for (i=1; i<maxb; ++i)
        pw[i] = pw[i-1] * 2;
}

int to_10(string s)
{
    int i, len = 14, res = 0;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '1')
            res += (pw[13-i]);
    }
    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector <pair<int, int>> ans;
    init();
    int i, len = (int)(data.size()), j, x = -1, y = -1, num;
    string s;
    for (i=0; i<len; i+=14)
    {
        s = "00000000000000";
        for (j=i; j<i+14; ++j)
        {
            if (data[j])
                s[j%14] = '1';
        }

        num = to_10(s);
        if (x != -1 && y != -1)
            x = -1, y = -1;
        if (x == -1)
            x = num;
        else
        {
            y = num;
            ans.push_back({x, y});
        }
    }
    return ans;
}

/*

1
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10

*/