#include<iostream>
#include<vector>
#include"cactus.h"
using namespace std;

vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    vector<bool> ans;  //13 bita na chislp
    ans.resize(26*edges.size());
    long ind,br=1;
    for(auto a:edges)
    {   ind=(br-1)*13+12;
        while(a.first>1)
        {
            if(a.first&1)ans[ind]=true;
            else ans[ind]=false;
            a.first>>=1;
            ind--;
        }
        if(a.first&1)ans[ind]=true;
        else ans[ind]=false;
        br++;
        ind=(br-1)*13+12;
        while(a.second>1)
        {
            if(a.second&1)ans[ind]=true;
            else ans[ind]=false;
            a.second>>=1;
            ind--;
        }
        if(a.second&1)ans[ind]=true;
        else ans[ind]=false;
        br++;
    }
   /* for(auto h:ans) cout<<h<<" ";
    cout<<endl;*/
    return ans;
}
vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int, int>> ans;
    long brrebra=data.size()/26;
  //  cout<<brrebra<<"    b"<<endl;
    for(int i=0;i<brrebra*26;i=i+26)
    {
        long step=1,v1=0,v2=0;
        for(int ii=i+12;ii>=i;ii--)
        {
            if(data[ii]) v1+=step;
            if(data[ii+13]) v2+=step;
            step<<=1;
        }
        ans.push_back({v1,v2});
    //    cout<<v1<<"  "<<v2<<" i "<<i<<endl;
    }
    return ans;
}
