#define _GLIBCXX_FILESYSTEM
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
string chisla[16028];
string pravi(int x){
    if(x==0){
        return "0";
    }
    string st="";
    while(x!=0){
        if(x%2==1){
            st+='1';
        }else{
            st+='0';
        }
        x/=2;
    }
    return st;
}
string stope;
void build(int br){
    for(int i=0;i<br;i++){
        chisla[i]=pravi(i);
    }
    stope+=pravi(115);
    stope+=pravi(116);
    stope+=pravi(111);
    stope+=pravi(112);
}
int ch(string cr){
    int res=0;
    for(int i=(int)cr.size()-1;i>=0;i--){
        if(cr[i]=='1'){
            res+=(1<<i);
        }
    }
    return res;
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){
    build(n);
    vector<bool> res;
    for(int i=0;i<(int)edges.size();i++){
        int u=edges[i].first;
        int v=edges[i].second;
        for(int j=chisla[u].size()-1;j>=0;j--){
            if(chisla[u][j]=='1'){
                res.push_back(1);
            }else{
                res.push_back(0);
            }
        }
        for(int j=stope.size()-1;j>=0;j--){
            if(stope[j]=='1'){
                res.push_back(1);
            }else{
                res.push_back(0);
            }
        }
        for(int j=chisla[v].size()-1;j>=0;j--){
            if(chisla[v][j]=='1'){
                res.push_back(1);
            }else{
                res.push_back(0);
            }
        }
        for(int j=stope.size()-1;j>=0;j--){
            if(stope[j]=='1'){
                res.push_back(1);
            }else{
                res.push_back(0);
            }
        }
    }
    return res;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    vector<pair<int,int>> res;
    string danni;
    build(n);
    for(int i=0;i<data.size();i++){
        if(data[i]){
            danni+='1';
        }else{
            danni+='0';
        }
    }
    for(int i=0;i<danni.size();i++){
        if(i+stope.size()>danni.size()){
            break;
        }
        int id=i;
        string u,v;
        while(!operator==(danni.substr(id,stope.size()),stope)){
            if(id+stope.size()>danni.size()){
                break;
            }
            if(danni[i]){
                u+='1';
            }else{
                u+='0';
            }
            id++;
        }
        if(id+stope.size()>danni.size()){
                break;
            }
        i=id;
        i+=stope.size();
        i--;
        while(!operator==(danni.substr(id,stope.size()),stope)){
            if(id+stope.size()>danni.size()){
                break;
            }
            if(danni[i]){
                v+='1';
            }else{
                v+='0';
            }
            id++;
        }
        i=id;
        i+=stope.size();
        i--;
        res.push_back({ch(u),ch(v)});
    }
    return res;
}


