#include<vector>
#include<iostream>
#include<map>
#include"cactus.h"

std::vector<bool>encode(int n, std::vector<std::pair<int,int>> edges){
    int sz = n*(n+1)/2;
    std::vector<bool>arr(sz,false);
    std::vector<std::vector<int>> cc(n);

    for(auto [u,v] : edges){
        if(u<v)
            cc[u].push_back(v);
        else
            cc[v].push_back(u);
    }
    int temp = n-1, idx = 0, id =0 ;
    while(temp >= 1){
        for(int next : cc[id])
            arr[idx + next - id - 1] = true;
        temp--;
        id++;
        idx += temp;
    }
    return arr;
}

std::vector<std::pair<int,int>> decode(int n, std::vector<bool> data){
    std::vector<std::pair<int,int>> edges;
    int idx = 0, temp = n-1, id=0;
    while(temp >= 1){
        for(int i=0; i<temp-1;i++,idx++){
            if(data[idx]){
                edges.push_back({id, id + i + 1 });
                edges.push_back({id+i + 1, id});
            }
        }

        temp--;
        id++;
        idx++;
    }

    return edges;
}
