#include<vector>
#include<algorithm>
#include<math.h>
#include"cactus.h"

static std::vector<std::vector<std::pair<int,int>>> ans;
static int cnt = 0;

std::vector<bool>encode(int n, std::vector<std::pair<int,int>> edges){
    if(cnt == 0){
        ans.push_back(edges);
        cnt++;
        return {0};
    }
    std::vector<bool> res;
    int temp = cnt;
    cnt++;
    while(temp >= 1){
        res.push_back(temp%2);
        temp/=2;
    }
    std::reverse(begin(res),end(res));
    ans.push_back(edges);
    return res;
}

std::vector<std::pair<int,int>> decode(int n, std::vector<bool> data){
    int br = std::pow(2,(int)data.size()-1);
    int num = 0;
    for(int i=0; i<data.size();i++)
        num +=(data[i] ? br : 0), br/=2;

    return ans[num];
}
