#include<vector>
#include"cactus.h"
using namespace std;

vector<bool>encode(int n, vector<pair<int,int>> edges){
    vector<bool> ans(n*n);
    for(auto &[v, u] : edges)
        ans[v+u+1] = true;
    return ans;
}

vector<pair<int,int>> decode(int n, vector<bool> data){
    vector<pair<int,int>> edges;
    for(int i=0; i<n;i++)
        for(int j=1; j<=n;j++)
            if(data[i+j])
                edges.push_back({i,j});
    return edges;
}
