#include<vector>
#include<iostream>
typedef long long ll;

const int maxn = 1+2e3, INF = 1e9;
std::vector<int> a;
int n, k;
ll dp[maxn + 1][maxn/2 + 1][2];

ll rec(int idx, int kb, bool fl){
    if(idx > n)
        return 0;

    if(dp[idx][kb][fl] == -INF){
        if(!fl){
            if(kb >= k)
                dp[idx][kb][fl] = 0;
            else{
                if(idx != 0)
                dp[idx][kb][fl] = rec(idx+1, kb+1, true) - a[idx];
                dp[idx][kb][fl] = std::max(dp[idx][kb][fl], rec(idx+1,kb,false));
            }
        }
        else{
            dp[idx][kb][fl] = rec(idx+1, kb,false) + a[idx];
            dp[idx][kb][fl] = std::max(dp[idx][kb][fl],rec(idx+1, kb,true));
        }
    }

    return dp[idx][kb][fl];
}

int main(){
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr),std::cout.tie(nullptr);

    std::cin >> n;

    a.resize(n+1);
    for(int i=1; i<=n;i++)
        std::cin >> a[i];

    for(k=1;k<=n;k++){
        for(int i=0; i<=n;i++)
            for(int j=0; j<=n;j++)
                for(int l=0; l<=n;l++)
            dp[i][j][l] = -INF;

        rec(0,0,0);
        std::cout << dp[0][0][0] << " ";
    }
    std::cout << '\n';
}
