#include "cactus.h"
#include<bits/stdc++.h>
using namespace std;

const int k = 14;
vector<int> haha[100001];
vector<bool> bruh(100001);
vector<bool> yay(100001);
vector<int> par1(100001);
vector<int> par2(100001);

void dfs(int a, int t) {
    bruh[a] = false;
    yay[a] = true;
    for(int v: haha[a]) {
        if(bruh[v]) {
            par1[v] = a;
            dfs(v,a);
        }
        else if(yay[v] && v != t) {
            par2[a] = v;
        }
    }
    yay[a] = false;
}

vector<bool> encode(int n, vector<pair<int,int>> edges) {
    for(int i = 0; i < n; i++) {
        haha[i].clear();
        bruh[i] = true;
        par1[i] = n;
        par2[i] = n;
        yay[i] = false;
    }
    for(int i = 0; i < edges.size(); i++) {
        int a = edges[i].first,b = edges[i].second;
        haha[a].push_back(b);
        haha[b].push_back(a);
    }
    dfs(0,-1);
    vector<bool> ans(0);
    for(int i = 1; i < n; i++) {
        for(int j = 0; j < k; j++) {
            ans.push_back((1 << j)&par1[i]);
        }
    }
    for(int i = 1; i < n; i++) {
        for(int j = 0; j < k; j++) {
            ans.push_back((1 << j)&par2[i]);
        }
    }
    return ans;
}

vector<pair<int,int>> decode(int n, vector<bool> data) {
    vector<pair<int,int>> ans(0);
    int y = 0;
    for(int i = 1; i < n; i++) {
        int a = 0;
        for(int j = y; j < y+k; j++) {
            a+=(1 << (j-y))*data[j];
        }
        if(a != n) {
            ans.push_back({i,a});
        }
        y+=k;
    }
    for(int i = 1; i < n; i++) {
        int a = 0;
        for(int j = y; j < y+k; j++) {
            a+=(1 << (j-y))*data[j];
        }
        if(a != n) {
            ans.push_back({i,a});
        }
        y+=k;
    }
    return ans;
}
