# include <iostream>
using namespace std;

const long long INF=1e18;
const int MAX=2e3+11;

long long n;
long long a[MAX];
long long dp[MAX][MAX];
long long mx[MAX][MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];

    for(int i=0;i<=n;i++)
    {
        for(int j=0;j<=n;j++)
        {
            dp[i][j]=-INF;
            mx[i][j]=-INF;
        }
    }

    for(int i=1;i<=n;i++)
    {
        mx[i][0]=-a[i];
        mx[i][0]=max(mx[i][0],mx[i-1][0]);
    }

    for(int j=1;j<=n/2;j++)
    {
        for(int i=j*2;i<=n;i++)
        {
            dp[i][j]=a[i]+mx[i-1][j-1];
            dp[i][j]=max(dp[i][j],dp[i-1][j]);
            //cout<<i<<" "<<j<<":"<<dp[i][j]<<"\n";

            mx[i][j]=max(mx[i][j],dp[i][j]-a[i]);

            //cout<<i<<" "<<j<<":"<<mx[i][j]<<"\n";
        }
    }

    long long ans=0;
    for(int j=1;j<=n;j++)
    {
        for(int i=j*2;i<=n;i++) ans=max(ans,dp[i][j]);
        cout<<ans<<" ";
    }
    cout<<"\n";

    return 0;
}

/*
5
5 4 3 2 1
*/
