#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;



std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector<bool> ans;
    const long long DAL=14;
    for(auto i:edges)
    {
            int x=i.second;
            for(int i=DAL-1;i>=0;i--)
            {
                ans.push_back(x/(1LL<<i));
                x%=(1LL<<i);
            }
            x=i.first;
            for(int i=DAL-1;i>=0;i--)
            {
                ans.push_back(x/(1LL<<i));
                x%=(1LL<<i);
            }
    }
    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<pair<int,int>> ans;
    const int DAL=14;
    for(int i=0;i<data.size();)
    {
        int x=0;
        for(int j=i;j<i+DAL;j++)
        {
            x+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        i+=DAL;
        int y=0;
        for(int j=i;j<i+DAL;j++)
        {
            y+=data[j]*(1LL<<(DAL-(j-i)-1));
        }
        i+=DAL;
        ans.push_back({x,y});
    }
    return ans;
}
