#define _GLIBCXX_FILESYSTEM
#include<bits/stdc++.h>
#include "cactus.h"
#define endl "\n"
#pragma GCC optimize("unroll-loops,O3,Ofast")
using namespace std;
typedef long long ll;
int n;
vector<int> g[100010];
vector<int> path;
unordered_set<ll> used;
void dfs(int u){
    path.push_back(u);
    for(auto v: g[u]){
        if(used.find(min(u,v)*n+max(u,v))!=used.end()) continue;
        used.insert(min(u,v)*n+max(u,v));
        dfs(v);
        path.push_back(u);
    }
}
void add(vector<bool> &v, int x){
    for(int i=0;i<14;i++){
        v.push_back(((x&(1<<i))>0));
    }
}
int get(vector<bool> &v, int k){
    int x = 0;
    for(int i=14*k+13;i>=14*k;i--){
        x *= 2;
        x += v[i];
    }
    return x;
}
vector<bool> encode(int N,vector<pair<int, int> > edges){
    n = N;
    for(int i=1;i<=n;i++){
        g[i].clear();
    }
    path.clear();
    used.clear();
    for(auto e: edges){
        e.first++;
        e.second++;
        g[e.first].push_back(e.second);
        g[e.second].push_back(e.first);
    }
    dfs(1);
    used.clear();
    vector<bool> rez;
    bool term = false;
    add(rez,path[0]);
    for(int i=1;i<path.size();i++){
        int u = min(path[i-1],path[i]);
        int v = max(path[i-1],path[i]);
        if(used.find(u*n+v)!=used.end()){
            if(!term){
                add(rez,0);
                term = true;
            }
        }
        else{
            if(term){
                add(rez,path[i-1]);
                term = false;
            }
            used.insert(u*n+v);
            add(rez,path[i]);
        }
    }
    return rez;
}

vector<pair<int, int> > decode(int n,vector<bool> data){
    vector<int> v;
    vector<pair<int,int> > rez;
    for(int i=0;i<data.size()/14;i++){
        v.push_back(get(data,i));
        if(i>0 && v[i]!=0 && v[i-1]!=0) rez.push_back({v[i]-1,v[i+1]-1});
    }
    return rez;
}
