# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 1e5 + 1;
const ll INF = 1e18;
int N;
ll P[MAXN];
ll dp[MAXN][2];
ll dpPrevious[MAXN][2];
ll dpNext[MAXN][2];
ll CONSTANT;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

ll MyMax(ll A, ll B)
{
    if(A >= B) return A;
    return B;
}

void Read()
{
    cin >> N;
    for(int i = 1; i <= N; i++) cin >> P[i];
    for(int i = 0; i <= N; i++)
    {
        dpPrevious[i][0] = -INF;
        dpPrevious[i][1] = -INF;
    }

    dpPrevious[0][0] = 0;
    ll Answer = 0;
    ll L = clock();
    ll R;

    for(int Limit = 1; Limit <= N; Limit++)
    {
        if(CONSTANT == 0)
        {
            for(int i = 1; i <= N; i++)
            {
                dpPrevious[0][0] = 0;
                dpPrevious[Limit - 1][0] = dpNext[i][0];
                dpPrevious[Limit - 1][1] = dpNext[i][1];

                for(int K = Limit; K <= Limit; K++)
                {
                    dp[K][0] = dpPrevious[K][0];
                    dp[K][1] = dpPrevious[K][1];
                    dp[K][0] = MyMax(dpPrevious[K][1] + P[i], dp[K][0]);
                    dp[K][1] = MyMax(dpPrevious[K - 1][0] - P[i], dp[K][1]);
                }

                for(int K = Limit; K <= Limit; K++)
                {
                    dpPrevious[K][0] = dp[K][0];
                    dpPrevious[K][1] = dp[K][1];
                }

                dpNext[i][0] = dp[Limit][0];
                dpNext[i][1] = dp[Limit][1];
                R = clock();
                if((R - L) / CLOCKS_PER_SEC >= 1e6)
                {
                    dp[Limit][0] = 0;
                    break;
                }
            }

            if(Answer >= dp[Limit][0])
            {
                CONSTANT = Limit;
            }


            Answer = MyMax(Answer, dp[Limit][0]);
        }

        cout << Answer << ' ';
    }


}

void Solve()
{

}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
