# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2001;
const ll INF = 1e18;
int N;
ll P[MAXN];
ll dp[MAXN][MAXN];
bool Visited[MAXN][MAXN];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;
    for(int i = 1; i <= N; i++) cin >> P[i];
}

ll F(int QN, int QK)
{
    if(QK <= 0) return 0;
    if(QN <= 0) return - 2 * INF;
    if(Visited[QN][QK]) return dp[QN][QK];
    dp[QN][QK] = -INF;
    Visited[QN][QK] = true;
    ll Max = P[QN];

    for(int i = QN - 1; i >= 1; i--)
    {
        Max = max(Max, P[i]);
        if(Max > P[i]) dp[QN][QK] = max(dp[QN][QK], F(i - 1, QK - 1) + Max - P[i]);
    }

    return dp[QN][QK];
}

void Solve()
{
    ll Answer = 0;
    for(int K = 1; K <= N; K++)
    {
        Answer = max(Answer, F(N, K));
        cout << Answer << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

