#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int MAXN = 3005;

long long n,pA,pB;


string s;
long long p0,p1;

long long step(long long a, long long b)
{
    long long res = 1;
    while(b > 0)
    {
        if(b%2) res = (res*a)%mod;

        b /= 2;
        a = (a*a)%mod;
    }
    return res;
}

long long fract(long long chis, long long znam)
{
    return (chis*step(znam,mod-2))%mod;
}



void read()
{
    cin >> n;
    cin >> pA >> pB;
    cin >> s;

    p0 = fract(pA,pB);
    p1 = fract(pB-pA,pB);
    //cout << p0 << " " << p1 << endl;
}


long long used[2*MAXN];

void solve()
{
    if(s[0]=='0')
    {
        used[0] = 1;
        used[1] = p1;
    }
    else
    {
        used[0] = 1;
        used[1] = p0;
    }

    int gr = n+1;

    for(long long i = 2; i <= gr; i++)
    {
        used[i] = used[i-1];
        if(i % n == 1) used[i] = (used[i]*p0)%mod;
    }


    long long ans = 0;
    for(int i = 0; i <= gr; i++)
    {
        ans = (ans + (used[i]*i)%mod)%mod;
    }
    cout << ans << endl;


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
