#include <iostream>

using namespace std;

const long long mod = 1e9 + 7;

int n;
long long p, q;
string s;

long long fastPower(long long a, long long b)
{
    long long curr = a, result = 1;

    for (int i = 0; i < 63; ++i)
    {
        if ((b & (1LL << i)) != 0)
        {
            result *= curr;
            result %= mod;
        }

        curr *= curr;
        curr %= mod;
    }

    return result;
}

long long E[3005];
long long pInv, qInv;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> p >> q;
    cin >> s;

    if (s[0] == '1')
    {
        p = q - p;
    }

    pInv = fastPower(p, mod - 2);
    qInv = fastPower(q, mod - 2);

    long long sum = 0;
    long long oth = 0;
    long long pq = (p * qInv) % mod;

    sum = 1 + mod - pq;
    sum %= mod;
    oth = (1 + mod - pq);
    oth %= mod;

    for (int i = 1; i <= n - 1; ++i)
    {
        sum += (((fastPower(pq, i) * (1 + mod - pq)) % mod) * (1LL * i)) % mod;
        sum %= mod;
        oth = oth + mod - (pq * (1 + mod - pq)) % mod;
        oth %= mod;
    }

    oth = (1 + mod - oth);
    oth %= mod;

    sum += ((1LL * n) * (fastPower(pq, n))) % mod;
    sum %= mod;

    cout << (sum * fastPower(oth, mod - 2)) % mod << endl;

    return 0;
}
