#include <bits/stdc++.h>
#include "cactus.h"

#define maxlog 14
#define maxn 16001
#define X first
#define Y second


typedef long long ll;
typedef std::pair <int, int> pii;


std::vector <bool> cc;
void get_bin(int num, std::vector <bool>& cc)
{
    for(int i = 0; i < maxlog; i++)
        if(num & (1 << i))
            cc.push_back(1);
        else
            cc.push_back(0);

    //std::cout << num << "\n";
    //for(auto e : cc)
    //std::cout <<e << " ";
    //std::cout << "\n";
}

int br = 0;
int get_des(int l, std::vector <bool>& cc)
{
    ll ans = 0;
    for(int i = 0; i < maxlog; i++)
        if(cc[i + l] == 1)
            ans += (1 << i);
    return ans;
}


std::vector <int> v[maxn];

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    random_shuffle(edges.begin() , edges.end());

    for(int i = 0; i < n; i++)
        v[i].clear();

    for(auto& e : edges)
        v[e.X].push_back(e.Y);
    /**for(int i = 0; i < n; i++)
    {
        std::cout << i << ": ";
        for(auto& e : v[i])
            std::cout << e << " ";
        std::cout << "\n";
    }*/

    std::vector <bool> ans;
    for(int i = 0; i < n; i++)
    {
        //get_bin((int)v[i].size(), ans);

        if(v[i].size() == 0)
        {
            ans.push_back(1);
            continue;
        }
        else
            ans.push_back(0);

        for(int j = 0; j < v[i].size(); j++)
        {
            get_bin(v[i][j], ans);
            if(j == v[i].size() - 1)
                ans.push_back(1);
            else
                ans.push_back(0);
        }
    }

    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{

    /**std::cout << "--------------------------" << "\n";

    for(int i = 0; i < data.size(); i++)
        std::cout << i << " " << data[i] << "\n";*/

    std::vector <pii> ans;

    int pos = -1;
    for(int i = 0; i < n; i++)
    {
        //std::cout << "in " << i << "\n";
        int bit = data[pos + 1];
        pos++;
        if(bit == 1)
            continue;

        bool lamp = true;
        while(lamp)
        {
            int x = i;
            int y = get_des(pos + 1 , data);
            pos += maxlog;

            ans.push_back({x , y});
            int bb = data[pos + 1];
            if(bb == 1)
                lamp = false;
            pos++;
        }
    }



    return ans;
}
