#include <bits/stdc++.h>
#include "cactus.h"

#define X first
#define Y second


typedef long long ll;
typedef std::pair <int , int> pii;


std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    std::vector <bool> ans(n * (n - 1) + n , 0);
    for(auto& e : edges)
        ans[e.X * n + e.Y] = 1;
    return ans;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    std::vector <pii> ans;
    for(int i = 0; i < data.size(); i++)
    {
        int currx = i / n;
        int curry = i - (currx * n);

        if(data[i] == 1)
        ans.push_back({currx , curry});
    }
    std::sort(ans.begin() , ans.end());

    return ans;
}
