#include <iostream>
#define maxn 10001

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops")
#pragma GCC target("avx2")


typedef long long ll;
typedef std::pair <int , int> pii;

ll dp[maxn][maxn];
int n , a[maxn];
ll pref[maxn];
ll ans[maxn];

void read()
{
    std::cin >> n;

    for(int i = 1; i <= n; i++)
        std::cin >> a[i];

    for(int k = 1; k <= n; k++)
    {
        ll maxx = -1e9;
        for(int i = 1; i <= n; i++)
        {
            if(i > 1)
            {
                dp[i][k] = a[i] + maxx;
                ans[k] = std::max(dp[i][k] , ans[k]);
            }
            maxx = std::max(maxx , -a[i] + pref[i - 1]);
        }

        pref[0] = 0;
        for(int i = 1; i <= n; i++)
            pref[i] = std::max(pref[i - 1] , dp[i][k]);
    }

    for(int i = 1; i <= n; i++)
        std::cout << ans[i] << " ";
    std::cout << "\n";
}



int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    read();

    return 0;

}
