#define _GLIBCXX_FILESYSTEM
#include "cactus.h"
#include <bits/stdc++.h>
using namespace std;

vector<bool> encode(int n, vector<pair<int, int>> v)
{
    int m = v.size();
    vector<bool> x;
    while (m > 0)
    {
        x.push_back(m % 2);
        m /= 2;
    }
    reverse(x.begin(), x.end());
    while (x.size() < 20)
        x.push_back(0);
    vector<bool> p;
    for (int i = 0; i < v.size(); i++)
    {
        p.clear();
        m = v[i].first;
        while (m > 0)
        {
            p.push_back(m % 2);
            m /= 2;
        }
        reverse(p.begin(), p.end());
        while (p.size() < 14)
            p.push_back(0);
        for (int j = 0; j < p.size(); j++)
            x.push_back(p[j]);
        p.clear();
        m = v[i].second;
        while (m > 0)
        {
            p.push_back(m % 2);
            m /= 2;
        }
        reverse(p.begin(), p.end());
        while (p.size() < 14)
            p.push_back(0);
        for (int j = 0; j < p.size(); j++)
            x.push_back(p[j]);
    }
    return x;
}

vector<pair<int, int>> decode(int n, vector<bool> b)
{
    vector<pair<int, int>> v;
    int m = 0;
    for (int i = 0; i <= 20; i++)
    {
        if (b[i])
            m += (1 << i);
    }
    int i1, i2, o;
    for (int i = 1; i <= m; i++)
    {
        i1 = o = 0;
        for (int j = 20 + (i - 1) * 14; j < 20 + i * 14; j++)
        {
            if (b[i] == 1)
                i1 += (1 << o);
            o++;
        }
        i2 = o = 0;
        for (int j = 20 + i * 14; j < 20 + (i + 1) * 14; j++)
        {
            if (b[i] == 1)
                i1 += (1 << o);
            o++;
        }
        v.push_back({i1, i2});
    }
    return v;
}
