#include <iostream>

#define ll long long

int n;
ll prices[1000000];
ll dp[5000][5000];
ll maxes[5000];

ll compute(ll pos, ll trades_left) {
    if (trades_left == 0) return 0;
    if (pos >= (n - 1)) return 0;
    if (dp[pos][trades_left] != -1) return dp[pos][trades_left];

    ll res = -1;

    for (int j = pos+1; j < n; j++) {
        ll min_price = 1000000000000;
        for (int i = pos; i < j; i++) min_price = std::min(min_price, prices[i]);
        res = std::max(res, compute(j+1, trades_left - 1) + prices[j] - min_price);
    }

    dp[pos][trades_left] = res;
    return res;
}

int main() {
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        std::cin >> prices[i];
        maxes[i] = -1;
    }

    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            dp[i][j] = -1;
        }
    }

    for (int i = 0; i <= n; i++) {
        maxes[i] = compute(0, i);
    }

    for (int i = 1; i <= n; i++) {
        maxes[i] = std::max(maxes[i - 1], maxes[i]);
    }

    for (int i = 1; i <= n; i++) {
        std::cout << maxes[i] << " ";
    }
}

