#include "cactus.h"
#include <bits/stdc++.h>
using namespace std;

bool matrix[16001][16001];
vector<bool> encode(const int n, vector<pair<int, int>> edges) {
    memset(matrix, 0, sizeof(matrix));
    vector<bool> ans;

    for (int i = 0; i < edges.size(); i ++) {
        int a = edges[i].first;
        int b = edges[i].second;
        if (a > b) swap(a, b);
        matrix[a][b] = true;
    }

    int cnt = 0;
    for (int i = 0; i < n; i ++) {
        for (int j = i + 1; j < n; j ++) {
            ans.push_back(matrix[i][j]);
            cnt ++;
        }
    }

    return ans;
}

vector<pair<int, int>> decode(int n, vector<bool> data) {
    vector<pair<int, int>> ans;


    int cnt = 0;
    for (int i = 0; i < n; i ++) {
        for (int j = i + 1; j < n; j ++) {
            if (cnt < data.size() && data[cnt]) ans.push_back({i, j});
            cnt ++;
        }
    }

    return ans;
}
