#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#define endl "\n"

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define int long long

const int MOD = 1e9 + 7;
const int INF = 1e9 + 50;

const int MAX_N = 5 * 1e5 + 10;

int n;
int a[MAX_N];
int ans[MAX_N];

void setAns (int s, int profit) {
    ans[s] = max(ans[s], profit);
}

void solve (int ind, int profit, int s, int currentPrice) {
    setAns(s, profit);
    if (ind == n - 1) {
        if (currentPrice != 0) {
            setAns(s + 1, profit + a[ind] - currentPrice);
        }
        return;
    }

    if (currentPrice > 0) {
        solve(ind + 1, profit, s, currentPrice);
        if (a[ind] > currentPrice && a[ind + 1] < a[ind]) solve(ind + 1, profit + a[ind] - currentPrice, s + 1, 0);
    } else {
        solve(ind + 1, profit, s, currentPrice);
        solve(ind + 1, profit, s, a[ind]);
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    cin >> n;

    for (int i = 0; i < n; i ++) {
        cin >> a[i];
    }

    solve(0, 0, 0, 0);

    int currentAns = 0;
    for (int i = 1; i <= n; i ++) {
        currentAns = max(currentAns, ans[i]);
        cout << currentAns << " ";
    }

    cout << endl;

    return 0;
}
