#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
const long long INF = 1e16;
const long long MOD = 1e9+7;
long long modmult(long long a, long long b){
    return ((a%MOD)*(b%MOD))%MOD;
}
long long fastpow(long long n, long long k){
    if(k==1){
        return n;
    }
    long long tmp = fastpow(n,k/2);
    if(k&1){
        return modmult(tmp,modmult(tmp,n));
    }
    else{
        return modmult(tmp,tmp);
    }
}
int main(){
    long long n; cin >> n;
    long long p,q; cin >> p >> q;
    string s; cin >> s;
    long long d = s.size();
    long long top = 1, bot = 1;
    for(int i=0; i<s.size(); i++){
        if(s[i]=='1'){
            top=modmult(top,q-p);
            bot = modmult(bot,fastpow(q,MOD-2));
        }
        else{
            top=modmult(top,p);
            bot = modmult(bot,q);
        }
    }
    cout << modmult(d,modmult(bot,top))<<endl;
}
