#include <bits/stdc++.h>
#include "cactus.h"
///#include "Lgrader2.cpp"

using namespace std;

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector <bool> ret;

    for (int i = 0; i < edges.size(); i++)
    {
        int u = edges[i].first, v = edges[i].second;

        if (u > v)
        {
            swap(u, v);
        }

        int h = n * u + v;
        vector <bool> f;

        ///cout << "YO: " << h << endl;

        while (h)
        {
            bool b = h % 2;

            f.push_back(b);
            h /= 2;
        }

        reverse(f.begin(), f.end());

        for (int q = 0; q < f.size(); q++)
        {
            ret.push_back(f[q]);
        }

        if (i == edges.size() - 1)
        {
            continue;
        }

        for (int q = 0; q < 40; q++)
        {
            ret.push_back(0);
        }
    }

    /**cout << "bool:"<< endl;

    for (int i = 0; i < ret.size(); i++)
    {
        cout << ret[i];
    }

    cout << endl;**/

    return ret;
}

bool check(int idx, int cnt, vector <bool> data)
{
    int br = 0;

    for (int i = idx; i < data.size(); i++)
    {
        if (data[i] == 0)
        {
            br++;
        }
        else
        {
            break;
        }
    }

    ///cout << "check: " << br << endl;

    return br == cnt;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector < pair <int, int> > ret;

    for (int i = 0; i < data.size(); i++)
    {
        int ptr = i;
        int h = 0;

        while (ptr + 1 < data.size() && !check(ptr + 1, 40, data))
        {
            ptr++;
        }

        for (int q = i; q <= ptr; q++)
        {
            h *= 2;

            if (data[q])
            {
                h++;
            }
        }

        ///cout << "h: " << h << endl;
        ///cout << "ptr: " << ptr << endl;

        pair <int, int> push;

        push.first = h / n;
        push.second = h - push.first * n;

        ret.push_back(push);

        i = ptr + 40;
    }

    return ret;
}