#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e4 + 10;
const ll INF = 4e18 + 10;

int n;
ll a[MAXN];

ll dp[MAXN][2];
ll ans[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}

void solve()
{
    priority_queue < int > pq;

    for(int j = 1; j <= n; j++)
    {
        for(int i = 1; i <= n; i++)
        {
            dp[i][j & 1] = dp[i - 1][j & 1];

            if(!pq.empty())
                dp[i][j & 1] = max(dp[i][j & 1], a[i] + pq.top());

            pq.push(dp[i][(j - 1) & 1] - a[i]);
        }
        ans[j] = dp[n][j & 1];

        while(!pq.empty())
            pq.pop();
    }

    for(int j = 1; j <= n; j++)
    {
        cout << ans[j] << " ";
    }
    cout << endl;
}

int main()
{
    read();
    solve();
    return 0;
}
