#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
//#include "cactus.h"
using namespace std;
const int MAXN = 1e5 + 3;
string bit(int x){
    string m = "";
    while(x > 0){
        if(x%2 == 1){
            m += '1';
        }else{
            m += '0';
        }
        x = x/2;
    }
    while(m.size() < 15){
        m += '0';
    }
    return m;
}
int _bit(string x){
    int stepen = 1;
    int chislo = 0;
    for(int i = 0; i < x.size(); i ++){
        if(x[i] == '1'){
            chislo += stepen;
        }
        stepen = stepen * 2;
    }
    return chislo;
}
vector <bool> encode(int n, vector<pair<int, int>> edges){
    vector <bool> otg;
    for(int i = 0; i < edges.size(); i ++){
        int x = edges[i].first;
        int y = edges[i].second;
        string a, b;
        a = bit(x);
        b = bit(y);
        for(int i = 0; i < a.size(); i ++){
            if(a[i] == '0'){
                otg.push_back(false);
            }else{
                otg.push_back(true);
            }
        }
        for(int i = 0; i < b.size(); i ++){
            if(b[i] == '0'){
                otg.push_back(false);
            }else{
                otg.push_back(true);
            }
        }
    }

    return otg;
}
vector<pair<int, int>> decode(int n, vector<bool> data){
    vector <pair <int, int>> graf;
    int m = graf.size()/15;
    for(int i = 0; i < m; i += 2){
        string a = "", b = "";
        for(int j = 15 * i; j < 15 * (i + 1); j ++){
            if(data[j] == false){
                a += '0';
            }else{
                a += '1';
            }
        }
        for(int j = 15 * (i + 1); j < 15 * (i + 2); j ++){
            if(data[j] == false){
                b += '0';
            }else{
                b += '1';
            }
        }
        int x = _bit(a);
        int y = _bit(b);
        graf.push_back({x, y});
    }
    return graf;
}


