#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define endl "\n"
#define ll long long
using namespace std;
const ll MAXN = 2002;
ll arr[MAXN];
ll N;
vector <pair <ll, ll>> llervali;
vector <pair <ll, ll>> freellervali;
pair <ll, pair <ll, ll> > calc(ll l, ll r){
    ll raz = 0, l1 = 0, r1 = 0;
    for(ll i = l; i <= r; i ++){
        for(ll j = i; j <= r; j ++){
            if(arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]) > raz){
                l1 = i; r1 = j;
                raz = arr[i] - arr[l] + arr[r] - arr[j] - (arr[r] - arr[l]);
            }
        }
    }
    return {raz, {l1, r1}};

}
pair <ll, pair <ll, ll>> maxFree(ll l, ll r){
    ll max1 = 0, l1 = 0, r1 = 0;
    for(ll i = l; i <= r; i ++){
        for(ll j = i + 1; j <= r; j ++){
            if(arr[j] - arr[i] > max1){
                l1 = i; r1 = j;
                max1 = arr[j] - arr[i];
            }
        }
    }
    return {max1, {l1, r1}};

}
int main (){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> N;
    for(ll i = 0; i < N; i ++){
        cin >> arr[i];
    }
    ll l = 0, r = 0;
    for(ll i = 0; i < N; i ++){
        for(ll j = i; j < N; j ++){
            if(arr[j] - arr[i] > arr[r] - arr[l]){
                l = i; r = j;
            }
        }
    }
    llervali.push_back({l, r});
    freellervali.push_back({0, l});
    freellervali.push_back({r, N - 1});
    ll sum = arr[r] - arr[l];
    cout << arr[r] - arr[l] << " ";
    for(ll i = 2; i <= N; i ++){
        ll x = llervali.size();
        ll y = freellervali.size();
        ll flag = 0;
        ///cout << i << ": " << endl << endl;
        ll maxL = 0, maxR = 0, maxJ = 0, maxRaz = 0;
        for(ll j = 0; j < x; j ++){
            ll l1, r1, raz;
            ///cout << llervali[j].first << " " << llervali[j].second << endl;
            pair <ll, pair <ll, ll> > tek = calc(llervali[j].first, llervali[j].second);
            raz = tek.first;
            l1 = tek.second.first;
            r1 = tek.second.second;
            ///cout << raz << " " << l1 << " " << r1 << " " << maxRaz << endl;
            if(raz > maxRaz){
                maxRaz = raz;
                maxL = l1; maxR = r1; maxJ = j;
                flag = 1;
            }
        }
        for(ll j = 0; j < y; j ++){
            pair <ll, pair <ll, ll> > tek = maxFree(freellervali[j].first, freellervali[j].second);
            ll l1, r1, raz;
            raz = tek.first;
            l1 = tek.second.first;
            r1 = tek.second.second;
            if(raz > maxRaz){
                maxL = l1;
                maxR = r1;
                maxRaz = raz;
                flag = 2;
                maxJ = j;
            }
        }
        if(maxRaz > 0){
            if(flag == 1){
                llervali.push_back({maxR, llervali[maxJ].second});
                llervali[maxJ].second = maxL;
                sum = sum + maxRaz;
                freellervali.push_back({maxL, maxR});
            }
            if(flag == 2){
                sum = sum + maxRaz;
                freellervali.push_back({maxR, freellervali[maxJ].second});
                freellervali[maxJ].second = maxL;
                llervali.push_back({maxL, maxR});
            }
        }
        cout << sum << " ";

    }
    return 0;
}
/**
10
90 10 30 20 40 35 30 50 40 70
*/


