#include <vector>
#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

vector<bool> two_nums_to_bool(int a, int b){
    unsigned long long num = (((1 << 15) + a) << 14) + b;
    vector<bool> cur;
    for(int i = 28; i > 0; --i){
        cur.push_back(num % 2);
        num >>= 1;
    }
    return cur;
}

vector<bool> num_to_bool(int a){
    if(a >= (1 << 14)){
        cout << "STUPID";
    }else{
        vector<bool> cur;
        for(int i = 14; i > 0; --i){
            cur.push_back(a % 2);
            a >>= 1;
        }
        return cur;
    }
}

vector<bool> encode(int n, vector<pair<int, int>> edges){
    unordered_set<int> a;
    for(auto edge : edges){
        a.insert(edge.first);
        a.insert(edge.second);
    }
    if(a.size() != n) cout << "A";
    /*vector<int> adj_list[n];
    for(auto edge : edges){
        int u = edge.first, v = edge.second;
        adj_list[u].push_back(v);
        adj_list[v].push_back(u);
    }

    vector<bool> visited(n, false);
    queue<int> to_visit;
    to_visit.push(0);
    while(!to_visit.empty()){
        int u = to_visit.front();
        to_visit.pop();
        if(visited[u]){
            cout << "CYCLE";
        }else{
            visited[u] = true;
            for(int v : adj_list[u]){
                to_visit.push(v);
            }
        }
    }*/

    vector<bool> ans;

    return ans;
}

pair<int, int> bool_to_two_nums(vector<bool> b){
    if(b.size() == 14 * 2){
        pair<int, int> ans = {0, 0};
        for(int i = 0; i < 14; ++i){
            ans.second = (ans.second << 1) + b[b.size() - 1];
            b.pop_back();
        }
        for(int i = 0; i < 14; ++i){
            ans.first = (ans.first << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }else{
        cout << "STUPID";
    }
}

int bool_to_num(vector<bool> b){
    if(b.size() == 14){
        int ans = 0;
        for(int i = 0; i < 14; ++i){
            ans = (ans << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    //cout << "DECODE\n";
    vector<pair<int, int>> ans;
    vector<int> adj_list[n];
    vector<bool> cur;
    for(int i = 0; i < data.size(); ){
        cur.push_back(data[i]);
        if(cur.size() == 14 * 2){
            pair<int, int> vertex_data = bool_to_two_nums(cur);
            //cout << "u: " << vertex_data.first << " size(" << vertex_data.second << "): ";
            cur.clear();
            i++;
            for(int k = 0; k < vertex_data.second; ++k){
                for(int j = i; j < i + 14; ++j){
                    cur.push_back(data[j]);
                }
                adj_list[vertex_data.first].push_back(bool_to_num(cur));
                //cout << adj_list[vertex_data.first][adj_list[vertex_data.first].size() - 1] << " ";
                cur.clear();
                i += 14;
            }
            //cout << endl;
        }else{
            ++i;
        }
    }
    for(int u = 0; u < n; ++u){
        for(int v : adj_list[u]){
            ans.push_back({u, v});
        }
    }
    return ans;
}
