#include <vector>
#include <iostream>

using namespace std;

vector<bool> encode(int n, vector<pair<int, int>> edges){
    vector<bool> ans;
    for(auto edge : edges){
        unsigned long long num = (((1 << 15) + edge.first) << 14) + edge.second;
        vector<bool> cur;
        for(int i = 29; i > 0; --i){
            cur.push_back(num % 2);
            num >>= 1;
        }
        for(bool a : cur){
            ans.push_back(a);
        }
    }
    return ans;
}


std::vector<std::pair<int, int>> decode(int n, vector<bool> data){
    vector<pair<int, int>> ans;
    vector<bool> cur;
    for(bool a : data){
        cur.push_back(a);
        if(cur.size() == 14 * 2){
            for(bool b : cur){ cout << b; } cout << endl;
            pair<int, int> edge = {0, 0};
            for(int i = 0; i < 14; ++i){
                edge.second = (edge.second << 1) + cur[cur.size() - 1];
                cur.pop_back();
            }
            for(int i = 0; i < 14; ++i){
                edge.first = (edge.first << 1) + cur[cur.size() - 1];
                cur.pop_back();
            }
            ans.push_back(edge);
        }
    }

    return ans;
}
