#include<iostream>
#include<vector>
#include<unordered_map>
using namespace std;

const int MAX_N = 5e5;
const long long MOD = 1e5;

int n, p[MAX_N], f = 0;
vector<int> deals[MAX_N];

unordered_map<long long, long long> cache;
// [l, r]
pair<int, int> find_best_deal(int l, int r){
    return {l, r};
    long long key = l * 1e5 + r;
    if(cache.find(key) != cache.end()){
        long long A = cache[key];
        //cout << A / MOD << " " << A % MOD << endl;
        return {A / MOD, A % MOD};
    }
    pair<int, int> ans = {-1, -1};
    int best = 0;
    for(int i = l; i < r; ++i){
        for(int j = i + 1; j <= r; ++j){
            if(p[j] - p[i] > best){
                best = p[j] - p[i];
                ans = {i, j};
            }
        }
    }
    cache[key] = ans.first * MOD + ans.second;
    return ans;
}


// [start, n - 1]
long long subsets(int start, int remaining){
    remaining = min(remaining, (n - start) / 2);
    long long ans = 0;
    if(start >= n){
        f++;
        return 0;
    }
    if(remaining <= 0){
        f++;
        return 0;
    }
    for(int i = start + 1; i < n; ++i){
        auto a = find_best_deal(start, i);
        if(a.second != i) continue;
        ans = max(ans, p[a.second] - p[a.first] + subsets(i + 1, remaining - 1));
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> p[i];
    }
    /*p[0] = 2;
    for(int i = 1; i < n; ++i){
        p[i] = (p[i - 1] * i) % (int)(1e9 + 7);
    }*/

    for(int k = 1; k <= n; ++k){
        cout << subsets(0, k) << " "/* << k << " " << f << "\n"*/;
    }
    return 0;
}
