#include <bits/stdc++.h>
#define ll long long
#include "cactus.h"
using namespace std;
const int maxn = 1e5 + 5;

bool cmp(pair<int,int> a, pair<int,int> b)
{
    if(a.first == b.first)return a.second > b.second;
    return a.first > b.first;
}
vector<vector<int>> par;

vector<bool> encode(int n, vector<pair<int,int>> edges)
{
    vector<bool> res;

    for(int i = 0; i < edges.size(); i++)
    {
        int x = edges[i].first;
        int y = edges[i].second;
        if(x != 0 && y != 0)
        {
            par[min(x, y)].push_back(max(x, y));
        }
        else if(x == 0)
        {
            par[y].push_back(0);
        }
        else if(y == 0)
        {
            par[x].push_back(0);
        }
    }

    for(int i = 0; i < n; i++)
    {
        //par[i] ..
        int lastj = 0;
        for(auto &x : par[i])
        {
            if(latj < x)
            {
                lastj = x;
                for(int j = lastj+1; j < x; j++)
                {
                    res.push_back(0);
                }
                res.push_back(1);
            }
        }
    }

    return res;
}

vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int, int>> res;
    int lasti = 0, lastj = 0;
    for(int i = 0; i < data.size(); i++)
    {
        if(data[i] == 1)
        {
            if(lastj == n-1)
            {
                lasti++;
                lastj = lasti+1;
            }
            else lastj++;
            res.push_back({lasti, lastj});
        }
        else
        {
            if(lastj == n-1)
            {
                lasti++;
                lastj = lasti+1;
            }
            else lastj++;
        }
    }
    return res;
}
