#include <bits/stdc++.h>
#define ll long long
#include "cactus.h"
using namespace std;
const int maxn = 1e5 + 5;

bool cmp(pair<int,int> a, pair<int,int> b)
{
    if(a.first == b.first)return a.second < b.second;
    return a.first < b.first;
}
vector<bool> encode(int n, vector<pair<int,int>> edges)
{
    vector<bool> res;
    sort(edges.begin(), edges.end());
    //reverse(edges.begin(), edges.end());
    for(int i = 0; i < n; i++)
    {
        for(int j = i+1; j < n; j++)
        {
            bool ok = false;
            for(int k = 0; k < edges.size() - j; k++)
            {
                if(edges[k].first == i && edges[k].second == j)
                {
                    ok = true;
                }
            }
            if(ok == true)res.push_back(1);
            else res.push_back(0);
        }
    }
    return res;
}

vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int, int>> res;
    int lasti = 0, lastj = 0;
    for(int i = 0; i < data.size(); i++)
    {
        if(data[i] == 1)
        {
            if(lastj == n-1)
            {
                lasti++;
                lastj = lasti+1;
            }
            else lastj++;
            res.push_back({lasti, lastj});
        }
        else
        {
            if(lastj == n-1)
            {
                lasti++;
                lastj = lasti+1;
            }
            else lastj++;
        }
    }
    return res;
}
