#include<vector>
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){
    std::vector<bool> code;
    code.resize(n * (n - 1) / 2 + 1);
    for(int k = 0; k < edges.size(); k++){
        long long indeks = 0;
        int i = edges[k].first;
        int j = edges[k].second;
        if(i > j){
            std::swap(i, j);
        }
        indeks = i * n - i * (i + 3) / 2 + j - 1;
        code[indeks] = 1;
    }
    return code;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    std::vector<std::pair<int, int>> code;
    for(int i = 0; i < n * (n - 1) / 2; i++){
        if(data[i] != 0){
            int kop = i + 1;
            int ind = 1;
            while(kop - (n - ind) > 0){
                kop -= n - ind;
                ind++;
            }
            if(kop == n - ind){
                code.push_back({ind - 1, n - 1});
            }else{
                code.push_back({ind - 1, ind - 1 + kop});
            }

        }
    }
    return code;
}
